Package: cpfa
Type: Package
Title: Classification with Parallel Factor Analysis
Version: 1.3.1
Date: 2026-07-13
Authors@R: person(given = c("Matthew", "A."), family = "Asisgress", 
                  email = "mattgress@protonmail.ch", role = c("aut", "cre"), 
                  comment = c(ORCID = "0000-0001-7294-3348"))
Maintainer: Matthew A. Asisgress <mattgress@protonmail.ch>
Depends: R (>= 4.3.0), multiway
Imports: glmnet, e1071, randomForest, nnet, rda, xgboost, foreach,
        doParallel, doRNG, clue
Suggests: knitr, rmarkdown
Description: Classification using Richard A. Harshman's Parallel Factor 
    Analysis-1 (Parafac) model or Parallel Factor Analysis-2 (Parafac2) model fit to 
    a three-way or four-way data array. See Harshman and Lundy (1994): 
    <doi:10.1016/0167-9473(94)90132-5>. Classification using principal component 
    analysis (PCA) fit to a two-way data matrix is also supported. Uses component 
    weights from one mode of a Parafac, Parafac2, or PCA model as features to tune 
    parameters for one or more classification methods via a k-fold cross-validation 
    procedure. Allows for constraints on different tensor modes. Allows for 
    inclusion of additional features alongside features generated by the component 
    model. Supports penalized logistic regression, support vector machine, random 
    forest, feed-forward neural network, regularized discriminant analysis, and 
    gradient boosting machine. Supports binary and multiclass classification. 
    Predicts class labels or class probabilities and calculates multiple 
    classification performance measures. Uses the 'clue' package to align Parafac 
    or Parafac2 models across data splits in the cross-validation procedure. 
    Calculates classification importance of individual features using permutation 
    feature importance. Implements parallel computing via the 'foreach', 
    'doParallel', and 'doRNG' packages.
BugReports: https://github.com/matthewasisgress/cpfa/issues
License: GPL (>= 2)
URL: https://github.com/matthewasisgress/cpfa
VignetteBuilder: knitr, rmarkdown
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2026-07-13 00:03:09 UTC; nr2
Author: Matthew A. Asisgress [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-7294-3348>)
Repository: CRAN
Date/Publication: 2026-07-13 05:10:08 UTC
Built: R 4.6.1; ; 2026-07-13 09:32:08 UTC; unix

exportPattern("^[[:alpha:]]+")

import(multiway)
import(glmnet)
import(e1071)
import(randomForest)
import(nnet)
import(rda)
import(xgboost)
import(doParallel)
import(doRNG)
import(clue)

S3method(print, tunecpfa)
S3method(predict, tunecpfa)

importFrom(stats, "na.omit", "predict", "model.matrix", "var", "formula", "cor", "varimax", "sd")
importFrom(stats, "rbinom", "rexp", "rgamma", "rbeta", "rnorm", "rpois")
importFrom(stats, "runif", "rgeom", "rnbinom", "rhyper", "rlnorm", "rcauchy")
importFrom(stats, "dnorm", "qlogis", "qnorm", "quantile", "median")
importFrom(utils, "combn")
importFrom("graphics", "axis", "image", "layout", "mtext", "par", "boxplot", "box", "text")
importFrom(parallel, "makeCluster", "detectCores", "clusterEvalQ", "stopCluster", "clusterSetRNGStream")
importFrom("grDevices", "colorRampPalette", "devAskNewPage")
importFrom(foreach, "%do%", "%dopar%", "foreach")

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  cache     = FALSE,
  warning   = FALSE,
  message   = FALSE,
  seed      = 500
)

## ----message = FALSE----------------------------------------------------------
library(cpfa)

## ----message = FALSE, warning = FALSE-----------------------------------------
# set seed for reproducibility
set.seed(500)

# specify correlation
cp <- 0.1

# define target correlation matrix for columns of fourth mode weight matrix
corrpred <- matrix(c(1, cp, cp, cp, 1, cp, cp, cp, 1), nrow = 3, ncol = 3)

# define correlations between fourth mode weight matrix and response vector
corresp <- rep(.85, 3)

# specify number of rows in the three-way array for each level of fourth mode
pf2num <- rep(c(7, 8, 9), length.out = 100)

# simulate a four-way ragged array connected to a response
data <- simcpfa(arraydim = c(10, 11, 12, 100), model = "parafac2", nfac = 3, 
                nclass = 3, nreps = 10, onreps = 10, corresp = corresp,
                pf2num = pf2num, modes = 4, corrpred = corrpred, 
                meanpred = c(10, 20, 30), smethod = "logistic")

# define simulated array 'X' and response vector 'y' from the output
X <- data$X
y <- data$y

## -----------------------------------------------------------------------------
# examine data object X
class(X)
length(X)
dim(X[[1]])
dim(X[[2]])

# examine data object y
class(y)
length(y)
table(y)

## -----------------------------------------------------------------------------
# examine correlations between columns of fourth mode weights 'Dmat' and 
# simulated response vector 'y'
cor(data$Dmat, (as.numeric(data$y) - 1))

## -----------------------------------------------------------------------------
# set seed
set.seed(500)

# initialize alpha and store within a list called 'parameters'
alpha <- seq(0, 1, length.out = 11)
parameters <- list(alpha = alpha)

# initialize inputs
method <- "PLR"
model <- "parafac2"
nfolds <- 3
nstart <- 3
nfac <- c(2, 3)
family <- "multinomial"
nrep <- 3
ratio <- 0.9
const <- c("uncons", "uncons", "uncons", "nonneg")

# implement train-test splits with inner k-fold CV to optimize classification
output <- cpfa(x = X, y = y, model = model, nfac = nfac, 
               nrep = nrep, ratio = ratio, nfolds = nfolds, method = method, 
               family = family, parameters = parameters, plot.out = FALSE, 
               parallel = FALSE, const = const, nstart = nstart, 
               verbose = FALSE, align = TRUE)

## -----------------------------------------------------------------------------
# examine classification performance measures - median across train-test splits
output$descriptive$median[, 1:2]

## -----------------------------------------------------------------------------
# examine optimal tuning parameters averaged across train-test splits
output$mean.opt.tune

## ----eval = FALSE-------------------------------------------------------------
# # set seed
# set.seed(500)
# 
# # plot heat maps of component weights for optimal model
# results <- plotcpfa(output, nstart = 3, ctol = 1e-1, verbose = FALSE)

## -----------------------------------------------------------------------------

# set seed
set.seed(500)

# calculate permutation feature importance for each feature
pfistats <- pficpfa(object = output, nshuffles = 5, type = "marginal")

# examine median pfi for classification accuracy and for nfac = 2
pfistats[which((pfistats$nfac == 2) & (pfistats$metric == "acc")), ]


## -----------------------------------------------------------------------------

# set seed
set.seed(500)

# calculate permutation feature importance for each feature
pfistats <- pficpfa(object = output, nshuffles = 5, type = "conditional",
                    conditional.model = "rf")

# examine median pfi for classification accuracy and for nfac = 2
pfistats[which((pfistats$nfac == 2) & (pfistats$metric == "acc")), ]



## ----message = FALSE, warning = FALSE-----------------------------------------
# set seed for reproducibility
set.seed(400)

# specify correlation
cp <- 0.1

# define target correlation matrix for columns of third mode weight matrix
corrpred <- matrix(c(1, cp, cp, 1), nrow = 2, ncol = 2)

# define correlations between third mode weight matrix and response vector
corresp <- rep(.9, 2)

# simulate a three-way array connected to a binary response
data <- simcpfa(arraydim = c(10, 11, 100), model = "parafac", nfac = 2, 
                nclass = 2, nreps = 10, onreps = 10, corresp = corresp,
                modes = 3, corrpred = corrpred, meanpred = c(10, 20), 
                smethod = "logistic")

# define simulated array 'X' and response vector 'y' from the output
X <- data$X
y <- data$y

## -----------------------------------------------------------------------------
# examine data object X
class(X)
dim(X)

# examine data object y
class(y)
length(y)
table(y)

## -----------------------------------------------------------------------------
# examine correlations between columns of third mode weights 'Cmat' and 
# simulated response vector 'y'
cor(data$Cmat, (as.numeric(data$y) - 1))

## -----------------------------------------------------------------------------
# set seed
set.seed(300)

# initialize tuning parameters and store within a list called 'parameters'
alpha <- seq(0, 1, length.out = 3)
ntree <- c(200, 400)
nodesize <- c(2, 4)
parameters <- list(alpha = alpha, ntree = ntree, nodesize = nodesize)

# initialize inputs
method <- c("PLR", "RF")
model <- "parafac"
nfolds <- 3
nstart <- 3
nfac <- c(2, 3)
family <- "binomial"
nrep <- 3
ratio <- 0.9
const <- c("uncons", "orthog", "uncons")

# implement train-test splits with inner k-fold CV to optimize classification
output <- cpfa(x = X, y = y, model = "parafac", nfac = nfac, 
               nrep = nrep, ratio = ratio, nfolds = nfolds, method = method, 
               family = family, parameters = parameters, plot.out = FALSE, 
               parallel = FALSE, const = const, nstart = nstart, 
               verbose = FALSE)

## -----------------------------------------------------------------------------
# examine classification performance measures - mean across train-test splits
output$descriptive$mean[, 1:2]

## -----------------------------------------------------------------------------
# examine optimal tuning parameters averaged across train-test splits
output$mean.opt.tune

## ----eval = FALSE-------------------------------------------------------------
# # set seed
# set.seed(400)
# 
# # plot heat maps of component weights for optimal model
# results <- plotcpfa(output, nstart = 3, ctol = 1e-1, verbose = FALSE)

## ----message = FALSE, warning = FALSE-----------------------------------------
# set seed for reproducibility
set.seed(400)

# specify correlation
cp <- 0.1

# define target correlation matrix for columns of first mode weight matrix
a <- matrix(cp, nrow = 3, ncol = 3); diag(a) <- 1; corrpred <- a

# define correlations between first mode weight matrix and response vector
corresp <- rep(.5, 3)

# simulate a two-way matrix connected to a multiclass response
data <- simcpfa(arraydim = c(200, 10), model = "pca", nfac = 3, 
                nclass = 3, corresp = corresp, modes = 2, corrpred = corrpred, 
                smethod = "eigende")

# define simulated matrix 'X' and response vector 'y' from the output
X <- data$X
y <- data$y

## -----------------------------------------------------------------------------
# examine data object X
class(X)
dim(X)

# examine data object y
class(y)
length(y)
table(y)

## -----------------------------------------------------------------------------
# examine correlations between columns of first mode weights 'Bmat' and 
# simulated response vector 'y'
cor(data$Bmat, (as.numeric(data$y) - 1))

## -----------------------------------------------------------------------------
# set seed
set.seed(300)

# initialize tuning parameters and store within a list called 'parameters'
alpha <- seq(0, 1, length.out = 5)
parameters <- list(alpha = alpha)

# initialize inputs
method <- c("PLR")
model <- "pca"
nfolds <- 3
nfac <- c(2, 3)
family <- "multinomial"
nrep <- 3
ratio <- 0.9

# implement train-test splits with inner k-fold CV to optimize classification
output <- cpfa(x = X, y = y, model = model, nfac = nfac, 
               nrep = nrep, ratio = ratio, nfolds = nfolds, method = method, 
               family = family, parameters = parameters, plot.out = FALSE, 
               parallel = FALSE, verbose = FALSE, pcarot = "varimax")

## -----------------------------------------------------------------------------
# examine classification performance measures - mean across train-test splits
output$descriptive$mean[, 1:2]

## -----------------------------------------------------------------------------
# examine optimal tuning parameters averaged across train-test splits
output$mean.opt.tune

## ----eval = FALSE-------------------------------------------------------------
# # set seed
# set.seed(400)
# 
# # plot heat maps of component weights for optimal model
# results <- plotcpfa(output)

print.tunecpfa <-
  function(x, ...)
{
    if (!(inherits(x, "tunecpfa"))) {
      stop("Input 'x' must be of class 'tunecpfa'.")
    }
    kcv.error <- x$kcv.error; est.time <- x$est.time
    method <- x$method; nfac <- x$opt.param$nfac
    nway <- x$lxdim; model <- x$model
    consts0 <- x$const; zout <- x$z
    if (!(is.null(zout))) {ncovari <- dim(zout)[2]}
    consts <- paste(consts0, collapse = "-")
    method.char <- NULL
    mname <- c("PLR", "SVM", "RF", "NN", "RDA", "GBM")
    nus <- as.character(1:6)
    for (hh in 1:length(nus)) {
       if (nus[hh] %in% method) {method.char <- c(method.char, mname[hh])}
    }
    cat(paste0("Component Models Fit:"))
    cat(paste0("\n", nway, "-way ", toupper(model), " with ", nfac, 
               " component(s)", " and constraint(s): ", consts), "\n")
    cat(paste0("\n", "Classification Methods Tuned:"))
    cat(paste0("\n", method.char), "\n")
    if (!(is.null(zout))) {
      cat(paste0("\n", "Number of Additional Features Included:"))
      cat(paste0("\n", ncovari), "\n")
    }
    cat(paste0("\n", "KCV Misclassification Error (est. time in seconds) \n 
               by Model and Method:"), "\n")
    for (w in seq_along(nfac)) {
       cnfac <- nfac[w]
       cerror <- kcv.error[which(nfac == cnfac), ]
       ctime <- est.time[which(nfac == cnfac), ]
       cat(paste0("\n", toupper(model), " with ", cnfac, " component(s):"), 
           "\n")
       for (hh in 1:length(nus)) {
          if (nus[hh] %in% method) {
            colzname <- paste0("error.", tolower(mname[hh]))
            error <- round(cerror[[colzname]], 4)
            colznametime <- paste0("time.", tolower(mname[hh]))
            time <- round(ctime[[colznametime]], 4)
            cat(paste0("  ", mname[hh], ":"))
            cat(paste0("  ", "Error = ", error, " (", time, ")\n"))
          }
       }
    }
    invisible(x)
}

kcv.svm <-
  function(x, y, foldid, svm.grid, nfolds = NULL, scale = TRUE, 
           kernel = "radial", degree = 3, coef0 = 0, nu = 0.5,
           class.weights = NULL, cachesize = 40, tolerance = 0.001,
           shrinking = TRUE, cross = 0, probability = TRUE, fitted = TRUE,
           na.action = na.omit, parallel = FALSE) 
{
    kcvcheck(y = y, nfolds = nfolds, parallel = parallel, foldid = foldid)
    grid.row <- nrow(svm.grid)
    cv.svm <- matrix(rep(0, grid.row * nfolds), ncol = nfolds)
    if (parallel == TRUE) {
      cv.svm <- foreach (gg = 1:nfolds, .combine = cbind, 
                         .packages = 'e1071') %dorng% {
                         x.train <- as.matrix(x[which(foldid != gg), ])
                         y.train <- y[which(foldid != gg)]
                         x.test <- as.matrix(x[which(foldid == gg), ])
                         y.test <- y[which(foldid == gg)]
                         stortune <- matrix(rep(0, grid.row), ncol = 1)
                         for (yy in 1:grid.row) {
                            svm.fit <- svm(x.train, y.train, 
                                           gamma = svm.grid[yy, 1], 
                                           coef0 = coef0, 
                                           cost = svm.grid[yy, 2], nu = nu, 
                                           class.weights = class.weights,
                                           cachesize = cachesize, 
                                           tolerance = tolerance, scale = scale,
                                           kernel = kernel, degree = degree,
                                           shrinking = shrinking, cross = cross,
                                           probability = probability, 
                                           fitted = fitted, 
                                           na.action = na.action)
                           svm.pred <- predict(svm.fit, x.test, 
                                               type = 'response')
                           stortune[yy, 1] <- 1 - mean(svm.pred == y.test) 
                         }
                         cv.svm[, gg] <- stortune
                }
    } else {
      for (gg in 1:nfolds) {
         x.train <- as.matrix(x[which(foldid != gg), ])
         y.train <- y[which(foldid != gg)]
         x.test <- as.matrix(x[which(foldid == gg), ])
         y.test <- y[which(foldid == gg)]
         stortune <- matrix(rep(0, grid.row), ncol = 1)
         for (yy in 1:grid.row) {
            svm.fit <- svm(x.train, y.train, gamma = svm.grid[yy, 1],
                           coef0 = coef0, cost = svm.grid[yy, 2], nu = nu,
                           class.weights = class.weights, cachesize = cachesize,
                           tolerance = tolerance, shrinking = shrinking,
                           cross = cross, probability = probability,
                           kernel = kernel, degree = degree, scale = scale,
                           fitted = fitted, na.action = na.action)
            svm.pred <- predict(svm.fit, x.test, type = 'response')
            stortune[yy, 1] <- 1 - mean(svm.pred == y.test) 
         }
         cv.svm[, gg] <- stortune
      }
    }
    svm.mean <- apply(cv.svm, 1, mean)
    minid <- which.min(svm.mean)
    svm.fit.best <- svm(x, y, gamma = svm.grid[minid, 1], coef0 = coef0,
                        cost = svm.grid[minid, 2], nu = nu, 
                        class.weights = class.weights, cachesize = cachesize,
                        tolerance = tolerance, shrinking = shrinking,
                        cross = cross, probability = probability, 
                        kernel = kernel, degree = degree, scale = scale,
                        fitted = fitted, na.action = na.action)
    return(list(svm.grid.id = minid, svm.fit = svm.fit.best,
                error = svm.mean[minid]))
}  

kcvcheck <-
  function(y, nfolds, parallel, foldid) 
{
    if (!(is.factor(y))) {y <- factor(y)}
    if (length(unique(y)) == 1L) {
      stop("Input 'y' must contain some variation (i.e., cannot contain only \n
           a single type of label).")
    }
    if (is.null(nfolds)) {
      nfolds <- 10
    } else {
      numcheck(nfolds)
      if ((nfolds %% 1) != 0) {stop("Input 'nfolds' must be an integer.")}
      if ((nfolds < 2) || (nfolds > length(y))) {
        stop("Input 'nfolds' must be an integer between 2 and the \n
             number of observations, inclusive. In addition, the \n
             number of observations cannot be less than 'nfolds'.")
      }
    }
    if (is.null(parallel)) {
      parallel <- FALSE
    } else {
      logicheck(parallel)
    }
    if (is.null(foldid)) {
      foldid <- sample(rep(1:nfolds, length.out = length(y)))
    }
    if (length(unique(foldid)) != as.integer(nfolds)) {
      stop("Input 'foldid' must contain the number of unique values equal to \n
           input 'nfolds'.")
    }
}

kcv.rf <-
  function(x, y, foldid = NULL, rf.grid, nfolds = NULL, xtest = NULL, 
           ytest = NULL, classwt = NULL, maxnodes = NULL, importance = FALSE, 
           localImp = FALSE, nPerm = 1, norm.votes = TRUE, do.trace = FALSE, 
           corr.bias = FALSE, keep.inbag = FALSE, parallel = FALSE) 
{
    kcvcheck(y = y, nfolds = nfolds, parallel = parallel, foldid = foldid)
    if (is.logical(unlist(x)[1])) {
      stop("Input 'x' in random forest contains at least one logical value. \n
           Convert logical values to numeric or integer values to proceed.")
    }
    grid.row <- nrow(rf.grid)
    cv.rf <- matrix(rep(0, grid.row * nfolds), ncol = nfolds)
    if (parallel == TRUE) {
      cv.rf <- foreach (gg = 1:nfolds, .combine = cbind, 
                        .packages = 'randomForest') %dorng% {
                        x.train <- as.matrix(x[which(foldid != gg), ])
                        y.train <- y[which(foldid != gg)]
                        x.test <- as.matrix(x[which(foldid == gg), ])
                        y.test <- y[which(foldid == gg)]
                        stortune <- matrix(rep(0, grid.row), ncol = 1)
                        for (yy in 1:grid.row) {
                           rf.fit <- randomForest(x.train, y.train,
                                                  ntree = rf.grid[yy, 1],
                                                  nodesize = rf.grid[yy, 2], 
                                                  xtest = xtest, ytest = ytest, 
                                                  classwt = classwt, 
                                                  maxnodes = maxnodes, 
                                                  importance = importance, 
                                                  localImp = localImp, 
                                                  nPerm = nPerm, 
                                                  norm.votes = norm.votes, 
                                                  do.trace = do.trace, 
                                                  corr.bias = corr.bias, 
                                                  keep.inbag = keep.inbag)
                           rf.pred <- predict(rf.fit, x.test, type = 'class')
                           stortune[yy, 1] <- 1 - mean(rf.pred == y.test) 
                        }
                        cv.rf[, gg] <- stortune
               }
    } else {
      for (gg in 1:nfolds) {
         x.train <- as.matrix(x[which(foldid != gg), ])
         y.train <- y[which(foldid != gg)]
         x.test <- as.matrix(x[which(foldid == gg), ])
         y.test <- y[which(foldid == gg)]
         stortune <- matrix(rep(0, grid.row), ncol = 1)
         for (yy in 1:grid.row) {
            rf.fit <- randomForest(x.train, y.train, ntree = rf.grid[yy, 1],
                                   nodesize = rf.grid[yy, 2], xtest = xtest, 
                                   ytest = ytest, classwt = classwt,
                                   maxnodes = maxnodes, importance = importance, 
                                   localImp = localImp, nPerm = nPerm, 
                                   norm.votes = norm.votes, do.trace = do.trace, 
                                   corr.bias = corr.bias, 
                                   keep.inbag = keep.inbag)
            rf.pred <- predict(rf.fit, x.test, type = 'class')
            stortune[yy, 1] <- 1 - mean(rf.pred == y.test) 
         }
         cv.rf[, gg] <- stortune
      }
    }
    rf.mean <- apply(cv.rf, 1, mean)
    minid <- which.min(rf.mean)
    rf.fit.best <- randomForest(x, y, ntree = rf.grid[minid, 1],
                                nodesize = rf.grid[minid, 2], xtest = xtest, 
                                ytest = ytest, classwt = classwt, 
                                maxnodes = maxnodes, importance = importance, 
                                localImp = localImp, nPerm = nPerm, 
                                norm.votes = norm.votes, do.trace = do.trace, 
                                corr.bias = corr.bias, keep.inbag = keep.inbag)
    return(list(rf.grid.id = minid, rf.fit = rf.fit.best, 
                error = rf.mean[minid]))
}

tunecpfa <- 
  function(x, y, z = NULL, model = c("parafac", "parafac2", "pca"), nfac = 1, 
           nfolds = 10, method = c("PLR", "SVM", "RF", "NN", "RDA", "GBM"),
           family = c("binomial", "multinomial"), parameters = list(), 
           foldid = NULL, prior = NULL, cmode = NULL, parallel = FALSE, 
           cl = NULL, verbose = TRUE, compscale = TRUE, 
           pcarot = c("unrotated", "varimax"), ...)
{   
    if (!(is.list(parameters))) {
      stop("Input 'parameters' must be of class 'list'.")
    }
    if (length(parameters) == 0) {
      size <- nodesize <- ntree <- gamma <- cost <- lambda <- alpha <- NULL 
      subsample <-  max.depth <- eta <- delta <- decay <- rda.alpha <- size
      nrounds <- subsample
    } else {
      names(parameters) <- tolower(names(parameters))
      paranames <- c("alpha", "lambda", "cost", "gamma", "ntree", "nodesize", 
                     "size", "decay", "rda.alpha", "delta", "eta", "max.depth", 
                     "subsample", "nrounds")
      paralogical <- paranames %in% names(parameters)
      if (sum(paralogical) == 0) {
        stop("Input 'parameters' was provided but does not contain any \n
             acceptable values. Input 'parameters' must contain only \n 
             acceptable values. See help file for function 'cpfa' under \n
             argument 'parameters' for a list of acceptable values.")
      }
      if (length(unique(names(parameters))) != length(names(parameters))) {
        stop("Input 'parameters' was provided but contains duplicate \n
             parameter names. Input 'parameters' cannot contain duplicates.")
      }
      logicalpara <- names(parameters) %in% paranames
      if ((sum(logicalpara) < length(parameters)) && (sum(logicalpara) > 0)) {
        stop("Input 'parameters' was provided and contains some acceptable \n
             values. However, 'parameters' also contains one or more values \n
             that are not acceptable. Input 'parameters' must contain only \n 
             acceptable values. See help file for function 'cpfa' under \n
             argument 'parameters' for a list of acceptable values.")
      }
      parainput <- paranames[which(paralogical)]
      paranull <- paranames[-which(paralogical)]
      if (length(parainput) > 0) {
        list2env(parameters[parainput], envir = environment())
      }
      iparam <- paranull
      if (length(iparam) > 0) {for (p in iparam) assign(p, NULL)} 
    }
    models <- c("parafac", "parafac2", "pca")
    model0 <- sum(tolower(model) %in% models)
    if ((model0 == 0L) || (model0 > 1L)) {
      stop("Input 'model' not specified correctly. Input must be one of \n
           either 'parafac', 'parafac2', or 'pca'.")
    }
    model <- tolower(model)
    if (is.array(x) && (!(is.matrix(x))) && (model %in% c("parafac", "pca"))) {
      xdim <- origdim <- dim(x)                                                            
      lxdim <- length(xdim)
      if (!((lxdim == 3L) || (lxdim == 4L))) {
        stop("Input 'x' must be a 3-way or 4-way array.")
      }
      if (any(is.nan(x)) || any(is.infinite(x))) {
        stop("Input 'x' cannot contain NaN or Inf values.")
      }
      if (any(is.na(x))) {stop("Input 'x' cannot contain missing values.")}
      if (!(is.null(cmode))) {
        if (!(cmode %in% (1:lxdim))) {
          stop("Input 'cmode' must be 1, 2, or 3 (or 4 if 'x' is 4-way).")
        }
        if (model == "parafac") {
          modeval <- 1:lxdim
          mode.re <- c(modeval[-cmode], cmode)
          x <- aperm(x, mode.re)
          xdim <- dim(x)
        } else {
          modeval <- 1:lxdim
          mode.re <- c(cmode, modeval[-cmode])
          x <- matrix(aperm(x, mode.re), nrow = xdim[cmode])
          xdim <- dim(x)
          lxdim <- length(xdim)
        }
      } else {
        cmode <- lxdim
        if (model == "pca") {
          modeval <- 1:lxdim
          mode.re <- c(cmode, modeval[-cmode])
          x <- matrix(aperm(x, mode.re), nrow = xdim[cmode])
          xdim <- dim(x)
          lxdim <- length(xdim)
          if (length(y) != dim(x)[1]) {
            stop("Input 'x' was a 3-way or 4-way array, and model was 'pca'. \n 
                 Input 'y' had a length different from the last mode of 'x'. \n 
                 When 'x' is a 3-way or 4-way array, and when model is 'pca', \n 
                 the last mode must be the classification mode. Consider \n 
                 permuting the array.")
          }
        }
      }
    } else if (is.array(x) && (!(is.matrix(x))) && (model == "parafac2")) {
      xdim <- dim(x)                                                            
      lxdim <- length(xdim)
      if (!((lxdim == 3L) || (lxdim == 4L))) {
        stop("Input 'x' must be a 3-way or 4-way array.")
      }
      if (any(is.nan(x)) || any(is.infinite(x))) {
        stop("Input 'x' cannot contain NaN or Inf values.")
      }
      if (any(is.na(x))) {stop("Input 'x' cannot contain missing values.")}
      if (!(is.null(cmode))) {
        cmode <- lxdim
        warning("Input 'cmode' is ignored when 'model = parafac2'. Last mode \n
                is classification mode by default.")
      } else {
        cmode <- lxdim
      }
      storlist <- vector("list", xdim[cmode])
      if (lxdim == 3L) {
        for (k in 1:xdim[cmode]) {storlist[[k]] <- x[, , k]}
      } else {
        for (k in 1:xdim[cmode]) {storlist[[k]] <- x[, , , k]}
      }
      x <- storlist
      rm(storlist)
    } else if (is.list(x) && (model == "parafac2")) {
      xdim1 <- dim(x[[1]])
      lxdim <- length(xdim1) + 1L
      if (!((lxdim == 3L) || (lxdim == 4L))) {
        stop("Input 'x' must be a list of matrices or 3-way arrays.")
      }
      if (!(is.null(cmode))) {
        cmode <- lxdim
        warning("Input 'cmode' is ignored if 'model = parafac2'. Last mode \n
                is classification mode by default. First mode is nested \n
                within last mode (i.e., number of levels for first mode can \n
                vary for each level of the last mode).")
      } else {
        cmode <- lxdim
      }
      if (any(as.logical(lapply(x, function(a){return(any(is.nan(a)))})))) {
        stop("Input 'x' cannot contain NaN values")
      }
      if (any(as.logical(lapply(x,function(a){return(any(is.infinite(a)))})))) {
        stop("Input 'x' cannot contain Inf values")
      }
      if (any(as.logical(lapply(x,function(a){return(any(is.na(a)))})))) {
        stop("Input 'x' cannot contain missing values")
      }
      if (lxdim == 3L) {
        xdim <- rep(NA, 3)
        xdim[2] <- xdim1[2]
        xdim[3] <- length(x)
        if (any(unlist(lapply(x, ncol)) != xdim[2])) {
          stop("Input 'x' must be list of matrices with same \n
               number of columns.")
        }
      } else {
        xdim <- rep(NA, 4)
        xdim[2] <- xdim1[2]
        xdim[3] <- xdim1[3]
        xdim[4] <- length(x)
        index2 <- seq(2, (3 * length(x) - 1), by = 3)
        index3 <- seq(3, (3 * length(x)), by = 3)
        if (any(unlist(lapply(x, dim))[index2] != xdim[2])) {
          stop("Input 'x' must be list of arrays with same number of columns.")
        }
        if (any(unlist(lapply(x, dim))[index3] != xdim[3])) {
          stop("Input 'x' must be list of arrays with same number of slabs.")
        }
      }
    } else if (is.list(x) && (model != "parafac2")) {
      stop("Input 'x' cannot be of class 'list' if model is 'parafac' or \n 
           'pca'.")
    } else if (is.matrix(x) && (model != "pca")) {
      stop("Input 'x' cannot be of class 'matrix' if model is 'parafac' or \n 
           'parafac2'.")
    } else if (is.matrix(x) && (model == "pca")) {  
      xdim <- origdim <- dim(x)                                                            
      lxdim <- length(xdim)
      if (!((lxdim == 2L))) {
        stop("If 'x' has class 'matrix' and model is 'pca', 'x' must be a \n 
             2-way matrix.")
      }
      if (any(is.nan(x)) || any(is.infinite(x))) {
        stop("Input 'x' cannot contain NaN or Inf values.")
      }
      if (any(is.na(x))) {stop("Input 'x' cannot contain missing values.")}
      if (!(is.null(cmode))) {
        if (!(cmode %in% (1:lxdim))) {
          stop("Input 'cmode' must be 1 or 2 when model is 'pca' and when \n
               'x' is of class 'matrix'.")
        }
        if (cmode == 1) {
          x <- x
        } else {
          modeval <- 1:lxdim
          mode.re <- c(cmode, modeval[-cmode])
          x <- aperm(x, mode.re)
          xdim <- dim(x)
        }
      } else {
        cmode <- 1
      }
    } else {
      stop("Input 'x' can be of class 'array' for any model, can be of class \n
           'list' for 'parafac2', and can be of class 'matrix' for 'pca'. \n
           Else, input 'x' cannot be of a different class.")
    }
    if (!(is.factor(y))) {stop("Input 'y' must be of class 'factor'.")}
    if (model == "parafac") {
      if (!(length(y) == origdim[cmode])) {
        stop("Length of 'y' must match number of levels in classification \n 
             mode of 'x'.")
      }
    } else if (model == "pca") {  
      if (!(length(y) == xdim[1])) {
        stop("Length of 'y' must match number of levels in classification \n 
             mode of 'x'.")
      }
    } else {
      if (!(length(y) == xdim[cmode])) {
        stop("Length of 'y' must match number of levels in classification \n 
             mode of 'x'.")
      }
    }
    if (length(unique(y)) == 0L || length(unique(y)) == 1L) {
      stop("Input 'y' contains less than two unique labels. Need to provide \n
           at least two unique labels.")
    }
    ylev <- length(levels(y))
    if (!(sum(sort(as.numeric(levels(y))) == 0:(ylev - 1)) == ylev)) {
      stop("Input 'y' must contain labels of 0 and 1 for binary problems, or \n
           0, 1, 2, ..., for multiclass problems.")
    }
    if (!((is.numeric(nfac)) || (is.integer(nfac)))) {
      stop("Input 'nfac' must be of class integer or numeric.")
    }
    if (!(all(nfac == floor(nfac)))) {
      stop("Input 'nfac' must contain only integers.")
    }
    nfac <- sort(nfac)
    lnfac <- length(nfac)
    if (!((is.integer(nfolds)) || (is.numeric(nfolds)))) {
      stop("Input 'nfolds' must be of class integer or numeric.")
    }
    if (length(nfolds) != 1L || nfolds < 2L || nfolds != floor(nfolds)) {
      stop("Input 'nfolds' must be a single integer equal to or greater \n
           than 2.")
    }
    if (nfolds > length(y)) {
      stop("Input 'nfolds' must be a single whole number equal to or less \n 
           than the number of labels in 'y'.")
    }
    if (!(is.null(z))) {
      zdim <- dim(z)                                                            
      lzdim <- length(zdim)
      if (!((lzdim == 2L))) {stop("Input 'z' must have two modes.")}
      if (!(is.matrix(z))) {stop("Input 'z' must be of class 'matrix'.")}
      if (any(is.nan(z)) || any(is.infinite(z))) {
        stop("Input 'z' cannot contain NaN or Inf values.")
      }
      if (any(is.na(z))) {stop("Input 'z' cannot contain missing values.")}
      if (zdim[1] != length(y)) {
        stop("Input 'z', when provided, must have number of rows equal to \n
             the length of input 'y' (i.e., the number of observations).")
      }
    }
    if (is.null(foldid)) {
      foldid <- sample(rep(1:nfolds, length.out = length(y)))
    } else {
      if (model != "pca") {
        if (length(foldid) != xdim[cmode]) {
          stop("Input 'foldid' must match number of levels in classification \n
             mode.")
        }
      } else {
        if (length(foldid) != xdim[1]) {
          stop("Input 'foldid' must match number of levels in classification \n
             mode.")
        }
      }
      if (!(is.integer(foldid))) {
        stop("Input 'foldid' must be of class integer.")
      }
      if (length(unique(foldid)) < 2L) {
        stop("Input 'foldid' must contain IDs for two or more folds.")
      }
      if (!(all(foldid == floor(foldid)))) {
        stop("Input 'foldid' must contain only integers.")
      }
      if (length(unique(foldid)) != as.integer(nfolds)) {
        stop("Input 'foldid' must contain the number of unique values equal \n
             to nfolds.")
      }
    }
    omethods <- c("PLR", "SVM", "RF", "NN", "RDA", "GBM") 
    checkmethod <- sum(toupper(method) %in% omethods)
    if (checkmethod != length(method)) {
      stop("Input 'method' contains at least one value that is not valid.")
    }
    method <- which(omethods %in% toupper(method) == TRUE)
    if (model == "pca") {
      pcarots <- c("unrotated", "varimax")
      pcarot0 <- sum(tolower(pcarot) %in% pcarots)
      if ((pcarot0 == 0L) || (pcarot0 > 1L)) {pcarot <- "unrotated"}
      pcarot <- tolower(pcarot)
    }
    if (length(method) == 0) {method <- 1:6}
    if (!(is.logical(verbose))) {
      stop("Input 'verbose' must be of class logical.")
    }
    if (length(verbose) != 1L) {stop("Input 'verbose' must be a single value.")}
    if ('1' %in% method) {
      if (is.null(alpha)) {alpha <- seq(0, 1, length = 6)}
      if (any(alpha < 0L) || any(alpha > 1L)) {
        stop("Input 'alpha' must contain real numbers between zero and \n 
             one (inclusive).")
      }
      if (!(is.numeric(alpha))) {stop("Input 'alpha' must be numeric.")}
      alpha <- sort(alpha)
    }
    if ('2' %in% method) {
      if (is.null(gamma)) {gamma <- c(0, 0.01, 0.1, 1, 10, 100, 1000)}
      if (any(gamma < 0L)) {
        stop("Input 'gamma' must contain real numbers equal to or greater \n 
             than zero.")
      }
      if (!(is.numeric(gamma))) {stop("Input 'gamma' must be numeric.")}
      gamma <- sort(gamma)
      if (is.null(cost)) {cost <- c(1, 2, 4, 8, 16, 32, 64)}
      if (any(cost <= 0L)) {
        stop("Input 'cost' must be a real number greater than zero.")
      }
      if (!(is.numeric(cost))) {stop("Input 'cost' must be numeric.")}
      cost <- sort(cost)
      svm.grid <- expand.grid(gamma, cost)
    }
    if ('3' %in% method) {
      if (is.null(ntree)) {ntree <- c(100, 200, 400, 600, 800, 1600, 3200)} 
      if (any(ntree < 1L)) {
        stop("Input 'ntree' must be greater than or equal to one.")
      }
      if (!(all(ntree == floor(ntree)))) {
        stop("Input 'ntree' must contain only integers.")
      }
      if (!(is.numeric(ntree))) {stop("Input 'ntree' must be numeric.")}
      ntree <- sort(ntree)
      if (is.null(nodesize)) {nodesize <- c(1, 2, 4, 8, 16, 32, 64)}
      if (any(nodesize < 1L)) {
        stop("Input 'nodesize' must be greater than or equal to one.") 
      }
      if (!(all(nodesize == floor(nodesize)))) {
        stop("Input 'nodesize' must contain only integers.")
      }
      if (!(is.numeric(nodesize))) {stop("Input 'nodesize' must be numeric.")}
      nodesize <- sort(nodesize)
      rf.grid <- expand.grid(ntree, nodesize)
    }
    if ('4' %in% method) {
      if (is.null(size)) {size <- c(1, 2, 4, 8, 16, 32, 64)} 
      if (any(size < 0L)) {
        stop("Input 'size' must be greater than or equal to zero.")
      }
      if (!(all(size == floor(size)))) {
        stop("Input 'size' must contain only integers.")
      }
      if (!(is.numeric(size))) {stop("Input 'size' must be numeric.")}
      size <- sort(size)
      if (is.null(decay)) {decay <- c(0.001, 0.01, 0.1, 1, 2, 4, 8, 16)}
      if (!(is.numeric(decay))) {stop("Input 'decay' must be numeric.")}
      decay <- sort(decay)
      nn.grid <- expand.grid(size, decay)
    }
    if ('5' %in% method) {
      if (is.null(rda.alpha)) {rda.alpha <- seq(0, 0.999, length = 6)}
      if (any(rda.alpha < 0L) || any(rda.alpha >= 1L)) {
        stop("Input 'rda.alpha' must contain real numbers equal to or greater \n
             than zero, and less than one.")
      }
      if (!(is.numeric(rda.alpha))) {stop("Input 'rda.alpha' must be numeric.")}
      rda.alpha <- sort(rda.alpha)
      if (is.null(delta)) {delta <- c(0, 0.1, 1, 2, 3, 4)}
      if (any(delta < 0L)) {
        stop("Input 'delta' must be a real number greater than or equal \n 
             to zero.")
      }
      if (!(is.numeric(delta))) {stop("Input 'delta' must be numeric.")}
      delta <- sort(delta)
      rda.grid <- expand.grid(rda.alpha, delta)
    }      
    if ('6' %in% method) {
      if (is.null(eta)) {eta <- c(0.1, 0.3, 0.5, 0.7, 0.9)}
      if (any(eta <= 0L) || any(eta >= 1L)) {
        stop("Input 'eta' must contain real numbers greater than zero and \n 
             less than one.")
      }
      if (!(is.numeric(eta))) {stop("Input 'eta' must be numeric.")}
      eta <- sort(eta)
      if (is.null(max.depth)) {max.depth <- c(1, 2, 3, 4)} 
      if (any(max.depth < 1L)) {
        stop("Input 'max.depth' must be greater than or equal to one.")
      }
      if (!(all(max.depth == floor(max.depth)))) {
        stop("Input 'max.depth' must contain only integers.")
      }
      if (!(is.numeric(max.depth))) {stop("Input 'max.depth' must be numeric.")}
      max.depth <- sort(max.depth)
      if (is.null(subsample)) {subsample <- c(0.6, 0.7, 0.8, 0.9)}
      if (any(subsample <= 0L) || any(subsample > 1L)) {
        stop("Input 'subsample' must be greater than zero and less than or \n
             equal to one.")
      }
      if (!(is.numeric(subsample))) {stop("Input 'subsample' must be numeric.")}
      if (is.null(nrounds)) {nrounds <- c(100, 200, 300, 500)} 
      if (any(nrounds < 1L)) {
        stop("Input 'nrounds' must be greater than or equal to one.")
      }
      if (!(all(nrounds == floor(nrounds)))) {
        stop("Input 'nrounds' must contain only integers.")
      }
      if (!(is.numeric(nrounds))) {stop("Input 'nrounds' must be numeric.")}
      gbm.grid <- expand.grid(eta, max.depth, subsample, nrounds)
    }
    families <- c("binomial", "multinomial")
    family <- pmatch(tolower(family), families)
    lfam <- length(family)
    if (any(is.na(family))) {
      stop("Input 'family' must be a character value, either 'binomial' \n
           or 'multinomial'.")
    }
    if (lfam == 0L) {
      stop("Input 'family' must not be NULL.")
    } else if(lfam > 2L) {
      stop("Input 'family' must be 'binomial' or 'multinomial'.")
    } else if (lfam == 2L && (length(levels(y)) == 2L)) {
      family <- "binomial"
      warning("Input 'family' was not specified. Two classes detected: \n
              defaulting to family = 'binomial'.")
    } else if (lfam == 2L && (length(levels(y)) > 2L)) {
      family <- "multinomial"
      warning("Input 'family' was not specified. Three or more classes \n 
              detected: defaulting to family = 'multinomial'.")
    } else if (lfam == 1L && family == 1L) {
      family <- "binomial"
    } else if (lfam == 1L && family == 2L) {
      family <- "multinomial"
    }
    if (is.null(prior)) {
      prior <- as.numeric(table(y) / length(y))
      frac <- as.table(prior)
      names(frac) <- seq_along(levels(y)) - 1
      wtemp <- as.numeric(frac[y])
      weight <- 1 / (wtemp * (length(y) / sum(wtemp)))
      frac <- tapply(weight, y, unique)
      pricorrect <- rep(1 / length(frac), length(frac))
    } else {
      if (!(abs(sum(prior) - 1) < .Machine$double.eps^0.5)) {
        stop("Values within input 'prior' must sum to one.")
      }
      if (!(is.numeric(prior))) {stop("Input 'prior' must be numeric.")}
      if (family == "binomial") {
        if (!(length(prior) == 2L))
          stop("Input 'prior' must contain two values for family of \n
                'binomial'.")
      }
      if (family == "multinomial") {
        if (!(length(prior) >= 3L))
          stop("Input 'prior' must contain three or more values for family \n
                of 'multinomial'.")
      }
      frac <- as.table(prior)
      pricorrect <- rep(1 / length(frac), length(frac))
      if (family == "binomial") {
        names(frac) <- c(0, 1)
        wtemp <- as.numeric(frac[y])
        weight <- 1 / (wtemp * (length(y) / sum(wtemp)))
      }
      if (family == "multinomial") {
        names(frac) <- seq_along(levels(y)) - 1
        wtemp <- as.numeric(frac[y])
        weight <- 1 / (wtemp * (length(y) / sum(wtemp)))
      }
      frac <- tapply(weight, y, unique)
    }
    priorweights <- list(weight = weight, frac = frac, pricorrect = pricorrect)
    if ('1' %in% method) {plr.weights <- weight}
    Aweights <- Bweights <- Cweights <- Phi <- vector("list", lnfac)
    scenters <- sscales <- Aweights
    train.weights <- opt.model <- Aweights                                         
    opt.param <- est.time <- kcv.error <- NULL
    logicheck(parallel); logicheck(compscale)
    ccluster <- FALSE
    if (parallel == TRUE) {
      if (is.null(cl)) {
        cl <- makeCluster(detectCores())
        ce <- clusterEvalQ(cl, library(multiway))
        ccluster <- TRUE
      }
      clusterSetRNGStream(cl, iseed = sample.int(.Machine$integer.max, 1)) 
      registerDoParallel(cl)
    }
    for (w in 1:lnfac) {
       optmodel.new <- vector("list", 6)                                        
       if (model == "parafac") {
         if (verbose == TRUE) {
           cat("nfac =", nfac[w], "model = parafac", fill = TRUE)
         }
         tic <- proc.time()
         pfac <- parafac(X = x, nfac = nfac[w], parallel = parallel, cl = cl,   
                         verbose = verbose, ...)
         toc <- proc.time()
         if (w == 1) {const <- pfac$control$const}
         time.pfac <- toc[3] - tic[3]
         Aweights[[w]] <- pfac$A
         Bweights[[w]] <- pfac$B   
         rtrain <- as.matrix(pfac$C)
         if (!(is.null(z)) && (lxdim == 3L)) {rtrain <- cbind(rtrain, z)}
         if (compscale == TRUE) {
           strain <- scale(rtrain)
           scenters[[w]] <- scenter <- attr(strain, "scaled:center") 
           sscales[[w]] <- sscale <- attr(strain, "scaled:scale")  
           train <- train.weights[[w]] <- strain
         } else {
           train <- train.weights[[w]] <- rtrain
           scenters[[w]] <- FALSE
           sscales[[w]] <- FALSE
         }
         if (lxdim == 4L) {
           Cweights[[w]] <- pfac$C                                               
           rtrain <- as.matrix(pfac$D)
           if (!(is.null(z))) {rtrain <- cbind(rtrain, z)}
           if (compscale == TRUE) {
             strain <- scale(rtrain)
             scenters[[w]] <- scenter <- attr(strain, "scaled:center") 
             sscales[[w]] <- sscale <- attr(strain, "scaled:scale")  
             train <- train.weights[[w]] <- strain
           } else {
             train <- train.weights[[w]] <- rtrain
             scenters[[w]] <- FALSE
             sscales[[w]] <- FALSE
           }
         }
       } else if (model == "parafac2") {
         if (verbose == TRUE) {
           cat("nfac =", nfac[w], "model = parafac2", fill = TRUE)
         }
         tic <- proc.time()
         pfac <- parafac2(X = x, nfac = nfac[w], parallel = parallel, cl = cl,  
                          verbose = verbose, ...)
         toc <- proc.time()
         if (w == 1) {const <- pfac$control$const}
         time.pfac <- toc[3] - tic[3]
         Aweights[[w]] <- pfac$A
         Bweights[[w]] <- pfac$B                                                  
         rtrain <- as.matrix(pfac$C)
         if (!(is.null(z)) && (lxdim == 3L)) {rtrain <- cbind(rtrain, z)}
         if (compscale == TRUE) {
           strain <- scale(rtrain)
           scenters[[w]] <- scenter <- attr(strain, "scaled:center") 
           sscales[[w]] <- sscale <- attr(strain, "scaled:scale")
           train <- train.weights[[w]] <- strain
         } else {
           train <- train.weights[[w]] <- rtrain
           scenters[[w]] <- FALSE
           sscales[[w]] <- FALSE
         }
         if (lxdim == 4L) {
           Cweights[[w]] <- pfac$C
           rtrain <- as.matrix(pfac$D)
           if (!(is.null(z))) {rtrain <- cbind(rtrain, z)}
           if (compscale == TRUE) {
             strain <- scale(rtrain)
             scenters[[w]] <- scenter <- attr(strain, "scaled:center") 
             sscales[[w]] <- sscale <- attr(strain, "scaled:scale")  
             train <- train.weights[[w]] <- strain
           } else {
             train <- train.weights[[w]] <- rtrain
             scenters[[w]] <- FALSE
             sscales[[w]] <- FALSE
           }
         }
         Phi[[w]] <- pfac$Phi
       } else {
         if (verbose == TRUE) {
           cat("nfac =", nfac[w], "model = pca", fill = TRUE)
         }
         if (w == 1) {
           tic <- proc.time()
           xcent <- scale(x, center = TRUE, scale = FALSE)
           pcacenter <- attr(xcent, "scaled:center")
           USV <- svd(xcent)
           weights <- USV$v[, 1:nfac[w], drop = FALSE]
           leftsing <- USV$u[, 1:nfac[w], drop = FALSE]
           scores <- sweep(leftsing, 2, USV$d[1:nfac[w]], "*")
           toc <- proc.time()
           time.pfac <- toc[3] - tic[3]
           if (pcarot == "varimax") {
             if (nfac[w] != 1L) {
               varires <- varimax(weights)
               rotmat <- varires$rotmat
               weights <- unclass(as.matrix(varires$loadings))
               scores <- scores %*% rotmat
             }
           }
         } else {
           weights <- USV$v[, 1:nfac[w], drop = FALSE]
           leftsing <- USV$u[, 1:nfac[w], drop = FALSE]
           scores <- sweep(leftsing, 2, USV$d[1:nfac[w]], "*")
           if (pcarot == "varimax") {
             if (nfac[w] != 1L) {
               varires <- varimax(weights)
               rotmat <- varires$rotmat
               weights <- unclass(as.matrix(varires$loadings))
               scores <- scores %*% rotmat
             }
           }
         }
         Aweights[[w]] <- weights
         rtrain <- as.matrix(scores)
         if (!(is.null(z))) {rtrain <- cbind(rtrain, z)}
         if (compscale == TRUE) {
           strain <- scale(rtrain)
           scenters[[w]] <- scenter <- attr(strain, "scaled:center") 
           sscales[[w]] <- sscale <- attr(strain, "scaled:scale")  
           train <- train.weights[[w]] <- strain
         } else {
           train <- train.weights[[w]] <- rtrain
           scenters[[w]] <- FALSE
           sscales[[w]] <- FALSE
         }
       }
       if ('1' %in% method) {
         if (verbose == TRUE) {
           cat("nfac =", nfac[w], "method = plr", fill = TRUE)
         }
         tic <- proc.time()
         if ((nfac[w] == 1) || (nfac[w] == 1L)) {
           train.plr <- cbind(train, 0)
           if (family == "multinomial") {
             stop("Input combination nfac = 1, family = 'multinomial', and \n
                  method = 'PLR' gives an error due to an issue interfacing \n
                  with glmnet::cv.glmnet. Until resolved, this combination of \n
                  arguments is not permitted.")
           }
         } else {
           train.plr <- train
         }
         plr.results <- kcv.plr(x = train.plr,  y = y, nfolds = nfolds,  
                                foldid = foldid, alpha = alpha,
                                family = family, lambda = lambda,
                                weights = plr.weights, parallel = parallel)
         toc <- proc.time()
         time.plr <- toc[3] - tic[3]
         error.plr <- plr.results$error
         plr.id <- plr.results$alpha.id
         plr.opt <- alpha[plr.id]
         optmodel.new[[1]] <- plr.fit <- plr.results$plr.fit
         if (nfolds == 2) {lambda.min <- plr.results$lambda.min}
         if (nfolds >= 3) {lambda.min <- plr.fit$lambda.min}
       } else {
         lambda.min <- plr.opt <- error.plr <- time.plr <- NA
         optmodel.new[[1]] <- NULL
       }
       if ('2' %in% method) {
         if (verbose == TRUE) {
           cat("nfac =", nfac[w], "method = svm", fill = TRUE)
         }
         tic <- proc.time()
         svm.results <- kcv.svm(x = train, y = y, nfolds = nfolds,
                                foldid = foldid, svm.grid = svm.grid, 
                                class.weights = frac, parallel = parallel,
                                scale = FALSE)
         toc <- proc.time()
         time.svm <- toc[3] - tic[3]
         error.svm <- svm.results$error
         svm.id <- svm.results$svm.grid.id
         svm.opt <- svm.grid[svm.id, ]
         optmodel.new[[2]] <- svm.fit <- svm.results$svm.fit
       } else {
         error.svm <- time.svm <- NA
         svm.opt <- data.frame(NA, NA)
         optmodel.new[[2]] <- NULL
       }
       if ('3' %in% method) {
         if (verbose == TRUE) {
           cat("nfac =", nfac[w], "method = rf", fill = TRUE)
         }
         tic <- proc.time()
         rf.results <- kcv.rf(x = train, y = y, nfolds = nfolds,
                              foldid = foldid, rf.grid = rf.grid, 
                              classwt = pricorrect, parallel = parallel)
         toc <- proc.time()
         time.rf <- toc[3] - tic[3]
         error.rf <- rf.results$error
         rf.id <- rf.results$rf.grid.id
         rf.opt <- rf.grid[rf.id, ]
         optmodel.new[[3]] <- rf.results$rf.fit
       } else {
         error.rf <- time.rf <- NA
         rf.opt <- data.frame(NA, NA)
         optmodel.new[[3]] <- NULL
       }
       if ('4' %in% method) {
         if (verbose == TRUE) {
           cat("nfac =", nfac[w], "method = nn", fill = TRUE)
         }
         tic <- proc.time()
         nn.results <- kcv.nn(x = train, y = y, nfolds = nfolds,
                              foldid = foldid, nn.grid = nn.grid, 
                              weights = weight, parallel = parallel)
         toc <- proc.time()
         time.nn <- toc[3] - tic[3]
         error.nn <- nn.results$error
         nn.id <- nn.results$nn.grid.id
         nn.opt <- nn.grid[nn.id, ]
         optmodel.new[[4]] <- nn.fit <- nn.results$nn.fit
       } else {
         error.nn <- time.nn <- NA
         nn.opt <- data.frame(NA, NA)
         optmodel.new[[4]] <- NULL
       }
       if ('5' %in% method) {
         if (verbose == TRUE) {
           cat("nfac =", nfac[w], "method = rda", fill = TRUE)
         }
         tic <- proc.time()
         rda.results <- kcv.rda(x = train, y = as.numeric(y) - 1, 
                                nfolds = nfolds, foldid = foldid, 
                                rda.grid = rda.grid, prior = pricorrect, 
                                parallel = parallel)
         toc <- proc.time()
         time.rda <- toc[3] - tic[3]
         error.rda <- rda.results$error
         rda.id <- rda.results$rda.grid.id
         rda.opt <- rda.grid[rda.id, ]
         optmodel.new[[5]] <- rda.fit <- rda.results$rda.fit                  
       } else {
         error.rda <- time.rda <- NA
         rda.opt <- data.frame(NA, NA)
         optmodel.new[[5]] <- NULL
       }
       if ('6' %in% method) {
         if (verbose == TRUE) {
           cat("nfac =", nfac[w], "method = gbm", fill = TRUE)
         }
         tic <- proc.time()
         gbm.results <- kcv.gbm(x = train, y = y, nfolds = nfolds, 
                                foldid = foldid, family = family, 
                                gbm.grid = gbm.grid, weights = weight, 
                                parallel = parallel)
         toc <- proc.time()
         time.gbm <- toc[3] - tic[3]
         error.gbm <- gbm.results$error
         gbm.id <- gbm.results$gbm.grid.id
         gbm.opt <- gbm.grid[gbm.id, ]
         optmodel.new[[6]] <- gbm.fit <- gbm.results$gbm.fit                  
       } else {
         error.gbm <- time.gbm <- NA
         gbm.opt <- data.frame(NA, NA, NA, NA)
         optmodel.new[[6]] <- NULL
       } 
       opt.model[[w]] <- optmodel.new
       optparam.new <- data.frame(nfac = nfac[w], alpha = plr.opt,
                                  lambda = lambda.min, gamma = svm.opt[1, 1], 
                                  cost = svm.opt[1, 2], ntree = rf.opt[1, 1], 
                                  nodesize = rf.opt[1, 2], size = nn.opt[1, 1], 
                                  decay = nn.opt[1, 2], 
                                  rda.alpha = rda.opt[1, 1], 
                                  delta = rda.opt[1, 2], eta = gbm.opt[1, 1],
                                  max.depth = gbm.opt[1, 2], 
                                  subsample = gbm.opt[1, 3], 
                                  nrounds = gbm.opt[1, 4])
       esttime.new <- data.frame(nfac = nfac[w], time.pfac = time.pfac,
                                 time.plr = time.plr, time.svm = time.svm,
                                 time.rf = time.rf, time.nn = time.nn,
                                 time.rda = time.rda, time.gbm = time.gbm)
       kcv.error.new <- data.frame(nfac = nfac[w], error.plr = error.plr,
                                   error.svm = error.svm, error.rf = error.rf,
                                   error.nn = error.nn, error.rda = error.rda,
                                   error.gbm = error.gbm)
       opt.param <- rbind(opt.param, optparam.new)
       est.time <- rbind(est.time, esttime.new)
       kcv.error <- rbind(kcv.error, kcv.error.new)
    }                                                                      
    if ((parallel == TRUE) && (ccluster == TRUE)) {stopCluster(cl)}
    levels(y) <- names(frac)
    if (lxdim == 2L) {
      tcpfalist <- list(opt.model = opt.model, opt.param = opt.param, 
                        kcv.error = kcv.error, est.time = est.time, 
                        model = model, method = method, x = x, y = y, z = z,
                        Aweights = Aweights, Bweights = NULL, 
                        Cweights = NULL, Phi = NULL, const = pcarot,
                        cmode = cmode, family = family, xdim = xdim, 
                        lxdim = lxdim, train.weights = train.weights, 
                        priorweights = priorweights, scenters = scenters,
                        sscales = sscales, pcacenter = pcacenter)
    }
    if (lxdim == 3L) {
      tcpfalist <- list(opt.model = opt.model, opt.param = opt.param, 
                        kcv.error = kcv.error, est.time = est.time, 
                        model = model, method = method, x = x, y = y, z = z,
                        Aweights = Aweights, Bweights = Bweights, 
                        Cweights = NULL, Phi = Phi, const = const,
                        cmode = cmode, family = family, xdim = xdim, 
                        lxdim = lxdim, train.weights = train.weights, 
                        priorweights = priorweights, scenters = scenters,
                        sscales = sscales, pcacenter = NULL)
    }
    if (lxdim == 4L) {
      tcpfalist <- list(opt.model = opt.model, opt.param = opt.param, 
                        kcv.error = kcv.error, est.time = est.time, 
                        model = model, method = method, x = x, y = y, z = z,
                        Aweights = Aweights, Bweights = Bweights, 
                        Cweights = Cweights, Phi = Phi, const = const, 
                        cmode = cmode, family = family, xdim = xdim, 
                        lxdim = lxdim, train.weights = train.weights,
                        priorweights = priorweights, scenters = scenters,
                        sscales = sscales, pcacenter = NULL)
    }
    class(tcpfalist) <- "tunecpfa"
    return(tcpfalist)
}

cpm <- 
  function(x, y, level = NULL, fbeta = NULL, prior = NULL) 
{   
    if (!(class(x) %in% c("numeric", "factor", "integer"))) {
      stop("Input 'x' must be of class 'numeric', 'factor', or 'integer'.")
    }
    if (!(class(y) %in% c("numeric", "factor", "integer"))) {
      stop("Input 'y' must be of class 'numeric', 'factor', or 'integer'.")
    }
    if (any(is.na(x))) {stop("Input 'x' cannot contain missing values.")}
    if (any(is.na(y))) {stop("Input 'y' cannot contain missing values.")}
    if (length(x) != length(y)) {
      stop("Input 'x' must be same length as input 'y'.") 
    }
    if (!(is.null(level))) {
      llev <- length(level)
      if (!(class(level) %in% c("numeric", "integer", "character"))) {
        stop("Input 'level' must be of class 'numeric', 'integer' \n 
             or 'character'.")
      }
      if (llev == 1) {
        stop("Input 'level' must contain two or more values when supplied.")
      }
    } else {
      luni <- length(unique(c(x, y)))
      if (luni == 1L) {
        stop("Inputs 'x' and 'y' contain only one unique value. Unclear if \n
              binary or multiclass classification is occurring. Must input \n
              argument 'level' to specify.")
      }
      level <- sort(unique(c(x, y)))
    }
    x <- as.integer(factor(x, levels = level)) - 1
    y <- as.integer(factor(y, levels = level)) - 1
    llev <- length(level)
    cm <- matrix(0, nrow = llev, ncol = llev)
    colnames(cm) <- rownames(cm) <- 1:llev - 1
    for (k in 1:length(x)) {
       roww <- which(rownames(cm) == x[k])
       colum <- which(colnames(cm) == y[k])
       cm[roww, colum] <- cm[roww, colum] + 1
    }
    colnames(cm) <- rownames(cm) <- level
    if (is.null(fbeta)) {fbeta <- 1}
    if (!(is.null(fbeta))) {
      if ((length(fbeta) != 1) || (!(is.numeric(fbeta)))) {
        stop("Input 'fbeta' must be a single real number when inputted and of \n
             class numeric.")
      }
    }
    if (!(is.null(prior))) {
      if (!is.numeric(prior)) {
        stop("Input 'prior' must be of class 'numeric' when provided.")
      }
      if (length(prior) != llev) {
        stop("When inputted, 'prior' must contain as many values as the \n
              number of classes.")
      }
      if ((any(prior < 0)) || (any(prior > 1))) {
        stop("When inputted, 'prior' must only contain values between 0 \n
             and 1, inclusive.")
      }
      if (abs(sum(prior) - 1) > 1e-8) {
        stop("When inputted, 'prior' must contain values that sum to 1.")
      }
    }
    if (is.null(prior)) {prior <- rep((1 / llev), llev)}
    acc <- (sum(diag(cm))) / sum(cm)
    err <- 1 - acc
    if (llev == 2) {
      tpr <- cm[2,2] / (cm[2,2] + cm[2,1])
      fnr <- 1 - tpr
      fpr <- cm[1,2] / (cm[1,2] + cm[1,1])
      tnr <- 1 - fpr
      ppv <- cm[2,2] / (cm[2,2] + cm[1,2])
      fdr <- 1 - ppv
      npv <- cm[1,1] / (cm[1,1] + cm[2,1])
      fom <- 1 - npv
    } else {
      tpr.sum <- ppv.sum <- fpr.sum <- npv.sum <- rep(0, llev)
      fom.sum <- fdr.sum <- fnr.sum <- tnr.sum <- tpr.sum
      for (h in 1:llev) {
         tpr.sum[h] <- (cm[h,h] / sum(cm[h, ]))
         ppv.sum[h] <- (cm[h,h] / sum(cm[, h]))
         fpr.sum[h] <- (sum(cm[,h]) - cm[h,h]) / (sum(cm) - sum(cm[h,]))
         npv.sum[h] <- (sum(cm) - sum(cm[h,]) - sum(cm[,h]) + cm[h,h]) / 
                            (sum(cm) - sum(cm[,h]))
         tnr.sum[h] <- 1 - fpr.sum[h]
         fnr.sum[h] <- 1 - tpr.sum[h]
         fdr.sum[h] <- 1 - ppv.sum[h]
         fom.sum[h] <- 1 - npv.sum[h]
      }
      tpr <- sum(prior * tpr.sum)
      ppv <- sum(prior * ppv.sum)
      fpr <- sum(prior * fpr.sum)
      npv <- sum(prior * npv.sum)
      tnr <- sum(prior * tnr.sum)
      fnr <- sum(prior * fnr.sum)
      fdr <- sum(prior * fdr.sum)
      fom <- sum(prior * fom.sum)
    }
    fs <- (1 + (fbeta^2)) * ((ppv * tpr) / (((fbeta^2) * ppv) + tpr))
    class.eval <- data.frame(err = err, acc = acc, tpr = tpr, fpr = fpr, 
                             tnr = tnr, fnr = fnr, ppv = ppv, npv = npv,
                             fdr = fdr, fom = fom, fs = fs)
    output <- list(cm = cm, class.eval = class.eval)
    return(output)
}

simcpfa <- 
  function(arraydim = NULL, model = "parafac", nfac = 2, nclass = 2, 
           smethod = "logistic", nreps = 100, onreps = 10, props = NULL,
           corresp = NULL, meanpred = NULL, modes = 3, corrpred = NULL, 
           pf2num = NULL, Amat = NULL, Bmat = NULL, Cmat = NULL, Dmat = NULL, 
           Gmat = NULL, Emat = NULL, technical = list())
{
    if (is.null(nfac)) {
      warning("Input 'nfac' was NULL. 'nfac' was set to 2."); nfac <- 2
    }
    numcheck(nfac)
    if ((nfac < 1) || (nfac != floor(nfac))) { 
      stop("Input 'nfac' must be an integer value of 1 or greater.") 
    }
    if (is.null(modes)) {
      warning("Input 'modes' was NULL. 'modes' was set to 3.")
      modes <- 3
    }
    if (!(smethod %in% c("logistic", "eigende"))) {
      stop("Input 'smethod' must be either 'logistic' or 'eigende'.")
    }
    numcheck(modes)
    if (is.null(props)) {props <- rep(1 / nclass, nclass)}
    if ((length(props) != nclass) || (!(is.numeric(props)))) {
      stop("Input 'props' must be a numeric vector of length equal to \n 
           'nclass'.")
    }
    if (abs(sum(props) - 1) > 1e-8) {stop("Input 'props' must sum to 1.")}
    if (any(props <= 0) || any(props >= 1)) {
      stop("Input 'props' must contain values strictly between 0 and 1.")
    }
    if ((!(modes %in% c(2, 3, 4))) || (modes != floor(modes))) { 
      stop("Input 'modes' must be an integer value of 2, 3, or 4.") 
    }
    if (is.null(arraydim)) {
      if (modes == 2) {
        warning("Input 'arraydim' was NULL. 'arraydim' was set to \n 
                c(10, 100).")
        arraydim <- c(10, 100)
      } else if (modes == 3) { 
        warning("Input 'arraydim' was NULL. 'arraydim' was set to \n 
                c(10, 10, 100).")
        arraydim <- c(10, 10, 100)
      } else {
        warning("Input 'arraydim' was NULL. 'arraydim' was set to \n 
                c(10, 10, 10, 100).")
        arraydim <- c(10, 10, 10, 100)
      }
    }
    if (length(arraydim) != modes) {
      stop("Input 'arraydim' must have length equal to 'modes' \n 
           (e.g., 2, 3, or 4).")
    }
    if (!(is.numeric(arraydim))) {stop("Input 'arraydim' must be numeric.")}
    if (any(is.na(arraydim)) || any(is.nan(arraydim))) { 
      stop("Input 'arraydim' must not contain NA or NaN values.")
    }
    if (any(is.infinite(arraydim))) {
      stop("Input 'arraydim' must contain only finite numbers.")
    }
    if (any(arraydim < 2) || any(arraydim != floor(arraydim))) { 
      stop("Input 'arraydim' must contain integer values of 2 or greater.") 
    }
    if (is.null(nclass)) {
      warning("Input 'nclass' was NULL. 'nclass' was set to 2."); nclass <- 2
    }
    numcheck(nclass)
    if ((nclass < 2) || (nclass != floor(nclass))) { 
      stop("Input 'nclass' must be an integer value of 2 or greater.") 
    }
    if (is.null(corresp)) {
      warning("Input 'corresp' was NULL. 'corresp' was set to rep(0.5, nfac).")
      corresp <- rep(0.5, nfac)
    }
    if (length(corresp) != nfac) {
      stop("Input 'corresp' must have a length equal to 'nfac'.")
    }
    if (!(is.numeric(corresp))) {stop("Input 'corresp' must be numeric.")}
    if (any(is.na(corresp) | is.nan(corresp))) {
      stop("Input 'corresp' must not contain NA or NaN values.")
    }
    if (any((corresp < -1) | (corresp > 1))) {
      stop("Input 'corresp' must contain values between -1 and 1, inclusive.")
    }
    if (is.null(nreps)) {
      warning("Input 'nreps' was NULL. 'nreps' was set to 100."); nreps <- 100
    }
    numcheck(nreps)
    if ((nreps < 1) || (nreps != floor(nreps))) { 
      stop("Input 'nreps' must be an integer value of 1 or greater.") 
    }
    if (is.null(onreps)) {
      warning("Input 'onreps' was NULL. 'onreps' was set to 10."); onreps <- 10
    }
    numcheck(onreps)
    if ((onreps < 1) || (onreps != floor(onreps))) { 
      stop("Input 'onreps' must be an integer value of 1 or greater.") 
    }
    if (is.null(meanpred)) {
      meanpred <- rep(0, nfac)
    } else { 
      if (length(meanpred) != nfac) {
        stop("Input 'meanpred' must have a length equal to 'nfac' when \n 
             provided.")
      }
      if (!(is.numeric(meanpred))) {stop("Input 'meanpred' must be numeric.")}
      if (any(is.na(meanpred)) || any(is.nan(meanpred))) { 
        stop("Input 'meanpred' must not contain NA or NaN values.")
      }
      if (any(is.infinite(meanpred))) {
        stop("Input 'meanpred' must contain only finite numbers.")
      }
    }
    if (is.null(model)) {
      warning("Input 'model' was NULL. 'model' was set to 'parafac'.")
      model <- "parafac"
    }
    if ((!(is.character(model))) || (length(model) != 1L)) {
      stop("Input 'model' must be a single character value of \n 
           'parafac', 'parafac2', or 'pca'.")
    }
    if (!(tolower(model) %in% c("parafac", "parafac2", "pca"))) {
      stop("Input 'model' is not specified correctly. Input must be only one \n
           of either 'parafac', 'parafac2', or 'pca'.")
    }
    model <- tolower(model)
    if ((modes == 2) && (model != "pca")) {
      stop("Input 'modes' was set to 2, but input 'model' was not set to 'pca'.
           When modes is 2, model must be 'pca'.")
    }
    if (model == "pca") {n <- arraydim[1]} else {n <- arraydim[modes]}
    if ((modes != 2) && (model == "pca")) {
      stop("Input 'model' was set to 'pca', but input 'modes' was not set to 2.
           When model is 'pca', modes must be 2.")
    }
    if (model == "parafac2") {
      if (is.null(pf2num)) {
        if (!(is.null(Amat))) {
          if (length(Amat) != n) {
            stop(sprintf("When model = 'parafac2' and pf2num = NULL, 'Amat' \n 
                         must be a list of length %d (the last element of \n 
                         input 'arraydim').", n))
          }
          pf2num <- vapply(Amat, nrow, integer(1))
        } else {
          warning("Input 'pf2num' was NULL. 'pf2num' was set \n 
                  to 'rep(c(nfac + 1, nfac + 2, nfac + 3), \n 
                  length.out = arraydim[modes])'.")
          pf2num <- rep(c(nfac + 1, nfac + 2, nfac + 3), length.out = n)
        }
      } else {
        if (length(pf2num) != n) {
          stop("When provided, input 'pf2num' must have length equal to the \n  
               last value of input 'arraydim'.")
        }
        if (!(is.numeric(pf2num))) {stop("Input 'pf2num' must be numeric.")}
        if (any(is.na(pf2num) | is.nan(pf2num))) {
          stop("Input 'pf2num' must not contain NA or NaN values.")
        }
        if (any(!(is.finite(pf2num)))) {
          stop("Input 'pf2num' must contain finite values.")
        }
        if (any((pf2num < 2))) {
          stop("Input 'pf2num' must contain values of 2 or greater.")
        }
        if (any(pf2num != floor(pf2num))) {
          stop("Input 'pf2num' must contain integer values of 2 or greater.")
        }
        if (any(pf2num < nfac)) { 
          stop("Input 'pf2num' must contain integer values greater \n 
               than or equal to 'nfac'.")
        }
      }
    } else {
      if (!(is.null(pf2num))) {
        warning("Input 'pf2num' was provided, but model is not 'parafac2'. \n
                'pf2num' was ignored.")
      }
    }
    if (!(is.null(corrpred))) {
      if (!(is.matrix(corrpred))) {stop("Input 'corrpred' must be a matrix.")}
      if (any(is.na(corrpred)) || any(is.nan(corrpred))) {
        stop("Input 'corrpred' must not contain NA values.") 
      }
      if (!(all(dim(corrpred) == c(nfac, nfac)))) {
        stop("Input 'corrpred' must be a square matrix with dimensions equal \n 
             to 'nfac'.") 
      }
      if (!(all(diag(corrpred) == 1))) {
        stop("Input 'corrpred' must contain diagonal values of 1.") 
      }
      offdiag <- corrpred[!diag(nrow(corrpred))]
      if (any((offdiag < -1) | (offdiag > 1))) { 
        stop("Input 'corrpred' must contain off-diagonal elements between \n 
             -1 and 1, inclusive.") 
      }
      tcheck <- !(isSymmetric(corrpred))
      if (tcheck == TRUE) {
        stop("Input 'corrpred' must be a correlation matrix with lower \n
             triangular elements that correspond to its upper triangular \n 
             elements. In other words, it must be symmetric.")
      }
      evc <- eigen(corrpred, symmetric = TRUE)
      if (any(evc$values <= 1e-12)) { 
        stop("Input 'corrpred' is not positive definite. Provide a positive \n
             definite correlation matrix for 'corrpred'.") 
      }
    } else {
      corrpred <- matrix(0.2, nrow = nfac, ncol = nfac)
      diag(corrpred) <- 1
      evc <- eigen(corrpred, symmetric = TRUE)
    }
    if (!(is.list(technical))) {
      stop("Input 'technical' must be of class 'list' when provided.")
    }
    if (length(technical) != 0) {
      allowedkeys <- c("distA", "distB", "distC", "distG", "distE")
      if (is.null(names(technical))) {
        stop("Input 'technical', when provided, must contain valid named \n 
             lists.")
      }
      if (!(all(names(technical) %in% allowedkeys))) {
        stop("Input 'technical', when provided, can only contain one or more \n
             of the following: 'distA', 'distB', 'distC', 'distG' or 'distE'.")
      }
      if (length(technical) != length(unique(names(technical)))) {
        stop("Input 'technical', when provided, can only contain valid lists \n 
             once.")
      }
      for (nm in names(technical)) {
         innerlist <- technical[[nm]]
         if (!(is.list(innerlist))) {
           stop(sprintf("For '%s', the inner list for the input 'technical' \n
                        is not of class 'list'.", nm))
         }
         if (!(is.character(names(innerlist)[1]))) {
           stop(sprintf("For '%s', the inner list for the input 'technical' \n
                        does not have names that are of class 'character'.", 
                        nm))
         }
         if ((length(innerlist) == 0) || (names(innerlist)[1] != "dname")) {
           stop(sprintf("For '%s', the first element of the inner list for \n
                        the input 'technical' must be named 'dname'.", nm))
         }
      }
      finnam <- lapply(technical, function(x) x[1])
      fintech <- lapply(technical, function(x) x[-1])
      finlets <- sapply(names(technical), 
                        function(x) substr(x, nchar(x), nchar(x)))
    } else {
      finlets <- finnam <- NULL; fintech <- list()
    }
    if (!(is.null(Amat))) {
      if (model != "parafac2") {
        if (!(is.matrix(Amat))) {
          stop("Input 'Amat' must be a matrix when provided and when \n 
               model is 'parafac' or 'pca'.")
        }
        exparows <- if (model == "pca") arraydim[2] else arraydim[1]
        if (nrow(Amat) != exparows) {
          stop("Input 'Amat', when provided, must have number of rows equal \n 
                to the expected mode dimension, given the model.")
        }
        if (ncol(Amat) != nfac) {
          stop("Input 'Amat', when provided, must have number of columns \n
               equal to input 'nfac' when model is 'parafac' or 'pca'.")
        }
        if (!(is.numeric(Amat))) {
          stop("Input 'Amat', when provided, must be numeric.")
        }
      } else {
        if (!(is.list(Amat))) {
          stop("Input 'Amat', when provided and when model = 'parafac2', must \n
               be a list.")
        }
        if (length(Amat) < 2) {
          stop("Input 'Amat', when provided and when model = 'parafac2', \n 
               must contain at least two elements.")
        }
        if (length(Amat) != arraydim[modes]) {
          stop("Input 'Amat', when provided, must have length equal to \n
               the last value in input 'arraydim' when model = 'parafac2'.")
        }
        for (i in seq_along(Amat)) {
           if (!(is.matrix(Amat[[i]]))) {
             stop(sprintf("Element %d of 'Amat' is not a matrix. Provide a \n
                          matrix for all elements of 'Amat' when \n
                          model = 'parafac2' and when 'Amat' is provided.", i))
           }
           if (nrow(Amat[[i]]) < 2) {
             stop(sprintf("Element %d of 'Amat' has less than two rows. \n 
                          Provide a matrix with at least two rows for all \n
                          elements of 'Amat' when model = 'parafac2' and \n 
                          when 'Amat' is provided.", i))
           }
           if (nrow(Amat[[i]]) != pf2num[i]) {
             stop(sprintf("Element %d of 'Amat' has number of rows not equal \n
                          to the corresponding value in 'pf2num'. Provide \n 
                          a matrix in each element of 'Amat' with number of \n
                          rows that matches the corresponding value in input \n
                          'pf2num' when model = 'parafac2' and when 'Amat' is \n 
                          provided.", i))
           }
           if (ncol(Amat[[i]]) != nfac) {
             stop(sprintf("Element %d of 'Amat' must have number of columns \n
                          equal to input 'nfac'. Provide a matrix with number \n
                          of columns equal to 'nfac' for all elements of \n
                          'Amat' when model = 'parafac2' and when 'Amat' is \n 
                          provided.", i))
           }
           if (!(is.numeric(Amat[[i]]))) {
             stop(sprintf("Element %d of 'Amat' is not numeric. Provide a \n 
                          matrix with only real numbers for all elements \n
                          of 'Amat' when model = 'parafac2' and when 'Amat' \n 
                          is provided.", i))
           }
           if (!(all(is.finite(Amat[[i]])))) {
             stop(sprintf("Element %d of 'Amat' is not finite. Provide a \n 
                          matrix with only finite numbers for all elements \n
                          of 'Amat' when model = 'parafac2' and when 'Amat' \n 
                          is provided.", i))
           }
        }
      }
    }
    errprov <- FALSE
    if (!(is.null(Emat))) {
      errprov <- TRUE
      if (model == "parafac") {
        if ((!(is.array(Emat))) || is.matrix(Emat)) {
          stop("Input 'Emat' must be a 3-way or 4-way array when provided and \n
               when model = 'parafac'.")
        }
        if (!(all(dim(Emat) == arraydim))) {
          stop("Input 'Emat', when provided, must have dimensions equal to \n
               those in input 'arraydim' when model = 'parafac'.")
        }
        if (!(is.numeric(Emat))) {
          stop("Input 'Emat', when provided, must be numeric.")
        }
      } else if (model == "pca") {
        if (!(is.matrix(Emat))) {
          stop("Input 'Emat' must be a matrix when provided and when \n 
               model = 'pca'.")
        }
        if (!(all(dim(Emat) == arraydim))) {
          stop("Input 'Emat', when provided, must have dimensions equal to \n
               those in input 'arraydim' when model = 'pca'.")
        }
        if (!(is.numeric(Emat))) {
          stop("Input 'Emat', when provided, must be numeric.")
        }
      } else {
        if (!(is.list(Emat))) {
          stop("Input 'Emat', when provided and when model = 'parafac2', must \n
               be a list.")
        }
        if (length(Emat) < 2) {
          stop("Input 'Emat', when provided and when model = 'parafac2', \n 
               must contain at least two elements.")
        }
        if (length(Emat) != arraydim[modes]) {
          stop("Input 'Emat', when provided and when model = 'parafac2', \n
               must have length equal to the last value in 'arraydim'.")
        }
        for (i in seq_along(Emat)) {
           if (modes == 3) {
             if (!(is.matrix(Emat[[i]]))) {
               stop(sprintf("Element %d of 'Emat' is not a matrix. Provide a \n
                            matrix for all elements of 'Emat' when \n
                            model = 'parafac2', when 'Emat' is provided, and \n
                            when modes = 3.", i))
             }
             if (nrow(Emat[[i]]) != pf2num[i]) {
               stop(sprintf("Element %d of 'Emat' has number of rows not \n
                            equal to the corresponding value in 'pf2num'. \n 
                            Provide a matrix in each element of 'Emat' with \n
                            number of rows that matches the corresponding \n
                            value in input 'pf2num' when model = 'parafac2', \n 
                            when 'Emat' is provided, and when modes = 3.", i))
             }
             if (ncol(Emat[[i]]) != arraydim[2]) {
               stop(sprintf("Element %d of 'Emat' must have number of columns \n
                            equal to the second element of input 'arraydim'. \n 
                            Provide a matrix with number of columns equal to \n 
                            the second element of input 'arraydim' for all \n 
                            elements of 'Emat' when model = 'parafac2', when \n 
                            'Emat' is provided, and when modes = 3.", i))
             }
             if (!(is.numeric(Emat[[i]]))) {
               stop(sprintf("Element %d of 'Emat' is not numeric. Provide a \n
                            matrix with only real numbers for all elements of \n
                            'Emat' when model = 'parafac2', when 'Emat' is \n 
                            provided, and when modes = 3.", i))
             }
             if (!(all(is.finite(Emat[[i]])))) {
               stop(sprintf("Element %d of 'Emat' is not finite. Provide a \n 
                            matrix with only finite numbers for all elements \n
                            of 'Emat' when model = 'parafac2', when 'Emat' \n 
                            is provided, and when modes = 3.", i))
             }
           } else {
             if (!(is.array(Emat[[i]]))) {
               stop(sprintf("Element %d of 'Emat' is not an array. Provide a \n
                            three-way array for all elements of 'Emat' when \n
                            model = 'parafac2', when 'Emat' is provided, and \n
                            when modes = 4.", i))
             }
             if (length(dim(Emat[[i]])) != 3) {
               stop(sprintf("Element %d of 'Emat' must be a three-way array \n
                            when model = 'parafac2', when 'Emat' is provided, \n
                            and when modes = 4.", i))
             }
             if (any(dim(Emat[[i]]) < 2)) {
               stop(sprintf("Element %d of 'Emat' has an array dimension of \n 
                            less than two levels. Provide an array with \n
                            dimensions of at least 2 for all dimensions of \n 
                            'Emat' when model = 'parafac2', when 'Emat' is \n 
                            provided, and when modes = 4.", i))
             } 
             if (!(is.numeric(Emat[[i]]))) {
               stop(sprintf("Element %d of 'Emat' is not numeric. Provide an \n
                            array with only real numbers for all elements of \n
                            'Emat' when model = 'parafac2', when 'Emat' is \n 
                            provided, and when modes = 4.", i))
             }
             if (!(all(is.finite(Emat[[i]])))) {
               stop(sprintf("Element %d of 'Emat' is not finite. Provide an \n 
                            array with only finite numbers for all elements \n
                            of 'Emat' when model = 'parafac2', when 'Emat' \n 
                            is provided, and when modes = 4.", i))
             }
             if (dim(Emat[[i]])[1] != pf2num[i]) {
               stop(sprintf("Element %d of 'Emat' has first dimension number \n
                            of levels not equal to the corresponding value in \n 
                            'pf2num'. Provide an array in each element of \n
                            'Emat' whose first dimension has number of levels \n 
                            that matches the corresponding value in input \n 
                            'pf2num' when model = 'parafac2', when 'Emat' is \n 
                            provided, and when modes = 4.", i))
             }
             if (dim(Emat[[i]])[2] != arraydim[2]) {
               stop(sprintf("Element %d of 'Emat' has second dimension number \n 
                            of levels not equal to the corresponding value in \n 
                            input 'arraydim'.", i))
             }
             if (dim(Emat[[i]])[3] != arraydim[3]) {
               stop(sprintf("Element %d of 'Emat' has third dimension number \n 
                            of levels not equal to the corresponding value in \n 
                            input 'arraydim'.", i))
             }
           }
        }
      }
    }
    cmodesup <- FALSE
    if (!(is.null(Bmat))) {
      if (!(is.matrix(Bmat))) {
        stop("Input 'Bmat', when provided, must be a matrix.")
      }
      expbrows <- if (model == "pca") arraydim[1] else arraydim[2]
      if (nrow(Bmat) != expbrows) {
        stop("Input 'Bmat', when provided, must have number of rows equal to \n 
              the expected mode dimension, given the model.")
      }
      if (ncol(Bmat) != nfac) {
        stop("Input 'Bmat', when provided, must have number of columns \n
             equal to input 'nfac'.")
      }
      if (!(is.numeric(Bmat))) {
        stop("Input 'Bmat', when provided, must contain only real numbers.")
      }
      if (!(all(is.finite(Bmat)))) {
        stop("Input 'Bmat', when provided, must contain only finite numbers.")
      }
      if (modes == 2) {
        cmodesup <- TRUE
        if (any(apply(Bmat, 2, var) == 0)) {
          stop("Input 'Bmat', when provided as a classification mode weights \n
                matrix, must have a non-zero variance for each column.")
        }
      }
    }
    if (!(is.null(Cmat))) {
      if (modes < 3) {
        Cmat <- NULL
        warning("Input 'Cmat' was provided but was ignored because modes is 2.")
      } else {
        if (!(is.matrix(Cmat))) {
          stop("Input 'Cmat', when provided, must be a matrix.")
        }
        if (nrow(Cmat) != arraydim[3]) {
          stop("Input 'Cmat', when provided, must have number of rows \n 
               equal to the third value in 'arraydim'.")
        }
        if (ncol(Cmat) != nfac) {
          stop("Input 'Cmat', when provided, must have number of columns \n 
               equal to input 'nfac'.")
        }
        if (!(is.numeric(Cmat))) {
          stop("Input 'Cmat', when provided, must be numeric.")
        }
        if (!(all(is.finite(Cmat)))) {
          stop("Input 'Cmat', when provided, must contain only finite numbers.")
        }
        if (modes == 3) {
          cmodesup <- TRUE
          if (any(apply(Cmat, 2, var) == 0)) {
            stop("Input 'Cmat', when provided as a classification mode \n
                 weights matrix, must have a non-zero variance for \n 
                 each column.")
          }
        }
      }
    }
    if (!(is.null(Dmat))) {
      if (modes == 4) {
        cmodesup <- TRUE
        if (!(is.matrix(Dmat))) {
          stop("Input 'Dmat', when provided, must be a matrix.")
        }
        if (nrow(Dmat) != arraydim[4]) {
          stop("Input 'Dmat', when provided, must have number of rows equal \n 
               to the fourth value in 'arraydim'.")
        }
        if (ncol(Dmat) != nfac) {
          stop("Input 'Dmat', when provided, must have number of columns \n 
               equal to input 'nfac'.")
        }
        if (!(is.numeric(Dmat))) {
          stop("Input 'Dmat', when provided, must be numeric.")
        }
        if (!(all(is.finite(Dmat)))) {
          stop("Input 'Dmat', when provided, must contain only finite numbers.")
        }
        if (any(apply(Dmat, 2, var) == 0)) {
          stop("Input 'Dmat', when provided as a classification mode weights \n
               matrix, must have a non-zero variance for each column.")
        }
      } else {
        Dmat <- NULL
        warning("Input 'Dmat' was provided but was ignored because modes = 3.")
      }
    }
    if (model %in% c("parafac", "pca")) {
      if (!(is.null(Gmat))) {
        Gmat <- NULL
        warning(sprintf("Gmat was provided but was ignored because \n 
                        model = '%s'.", model))
      }
    } else {
      if (!(is.null(Gmat))) {
        if (!(is.matrix(Gmat))) {
          stop("Input 'Gmat' must be a matrix when provided and when \n
               model = 'parafac2'.")
        }
        if (nrow(Gmat) != nfac) {
          stop("Input 'Gmat', when provided and when model = 'parafac2', must \n 
               have number of rows equal to input 'nfac'.")
        }
        if (ncol(Gmat) != nfac) {
          stop("Input 'Gmat', when provided and when model = 'parafac2', must \n 
               have number of columns equal to input 'nfac'.")
        }
        if (!(is.numeric(Gmat))) {
          stop("Input 'Gmat', when provided, must be numeric.")
        }
        if (!(all(is.finite(Gmat)))) {
          stop("Input 'Gmat', when provided, must contain only finite numbers.")
        }
      }
    }
    finalletters <- c()
    if (!(is.null(Amat))) {finalletters <- c(finalletters, 
                                             substr("Amat", 1, 1))}
    if (!(is.null(Bmat))) {finalletters <- c(finalletters, 
                                             substr("Bmat", 1, 1))}
    if (!(is.null(Cmat))) {finalletters <- c(finalletters, 
                                             substr("Cmat", 1, 1))}
    if (!(is.null(Dmat))) {finalletters <- c(finalletters, 
                                             substr("Dmat", 1, 1))}
    if ((model == "parafac2") && (!(is.null(Gmat)))) {
      finalletters <- c(finalletters, substr("Gmat", 1, 1))
    }
    if (!(is.null(Emat))) {finalletters <- c(finalletters, 
                                             substr("Emat", 1, 1))}
    if (!(is.null(finlets))) {
      conflict <- intersect(finalletters, finlets)
      if (length(conflict) > 0) {
        warning(sprintf("Mode(s) '%s' had both weights and distribution \n 
                        information provided. Provided weights were used and \n
                        provided distribution information was ignored.", 
                        paste(conflict, collapse = ", ")))
        outdex <- which(finlets %in% conflict)
        distnam <- finnam[-outdex]; disttech <- fintech[-outdex]
        distmodes <- finlets[-outdex]
      } else {
        distnam <- finnam; disttech <- fintech; distmodes <- finlets
      }
    } else {
      distnam <- finnam; disttech <- fintech; distmodes <- finlets
    } 
    storXout <- storYout <- NULL; stordatout <- Inf; warnflag <- FALSE; 
    sdfact <- 1
    if (smethod == "logistic") {
      Sigma.sqrt <- evc$vectors %*% diag(sqrt(evc$values)) %*% t(evc$vectors) 
      mum <- as.matrix(meanpred)
      if (cmodesup == TRUE) {
        if (onreps != 1) {
          if (modes == 2) {
            warning("Input 'onreps' was reduced to 1 because a classification \n
                    mode weights matrix 'Bmat' was provided.")
          } else if (modes == 3) {
            warning("Input 'onreps' was reduced to 1 because a classification \n
                    mode weights matrix 'Cmat' was provided.")
          } else {
            warning("Input 'onreps' was reduced to 1 because a classification \n
                    mode weights matrix 'Dmat' was provided.")
          }
          onreps <- 1
        }
      }
      for (j in 1:onreps) {
         storY <- storX <- bbest <- NULL; stordat <- Inf
         if (cmodesup == FALSE) {
           Z <- matrix(rnorm(n * nfac), nrow = n, ncol = nfac)
           Xq <- matrix(1, n, 1) %*% t(mum) + Z %*% Sigma.sqrt
         } else {
           if (modes == 2) {
             Xq <- Bmat
           } else if (modes == 3) {
             Xq <- Cmat
           } else {
             Xq <- Dmat
           }
         }
         for (i in 1:nreps) {
            if (nclass == 2) {
              if (is.null(bbest)) {
                beta <- matrix(runif(nfac, -1, 1), nrow = nfac)
              } else {
                if (runif(1) < 0.05) {
                  beta <- matrix(runif(nfac, -1, 1), nrow = nfac)
                } else {
                  beta <- matrix(rnorm(nfac, mean = bbest, sd = sdfact), 
                                 nrow = nfac)
                }
              }
              linpred <- scale(Xq %*% beta) + qlogis(props[2])
              pro <- 1 / (1 + exp(-linpred))
              Y <- rbinom(n, 1, pro)
            } else {
              if (is.null(bbest)) {
                beta <- matrix(runif((nfac * nclass), -1, 1), nrow = nfac)
              } else {
                if (runif(1) < 0.05) {
                  beta <- matrix(runif((nfac * nclass), -1, 1), nrow = nfac)
                } else {
                  beta <- matrix(rnorm((nfac * nclass), mean = as.vector(bbest), 
                                       sd = sdfact), nrow = nfac)
                }
              }
              linpred <- scale(Xq %*% beta)
              linpred <- sweep(linpred, 2, log(props), "+")
              pro <- t(apply(linpred, 1, function(x) exp(x) / sum(exp(x))))
              Y <- apply(pro, 1, function(p) sample(1:nclass, 
                                                    size = 1, prob = p)) - 1
            }
            if (length(unique(Y)) == 1) {warnflag <- TRUE; next}
            outcome <- sum(abs(corresp - cor(Xq, Y)))
            simdat <- list(outcome = outcome, Y = Y, Xq = Xq)
            outdat <- simdat$outcome
            if (outdat < stordat) {
              stordat <- outdat; storY <- simdat$Y; storX <- simdat$Xq
              bbest <- beta
            }
         }
         sdfact <- sdfact * 0.95
         if (stordat < stordatout) {
           stordatout <- stordat; storYout <- as.matrix(storY)
           storXout <- storX
         }
      }
    } else {
      cumprobs <- c(0, cumsum(props))
      if (cmodesup == TRUE) {
        if (modes == 2) {
          storXout <- Bmat
        } else if (modes == 3) {
          storXout <- Cmat
        } else {
          storXout <- Dmat
        }
        betasim <- matrix(corresp, ncol = 1) 
        linpred <- scale(storXout %*% betasim)
        linpred <- linpred + rnorm(length(linpred), mean = 0, sd = 1e-8)
        breaks <- quantile(linpred, probs = cumprobs)
        if (any(duplicated(breaks))) {breaks <- unique(breaks)} 
        storYout <- matrix(as.integer(cut(linpred, breaks = breaks, 
                                          include.lowest = TRUE)) - 1, ncol = 1)
      } else {
        yvals <- 0:(nclass - 1)
        vary <- sum((yvals - sum(yvals * props))^2 * props)
        correction <- sqrt(vary) / sum(dnorm(qnorm(cumsum(props)[-nclass])))
        correspadj <- pmin(pmax(corresp * correction, -0.99), 0.99)
        Sigjoint <- diag(nfac + 1)
        Sigjoint[1:nfac, 1:nfac] <- corrpred
        Sigjoint[1:nfac, nfac + 1] <- correspadj
        Sigjoint[nfac + 1, 1:nfac] <- correspadj
        evj <- eigen(Sigjoint, symmetric = TRUE)
        if (any(evj$values < -1e-8)) {
          stop("Requested correlations are impossible.")
        }
        L <- evj$vectors %*% diag(sqrt(pmax(evj$values, 0))) %*% t(evj$vectors)
        rawdats <- matrix(rnorm(n * (nfac + 1)), nrow = n) %*% L
        storXout <- sweep(rawdats[, 1:nfac, drop = FALSE], 2, 
                          as.matrix(meanpred), "+")
        ylat <- rawdats[, nfac + 1]
        breaks <- unique(quantile(ylat, probs = cumprobs))
        storYout <- matrix(as.integer(cut(ylat, breaks = breaks, 
                                          include.lowest = TRUE)) - 1, ncol = 1)
      }
    }
    if (warnflag == TRUE) warning("At least one simulation had zero variance \n
                                  in outcome.")
    if (is.null(storXout)) stop("Component weights were not simulated.")
    if (is.null(storYout)) {
      stop("Failed to simulate class labels after 'nreps' attempts. Check for \n 
           extreme values in 'props' or for impossible target correlations \n 
           in 'corresp'.")
    }
    y <- factor(as.vector(storYout))
    if (is.null(Bmat) && (model != "pca")) {
      if ("B" %in% distmodes) {
        dsupply <- sapply(names(disttech), 
                          function(x) substr(x, nchar(x), nchar(x)))
        techindex <- which("B" == dsupply)
        bvals <- distdraw(dname = distnam[[techindex]]$dname, 
                          n = (arraydim[2] * nfac), modes = "B",
                          params = disttech[[techindex]])
      } else {
        bvals <- distdraw(dname = "normal", n = (arraydim[2] * nfac), 
                          modes = "B", params = NULL)
      }
      Bmat <- matrix(bvals, nrow = arraydim[2], ncol = nfac)
    }
    if ((modes == 3) && (model == "parafac")) {
      if (is.null(Amat)) {
        if ("A" %in% distmodes) {
          dsupply <- sapply(names(disttech), 
                            function(x) substr(x, nchar(x), nchar(x)))
          techindex <- which("A" == dsupply)
          avals <- distdraw(dname = distnam[[techindex]]$dname,
                            n = (arraydim[1] * nfac), modes = "A",
                            params = disttech[[techindex]])
        } else {
          avals <- distdraw(dname = "normal", n = (arraydim[1] * nfac), 
                            modes = "A", params = NULL)
        }
        Amat <- matrix(avals, nrow = arraydim[1], ncol = nfac)
      }
      Cmat <- storXout; Xmat <- tcrossprod(Amat, krprod(Cmat, Bmat))
      Xmat <- array(Xmat, dim = arraydim)
      if (errprov == FALSE) {
        if ("E" %in% distmodes) {
          dsupply <- sapply(names(disttech), 
                            function(x) substr(x, nchar(x), nchar(x)))
          techindex <- which("E" == dsupply)
          evals <- distdraw(dname = distnam[[techindex]]$dname, 
                            n = (prod(arraydim)), modes = "E",
                            params = disttech[[techindex]])
        } else {
          evals <- distdraw(dname = "normal", n = (prod(arraydim)), modes = "E", 
                            params = NULL)
        }
        Emat <- array(evals, dim = arraydim)
      }
      X <- Xmat + Emat
      dataout <- list(X = X, y = y, model = model, Amat = Amat, Bmat = Bmat, 
                      Cmat = Cmat, Emat = Emat)
    } else if ((modes == 3) && (model == "parafac2")) {
      if (is.null(Gmat)) {
        if ("G" %in% distmodes) {
          dsupply <- sapply(names(disttech), 
                            function(x) substr(x, nchar(x), nchar(x)))
          techindex <- which("G" == dsupply)
          gvals <- distdraw(dname = distnam[[techindex]]$dname, modes = "G",
                            n = (nfac * nfac), params = disttech[[techindex]])
        } else {
          gvals <- distdraw(dname = "normal", n = (nfac * nfac), modes = "G", 
                            params = NULL)
        }
        Gmat <- matrix(gvals, nrow = nfac, ncol = nfac)
      }
      Cmat <- storXout; nDd <- pf2num
      if (is.null(Amat)) { 
        Amat <- Amat0 <- vector("list", n)
        for (Dd in 1:n) {
           if ("A" %in% distmodes) {
             dsupply <- sapply(names(disttech), 
                               function(x) substr(x, nchar(x), nchar(x)))
             techindex <- which("A" == dsupply)
             avals <- distdraw(dname = distnam[[techindex]]$dname, 
                               n = (nDd[Dd] * nfac), modes = "A",
                               params = disttech[[techindex]])
           } else {
             avals <- distdraw(dname = "normal", n = (nDd[Dd] * nfac), 
                               modes = "A", params = NULL)
           }
           Amat[[Dd]] <- Amat0[[Dd]] <- matrix(avals, nrow = nDd[Dd], 
                                               ncol = nfac)
           Amat[[Dd]] <- svd(Amat[[Dd]], nv = 0)$u %*% Gmat
        }
      }
      Xmat <- vector("list", n)
      if (errprov == FALSE) {Emat <- vector("list", n)}
      for (Dd in 1:n) {
         if (nfac == 1) {
           Xmat[[Dd]] <- tcrossprod(Amat[[Dd]] %*% as.matrix(Cmat[Dd, ]), Bmat)
         } else {
           Xmat[[Dd]] <- tcrossprod(Amat[[Dd]] %*% diag(Cmat[Dd, ]), Bmat)
         }
         if (errprov == FALSE) {
           if ("E" %in% distmodes) {
             dsupply <- sapply(names(disttech), 
                               function(x) substr(x, nchar(x), nchar(x)))
             techindex <- which("E" == dsupply)
             evals <- distdraw(dname = distnam[[techindex]]$dname, 
                               n = (nDd[Dd] * arraydim[2]), modes = "E",
                               params = disttech[[techindex]])
           } else {
             evals <- distdraw(dname = "normal", n = (nDd[Dd] * arraydim[2]), 
                               modes = "E", params = NULL)
           }
           Emat[[Dd]] <- matrix(evals, nrow = nDd[Dd], ncol = arraydim[2])
         }
      }
      X <- mapply("+", Xmat, Emat, SIMPLIFY = FALSE)
      dataout <- list(X = X, y = y, model = model, Gmat = Gmat, Amat = Amat, 
                      Bmat = Bmat, Cmat = Cmat, Emat = Emat)
    } else if ((modes == 4) && (model == "parafac")) { 
      if (is.null(Amat)) {
        if ("A" %in% distmodes) {
          dsupply <- sapply(names(disttech), 
                            function(x) substr(x, nchar(x), nchar(x)))
          techindex <- which("A" == dsupply)
          avals <- distdraw(dname = distnam[[techindex]]$dname, 
                            n = (arraydim[1] * nfac), modes = "A",
                            params = disttech[[techindex]])
        } else {
          avals <- distdraw(dname = "normal", n = (arraydim[1] * nfac), 
                            modes = "A", params = NULL)
        }
        Amat <- matrix(avals, nrow = arraydim[1], ncol = nfac)
      }
      if (is.null(Cmat)) {
        if ("C" %in% distmodes) {
          dsupply <- sapply(names(disttech), 
                            function(x) substr(x, nchar(x), nchar(x)))
          techindex <- which("C" == dsupply)
          cvals <- distdraw(dname = distnam[[techindex]]$dname, 
                            n = (arraydim[3] * nfac), modes = "C",
                            params = disttech[[techindex]])
        } else {
          cvals <- distdraw(dname = "normal", n = (arraydim[3] * nfac), 
                            modes = "C", params = NULL)
        }
        Cmat <- matrix(cvals, nrow = arraydim[3], ncol = nfac)
      }
      Dmat <- storXout; Xmat <- tcrossprod(Amat, 
                                           krprod(Dmat, krprod(Cmat, Bmat)))
      Xmat <- array(Xmat, dim = arraydim)
      if (errprov == FALSE) {
        if ("E" %in% distmodes) {
          dsupply <- sapply(names(disttech), 
                            function(x) substr(x, nchar(x), nchar(x)))
          techindex <- which("E" == dsupply)
          evals <- distdraw(dname = distnam[[techindex]]$dname, 
                            n = (prod(arraydim)), modes = "E",
                            params = disttech[[techindex]])
        } else {
          evals <- distdraw(dname = "normal", n = (prod(arraydim)), modes = "E", 
                            params = NULL)
        }
        Emat <- array(evals, dim = arraydim)
      }
      X <- Xmat + Emat
      dataout <- list(X = X, y = y, model = model, Amat = Amat, Bmat = Bmat, 
                      Cmat = Cmat, Dmat = Dmat, Emat = Emat)
    } else if ((modes == 4) && (model == "parafac2")) {
      if (is.null(Gmat)) {
        if ("G" %in% distmodes) {
          dsupply <- sapply(names(disttech), 
                            function(x) substr(x, nchar(x), nchar(x)))
          techindex <- which("G" == dsupply)
          gvals <- distdraw(dname = distnam[[techindex]]$dname, modes = "G",
                            n = (nfac * nfac), params = disttech[[techindex]]) 
        } else {
          gvals <- distdraw(dname = "normal", n = (nfac * nfac), modes = "G",
                            params = NULL)
        }
        Gmat <- matrix(gvals, nrow = nfac, ncol = nfac)
      }
      if (is.null(Cmat)) {
        if ("C" %in% distmodes) {
          dsupply <- sapply(names(disttech), 
                            function(x) substr(x, nchar(x), nchar(x)))
          techindex <- which("C" == dsupply)
          cvals <- distdraw(dname = distnam[[techindex]]$dname,  
                            n = (arraydim[3] * nfac), modes = "C",
                            params = disttech[[techindex]])
        } else {
          cvals <- distdraw(dname = "normal", n = (arraydim[3] * nfac), 
                            modes = "C", params = NULL)
        }
        Cmat <- matrix(cvals, nrow = arraydim[3], ncol = nfac)
      }
      Dmat <- storXout; nDd <- pf2num
      if (is.null(Amat)) { 
        Amat <- Amat0 <- vector("list", n)
        for (Dd in 1:n) {
           if ("A" %in% distmodes) {
             dsupply <- sapply(names(disttech), 
                               function(x) substr(x, nchar(x), nchar(x)))
             techindex <- which("A" == dsupply)
             avals <- distdraw(dname = distnam[[techindex]]$dname, 
                               n = (nDd[Dd] * nfac), modes = "A",
                               params = disttech[[techindex]])
           } else {
             avals <- distdraw(dname = "normal", n = (nDd[Dd] * nfac), 
                               modes = "A", params = NULL)
           }
           Amat[[Dd]] <- Amat0[[Dd]] <- matrix(avals, nrow = nDd[Dd], 
                                               ncol = nfac)
           Amat[[Dd]] <- svd(Amat[[Dd]], nv = 0)$u %*% Gmat
        }
      }
      X <- Xmat <- vector("list", n)
      if (errprov == FALSE) {Emat <- X}
      for (Dd in 1:n) {
         if (nfac == 1) {
           leftMat <- Amat[[Dd]] %*% as.matrix(Dmat[Dd, ])
         } else {
           leftMat <- Amat[[Dd]] %*% diag(Dmat[Dd, ])
         }
         Xmat[[Dd]] <- array(tcrossprod(leftMat, krprod(Cmat, Bmat)), 
                             dim = c(nDd[Dd], arraydim[2], arraydim[3]))
         if (errprov == FALSE) {
           if ("E" %in% distmodes) {
             dsupply <- sapply(names(disttech), 
                               function(x) substr(x, nchar(x), nchar(x)))
             techindex <- which("E" == dsupply)
             evals <- distdraw(dname = distnam[[techindex]]$dname, 
                               n = (nDd[Dd] * arraydim[2] * arraydim[3]), 
                               modes = "E", params = disttech[[techindex]])
           } else {
             evals <- distdraw(dname = "normal", 
                               n = (nDd[Dd] * arraydim[2] * arraydim[3]), 
                               modes = "E", params = NULL)
           }
           Emat[[Dd]] <- array(evals, dim = c(nDd[Dd], arraydim[2], 
                                              arraydim[3]))
         }
         X[[Dd]] <- Xmat[[Dd]] + Emat[[Dd]]
      }
      dataout <- list(X = X, y = y, model = model, Gmat = Gmat, Amat = Amat, 
                      Bmat = Bmat, Cmat = Cmat, Dmat = Dmat, Emat = Emat)
    } else {
      Bmat <- storXout
      if (is.null(Amat)) {
        if ("A" %in% distmodes) {
          dsupply <- sapply(names(disttech), 
                            function(x) substr(x, nchar(x), nchar(x)))
          techindex <- which("A" == dsupply)
          avals <- distdraw(dname = distnam[[techindex]]$dname, 
                            n = (arraydim[2] * nfac), modes = "A",
                            params = disttech[[techindex]])
        } else {
          avals <- distdraw(dname = "normal", n = (arraydim[2] * nfac), 
                            modes = "A", params = NULL)
        }
        Amat <- matrix(avals, nrow = arraydim[2], ncol = nfac)
      }
      Xmat <- tcrossprod(Bmat, Amat)
      if (errprov == FALSE) {
        if ("E" %in% distmodes) {
          dsupply <- sapply(names(disttech), 
                            function(x) substr(x, nchar(x), nchar(x)))
          techindex <- which("E" == dsupply)
          evals <- distdraw(dname = distnam[[techindex]]$dname, 
                            n = (arraydim[1] * arraydim[2]), modes = "E",
                            params = disttech[[techindex]])
        } else {
          evals <- distdraw(dname = "normal", n = (arraydim[1] * arraydim[2]), 
                            modes = "E", params = NULL)
        }
        Emat <- matrix(evals, nrow = arraydim[1], ncol = arraydim[2])
      }
      X <- Xmat + Emat
      dataout <- list(X = X, y = y, model = model, Amat = Amat, Bmat = Bmat, 
                      Emat = Emat)
    }
    return(dataout)
}

kcv.plr <-
  function(x, y, foldid = NULL, alpha, nfolds = NULL, 
           family = c("binomial", "multinomial"), offset = NULL, lambda = NULL, 
           weights = NULL, standardize = FALSE, grouped = TRUE, keep = FALSE, 
           parallel = FALSE, maxit = 1e6) 
{
    kcvcheck(y = y, nfolds = nfolds, parallel = parallel, foldid = foldid)
    lalpha <- length(alpha)
    cvlist <- vector("list", lalpha)
    if (ncol(x) == 1) {x <- cbind(0, x)}
    if (nfolds == 2) {
      if (is.null(weights)) {
        frac <- table(y) / length(y)
        names(frac) <- seq_along(levels(as.factor(y))) - 1
        wtemp <- as.numeric(frac[y])
        weights <- 1 / (wtemp * (length(y) / sum(wtemp)))
      }
      if (family == "binomial") {threshold <- 0.5}
      stor.cvm <- rep(NA, lalpha)
      stor.minlam <- rep(NA, lalpha)
      for (h in 1:lalpha) {
         v.alpha <- alpha[h]
         x1 <- x[foldid == 1, ]
         x2 <- x[foldid == 2, ]
         y1 <- y[foldid == 1]
         y2 <- y[foldid == 2]
         fweight <- cbind(foldid, weights)
         weight1 <- fweight[which(fweight[, 1] == 1), 2]
         weight2 <- fweight[which(fweight[, 1] == 2), 2]
         cvlist[[h]] <- fit0 <- glmnet(x, y, family = family, weights = weights, 
                                       alpha = v.alpha)
         if (is.null(lambda)) {
           lam <- fit0$lambda
           nlam <- length(fit0$lambda)
         }
         if (!is.null(lambda)) {
           lam <- lambda
           nlam <- length(lambda)
         }
         fit1 <- glmnet(x1, y1, family = family, lambda = lam, alpha = v.alpha, 
                        weights = weight1)
         fit2 <- glmnet(x2, y2, family = family, lambda = lam, alpha = v.alpha, 
                        weights = weight2)
         pred1 <- predict(fit2, newx = x1, type = "response")
         pred2 <- predict(fit1, newx = x2, type = "response")
         cvm <- rep(NA, nlam)
         for (i in 1:nlam) {
            if (family == "binomial") {
              class1 <- as.numeric(pred1[, i] > threshold)
              class2 <- as.numeric(pred2[, i] > threshold)
              precvm <- ((1 - mean(class1 == y1)) + (1 - mean(class2 == y2)))
              cvm[i] <- precvm / 2
            }
            if (family == "multinomial") {
              class1 <- as.numeric((apply(pred1[, , i], 1, which.max))) - 1
              class2 <- as.numeric((apply(pred2[, , i], 1, which.max))) - 1
              precvm <- ((1 - mean(class1 == y1)) + (1 - mean(class2 == y2)))
              cvm[i] <- precvm / 2
            }
         }
         minid <- which.min(cvm)
         mincv <- cvm[minid]
         stor.cvm[h] <- mincv
         stor.minlam[h] <- minlam <- fit0$lambda[minid]
      }
      minid <- which.min(stor.cvm)
      minlam <- stor.minlam[minid]
      mincv <- stor.cvm
      return(list(alpha.id = minid, plr.fit = cvlist[[minid]], 
                  error = mincv[minid], lambda.min = minlam))
    } else {
      for (h in 1:lalpha) {
         cvlist[[h]] <- cv.glmnet(x, y, family = family, offset = offset,
                                  weights = weights, type.measure = "class", 
                                  nfolds = nfolds, foldid = foldid, 
                                  alpha = alpha[h], lambda = lambda, 
                                  grouped = grouped, keep = keep, 
                                  parallel = parallel, maxit = maxit, 
                                  standardize = standardize)
      }
      mincv <- sapply(cvlist, function(x) min(x$cvm))
      minid <- which.min(mincv)
      return(list(alpha.id = minid, plr.fit = cvlist[[minid]],
                  error = mincv[minid]))
    } 
}

cpfa <-
  function(x, y, z = NULL, model = c("parafac", "parafac2", "pca"), nfac = 1,
           nrep = 5, ratio = 0.8, nfolds = 10,
           method = c("PLR", "SVM", "RF", "NN", "RDA", "GBM"),
           family = c("binomial", "multinomial"), parameters = list(),
           type.out = c("measures", "descriptives"), foldid = NULL,
           prior = NULL, cmode = NULL, seeds = NULL, plot.out = FALSE,
           plot.measures = NULL, parallel = FALSE, cl = NULL,
           verbose = TRUE, compscale = TRUE, pcarot = c("unrotated", "varimax"),
           ...)
{
    permflag <- FALSE
    models <- c("parafac", "parafac2", "pca")
    model0 <- sum(tolower(model) %in% models)
    if ((model0 == 0L) || (model0 > 1L)) {
      stop("Input 'model' not specified correctly. Input must be one of \n
           either 'parafac', 'parafac2', or 'pca'.")
    }
    model <- tolower(model)
    flattened <- NULL
    if (is.array(x) && (!(is.matrix(x))) && (model %in% c("parafac", "pca"))) {
      xdim <- origdim <- dim(x)                             
      lxdim <- length(xdim)
      if (!((lxdim == 3L) || (lxdim == 4L))) {
        stop("Input 'x' must be a 3-way or 4-way array.")
      }
      if (any(is.nan(x)) || any(is.infinite(x))) {
        stop("Input 'x' cannot contain NaN or Inf values.")
      }
      if (any(is.na(x))) {stop("Input 'x' cannot contain missing values.")}
      if (!(is.null(cmode))) {
        if (!(cmode %in% (1:lxdim))) {
          stop("Input 'cmode' must be 1, 2, or 3 (or 4 if 'x' is 4-way).")
        }
        if (model == "parafac") {
          modeval <- 1:lxdim
          mode.re <- c(modeval[-cmode], cmode)
          x <- aperm(x, mode.re)
          xdim <- dim(x)
          permflag <- TRUE
        } else {
          modeval <- 1:lxdim
          mode.re <- c(cmode, modeval[-cmode])
          x <- matrix(aperm(x, mode.re), nrow = xdim[cmode])
          xdim <- dim(x)
          lxdim <- length(xdim)
          flattened <- TRUE
        }
      } else {
        cmode <- lxdim
        if (model == "pca") {
          modeval <- 1:lxdim
          mode.re <- c(cmode, modeval[-cmode])
          x <- matrix(aperm(x, mode.re), nrow = xdim[cmode])
          xdim <- dim(x)
          lxdim <- length(xdim)
          flattened <- TRUE
          if (length(y) != dim(x)[1]) {
            stop("Input 'x' was a 3-way or 4-way array, and model was 'pca'. \n 
                 Input 'y' had a length different from the last mode of 'x'. \n 
                 When 'x' is a 3-way or 4-way array, and when model is 'pca', \n 
                 the last mode must be the classification mode. Consider \n 
                 permuting the array.")
          }
        }
      }
    } else if (is.array(x) && (!(is.matrix(x))) && (model == "parafac2")) {
      xdim <- dim(x)                             
      lxdim <- length(xdim)
      if (!((lxdim == 3L) || (lxdim == 4L))) {
        stop("Input 'x' must be a 3-way or 4-way array.")
      }
      if (any(is.nan(x)) || any(is.infinite(x))) {
        stop("Input 'x' cannot contain NaN or Inf values.")
      }
      if (any(is.na(x))) {stop("Input 'x' cannot contain missing values.")}
      if (!(is.null(cmode))) {
        cmode <- lxdim
        warning("Input 'cmode' is ignored when 'model = parafac2'. Last mode \n
                is classification mode by default.")
      } else {
        cmode <- lxdim
      }
      storlist <- vector("list", xdim[cmode])
      if (lxdim == 3L) {
        for (k in 1:xdim[cmode]) {storlist[[k]] <- x[, , k]}
      } else {
        for (k in 1:xdim[cmode]) {storlist[[k]] <- x[, , , k]}
      }
      x <- storlist
      rm(storlist)
    } else if (is.list(x) && (model == "parafac2")) {
      xdim1 <- dim(x[[1]])
      lxdim <- length(xdim1) + 1L
      if (!((lxdim == 3L) || (lxdim == 4L))) {
        stop("Input 'x' must be a list of matrices or 3-way arrays.")
      }
      if (!(is.null(cmode))) {
        cmode <- lxdim
        warning("Input 'cmode' is ignored if 'model = parafac2'. Last mode \n
                is classification mode by default. First mode is nested \n
                within last mode (i.e., number of levels for first mode can \n
                vary for each level of the last mode).")
      } else {
        cmode <- lxdim
      }
      if (any(as.logical(lapply(x, function(a){return(any(is.nan(a)))})))) {
        stop("Input 'x' cannot contain NaN values")
      }
      if (any(as.logical(lapply(x,function(a){return(any(is.infinite(a)))})))) {
        stop("Input 'x' cannot contain Inf values")
      }
      if (any(as.logical(lapply(x,function(a){return(any(is.na(a)))})))) {
        stop("Input 'x' cannot contain missing values")
      }
      if (lxdim == 3L) {
        xdim <- rep(NA, 3)
        xdim[2] <- xdim1[2]
        xdim[3] <- length(x)
        if (any(unlist(lapply(x, ncol)) != xdim[2])) {
          stop("Input 'x' must be list of matrices with same 
               number of columns.")
        }
      } else {
        xdim <- rep(NA, 4)
        xdim[2] <- xdim1[2]
        xdim[3] <- xdim1[3]
        xdim[4] <- length(x)
        index2 <- seq(2, (3 * length(x) - 1), by = 3)
        index3 <- seq(3, (3 * length(x)), by = 3)
        if (any(unlist(lapply(x, dim))[index2] != xdim[2])) {
          stop("Input 'x' must be list of arrays with same number of columns.")
        }
        if (any(unlist(lapply(x, dim))[index3] != xdim[3])) {
          stop("Input 'x' must be list of arrays with same number of slabs.")
        }
      }
    } else if (is.list(x) && (model != "parafac2")) {
      stop("Input 'x' cannot be of class 'list' if model is 'parafac' or \n
           'pca'.")
    } else if (is.matrix(x) && (model != "pca")) {
      stop("Input 'x' cannot be of class 'matrix' if model is 'parafac' or \n
           'parafac2'.")
    } else if (is.matrix(x) && (model == "pca")) {
      xdim <- origdim <- dim(x)                             
      lxdim <- length(xdim)
      if (!((lxdim == 2L))) {
        stop("If 'x' has class 'matrix' and model is 'pca', 'x' must be a \n
             2-way matrix.")
      }
      if (any(is.nan(x)) || any(is.infinite(x))) {
        stop("Input 'x' cannot contain NaN or Inf values.")
      }
      if (any(is.na(x))) {stop("Input 'x' cannot contain missing values.")}
      if (!(is.null(cmode))) {
        if (!(cmode %in% (1:lxdim))) {
          stop("Input 'cmode' must be 1 or 2 when model is 'pca' and when \n
               'x' is of class 'matrix'.")
        }
        if (cmode == 1) {
          x <- x
        } else {
          modeval <- 1:lxdim
          mode.re <- c(cmode, modeval[-cmode])
          x <- aperm(x, mode.re)
          xdim <- dim(x)
          permflag <- TRUE
        }
      } else {
        cmode <- 1
      }
      flattened <- FALSE
    } else {
      stop("Input 'x' can be of class 'array' for any model, can be of class \n
           'list' for 'parafac2', and can be of class 'matrix' for 'pca'. \n
           Else, input 'x' cannot be of a different class.")
    }
    if (!(is.factor(y))) {stop("Input 'y' must be of class 'factor'.")}
    ylev <- length(levels(y))
    if (!(sum(sort(as.numeric(levels(y))) == 0:(ylev - 1)) == ylev)) {
      stop("Input 'y' must contain labels of 0 and 1 for binary problems, or \n
           0, 1, 2, ..., for multiclass problems.")
    }
    if (model == "parafac") {
      if (!(length(y) == origdim[cmode])) {
        stop("Length of 'y' must match number of levels in classification \n
             mode of 'x'.")
      }
    } else if (model == "pca") {
      if (!(length(y) == xdim[1])) {
        stop("Length of 'y' must match number of levels in classification \n
             mode of 'x'.")
      }
    } else {
      if (!(length(y) == xdim[cmode])) {
        stop("Length of 'y' must match number of levels in classification \n
             mode of 'x'.")
      }
    }
    numcheck(nrep)
    if ((!(ceiling(nrep) == nrep)) || (nrep < 1)) {
      stop("Input 'nrep' must be an integer greater than 0.")
    }
    numcheck(ratio)
    if ((ratio >= 1) || (ratio <= 0)) {
      stop("Input 'ratio' must be a number between 0 and 1, exclusive.")
    }
    if (is.null(seeds)) {
      seeds <- 1:nrep
    } else {
      if (!((is.numeric(seeds)) || (is.integer(seeds)))) {
        stop("Input 'seeds' must be of class 'numeric' or 'integer'.")
      }
      if (length(seeds) != nrep) {
        stop("Input 'seeds' must have length equal to input 'nrep'.")
      }
      if (length(unique(seeds)) != length(seeds)) {
        warning("Not all seeds are unique.")
      }
    }
    types <- c("measures", "descriptives")
    numtype <- sum(tolower(type.out) %in% types)
    if (numtype == 0) {
      stop("Input 'type.out' does not contain a valid value. Must specify \n
           either 'measures' or 'descriptives' for 'type.out'.")
    } else if (numtype > 2L) {
      stop("Input 'type.out' contains three or more values. Must specify \n
           either 'measures' or 'descriptives' for 'type.out'.")
    } else if (numtype == 2L) {
      type.out <- "descriptives"
    } else {
      type.out <- tolower(type.out)
    }
    if (model == "parafac") {
      nobs <- dim(x)[lxdim]
    } else if (model == "pca") {
      nobs <- nrow(x)
    } else {
      nobs <- length(x)
    }
    if (!(is.null(z))) {
      zdim <- dim(z)                                                            
      lzdim <- length(zdim)
      if (!((lzdim == 2L))) {stop("Input 'z' must have two modes.")}
      if (!(is.matrix(z))) {stop("Input 'z' must be of class 'matrix'.")}
      if (any(is.nan(z)) || any(is.infinite(z))) {
        stop("Input 'z' cannot contain NaN or Inf values.")
      }
      if (any(is.na(z))) {stop("Input 'z' cannot contain missing values.")}
      if (zdim[1] != length(y)) {
        stop("Input 'z', when provided, must have number of rows equal to \n
             the length of input 'y' (i.e., the number of class labels).")
      }
    }
    ntrain <- ceiling(nobs * ratio)
    if (!(is.null(foldid))) {
      if (!(is.list(foldid))) {
        stop("Input 'foldid' must be of class 'list' when provided.")
      }
      if (length(foldid) != nrep) {
        stop("Input 'foldid' must be a list of length equal to input 'nrep'.")
      }
      if (any(unlist(lapply(foldid, length)) != ntrain)) {
        stop("Each vector in 'foldid' must have length equal to \n
             ceiling(nobs * ratio).")
      }
    }
    logicheck(plot.out)
    if (plot.out) {
      if (is.null(plot.measures)) {
        plottype <- 5
      } else {
        cmeasures <- c("err", "acc", "tpr", "fpr", "tnr", "fnr", "ppv", "npv",
                       "fdr", "fom", "fs")
        plottype.num <- sum(cmeasures %in% plot.measures)
        if (plottype.num == 0) {
          stop("Input 'plot.out' is true, but input 'plot.measures' does not \n
               contain any accepted values. See help file and argument \n
               'plot.measures' for a list of accepted values.")
        }
        plottype <- which(cmeasures %in% plot.measures == TRUE) + 3
      }
    }
    nfac <- sort(nfac)
    stor <- array(0, dim = c(length(nfac) * length(method), 11, nrep))
    predstor <- Aw <- Bw <- Cw <- Pw <- vector(mode = "list", length = nrep)
    trainIDs <- testIDs <- opara <- predstor
    cmode0 <- cmode
    if (cmode == lxdim) {cmode <- NULL}
    logicheck(verbose)
    ccreated <- FALSE
    if ((parallel == TRUE) && (is.null(cl))) {
      cl <- makeCluster(detectCores())
      ccreated <- TRUE
      registerDoParallel(cl)
      clusterEvalQ(cl, library(multiway))
    }
    for (i in 1:nrep) {
      if (verbose == TRUE) {cat("nrep =", i, " \n")}
      set.seed(seed = seeds[i])
      train.id <- trainIDs[[i]] <- sample.int(nobs, size = ntrain)
      alllevels <- 1:nobs
      testIDs[[i]] <- alllevels[-train.id]
      y.train <- y[train.id]
      y.test <- as.numeric(y[-train.id]) - 1
      if (!(is.null(z))) {
        z.train <- z[train.id, , drop = FALSE]
        z.test <- z[-train.id, , drop = FALSE]
      } else {
        z.train <- z.test <- NULL
      }
      if (model == "parafac") {
        if (lxdim == 3L) {
          X.train <- x[, , train.id]                       
          X.test <- x[, , -train.id]
        } else {
          X.train <- x[, , , train.id]
          X.test <- x[, , , -train.id]
        }
      } else if (model == "pca") {
        X.train <- x[train.id, , drop = FALSE]
        X.test <- x[-train.id, , drop = FALSE]
      } else {
        X.train <- x[train.id]
        X.test <- x[-train.id]
      }
      if (is.null(foldid)) {
        cfoldid <- NULL
      } else {
        cfoldid <- foldid[[i]]
      }
      tcpfalist <- tunecpfa(x = X.train, y = y.train, z = z.train, 
                            model = model, nfac = nfac, nfolds = nfolds, 
                            method = method, family = family, 
                            parameters = parameters, foldid = cfoldid, 
                            prior = prior, cmode = NULL, parallel = parallel, 
                            cl = cl, verbose = verbose, compscale = compscale, 
                            pcarot = pcarot, ...)
      Aw[[i]] <- tcpfalist$Aweights
      Bw[[i]] <- tcpfalist$Bweights
      Cw[[i]] <- tcpfalist$Cweights
      Pw[[i]] <- tcpfalist$Phi
      opara[[i]] <- tcpfalist$opt.param
      yhat <- predict(object = tcpfalist, newdata = X.test, newdata.z = z.test, 
                      type = "response")           
      out <- cpm.all(x = yhat, y = y.test, level = levels(y))
      stor[ , , i] <- as.matrix(out$cpms)
      predstor[[i]] <- predict(object = tcpfalist, newdata = X.test,
                               newdata.z = z.test, type = "classify.weights")
    }
    mconst <- tcpfalist$const
    rnam <- rownames(out$cpms)
    cnam <- colnames(out$cpms)
    dimnames(stor)[[1]] <- rnam
    dimnames(stor)[[2]] <- cnam
    train.weights <- list(Atrain.weights = Aw, Btrain.weights = Bw,
                          Ctrain.weights = Cw, Phitrain = Pw)
    mean.tune.param <- Reduce("+", opara) / length(opara)
    if (plot.out == TRUE) {
      ncomps <- length(nfac)
      nmethods <- length(method)
      plotstor <- data.frame(matrix(0, nrow = (ncomps * nmethods * nrep),
                                    ncol = 14))
      plotcname <- c("method", "nfac", "rep", colnames(stor))
      colnames(plotstor) <- plotcname
      matnum <- ncomps * nmethods
      methnames0 <- sapply(strsplit(rownames(stor), split = '.', fixed = TRUE),
                           function(x) (x[2]))
      methnames <- gsub('[[:digit:]]+', '', methnames0)
      nfacnames <- as.numeric(gsub(".*?([0-9]+).*", "\\1", rownames(stor)))
      for (i in 1:nrep) {
        indl <- matnum * (i - 1) + 1
        indu <- matnum * i
        plotstor[indl:indu, 1] <- methnames
        plotstor[indl:indu, 2] <- nfacnames
        plotstor[indl:indu, 3] <- i
        plotstor[indl:indu, 4:14] <- stor[, , i]
      }
      toplot <- colnames(plotstor)[plottype]
      for (j in 1:length(plottype)) {
        pformula <- formula(paste0(toplot[j], " ~ ", "method * nfac"))
        boxplot(pformula, data = plotstor, ylim = c(0, 1),
                xlab = "Method and Number of Components", na.rm = FALSE,
                ylab = toupper(toplot[j]), main = "Performance Measure")
      }
    }
    if (ccreated == TRUE) {stopCluster(cl)}
    if (permflag == TRUE) {x <- aperm(x, perm = order(mode.re))}
    if (type.out == "measures") {
      cpfalist <- list(measure = stor, predweights = predstor,
                       train.weights = train.weights, opt.tune = opara,
                       mean.opt.tune = mean.tune.param, X = x, y = y, z = z,
                       nfac = nfac, model = model, method = method,
                       const = mconst, cmode = cmode0, family = family, 
                       lxdim = lxdim, trainIDs = trainIDs, testIDs = testIDs,
                       flattened = flattened)
      class(cpfalist) <- "wrapcpfa"
      return(cpfalist)                              
    } else {
      dfun <- c("mean", "median", "sd")
      output <- vector(mode = "list", length = length(dfun))
      for (j in seq_along(dfun)) {
         output[[j]] <- apply(stor, 1:2,
                              FUN = function(x){return(get(dfun[j])(x,
                                                                na.rm = TRUE))})
        rownames(output[[j]]) <- rnam
        colnames(output[[j]]) <- cnam
      }
      names(output) <- dfun  
      cpfalist <- list(descriptive = output, predweights = predstor,
                       train.weights = train.weights, opt.tune = opara,
                       mean.opt.tune = mean.tune.param, X = x, y = y, z = z,
                       nfac = nfac, model = model, method = method,
                       const = mconst, cmode = cmode0, family = family, 
                       lxdim = lxdim, trainIDs = trainIDs, testIDs = testIDs,
                       flattened = flattened)
      class(cpfalist) <- "wrapcpfa"
      return(cpfalist)
    }
}

plotcpfa <- 
  function(object, cmeasure = "acc", meanvalue = TRUE, supNum = FALSE, 
           cmode = NULL, parallel = FALSE, cl = NULL, scale.remode = NULL, 
           newscales = 1, scale.abmode = NULL, sign.remode = NULL, newsigns = 1, 
           sign.abmode = NULL, ...) 
{
    if (!(inherits(object, "wrapcpfa"))) {
      stop("Input 'object' must be of class 'wrapcpfa'.")
    }
    cmeasures <- c("err", "acc", "tpr", "fpr", "tnr", "fnr", "ppv", "npv", 
                   "fdr", "fom", "fs")
    cmeasure <- tolower(cmeasure)
    ctype <- sum(cmeasures %in% cmeasure)
    if (ctype != 1) {
      stop("Input 'cmeasure' must contain a single acceptable value. See help \n
           file for acceptable values.")
    }
    logicheck(meanvalue); logicheck(supNum); logicheck(parallel)
    model <- object$model; const <- object$const
    X <- object$X
    lxdim <- object$lxdim
    flattened <- object$flattened
    if (!(is.null(cmode))) {
      if (model == "parafac") {
        if (!(cmode %in% (1:lxdim))) {
          stop("Input 'cmode' must be 1, 2, or 3 (or 4 if 'x' is four-way).")
        }
        modeval <- 1:lxdim
        mode.re <- c(modeval[-cmode], cmode)
        X <- aperm(X, mode.re)
      } 
      if (model == "pca") {
        if ((flattened == TRUE) && (cmode > 2L)) {
          warning("New input 'cmode' is greater than 2, but original input \n
                  'x' in function 'cpfa' was a 3-way or 4-way array. Because \n 
                  'x' was an array, it was flattened to a 2-way matrix. Thus, \n 
                  new 'cmode' is ignored.")
        } else {
          if (!(cmode %in% (1:lxdim))) {
            stop("Input 'cmode' must be 1 or 2 when model was 'pca'.")
          } else if (cmode == 1L) {
            X <- X
          } else {
            X <- t(X)
          }
        }
      }
    } else {
      if (model == "parafac") {
        cmode <- object$cmode
        modeval <- 1:lxdim
        mode.re <- c(modeval[-cmode], cmode)
        X <- aperm(X, mode.re)
      }
      if ((model == "pca") && (flattened == FALSE)) {
        cmode <- object$cmode
        if (cmode == 2L) {X <- t(X)}
      }
    }
    values <- object$descriptive
    if (meanvalue == TRUE) {
      finalvalues <- values$mean
    } else {
      finalvalues <- values$median
    }
    vals <- finalvalues[, which(colnames(finalvalues) == cmeasure)]
    if (length(vals[!is.na(vals)]) == 0) {
      stop("For selected 'cmeasure', all values are 'NA'. Plots cannot be \n
           created. Consider checking output from function 'cpfa'.")
    }
    lowisbest <- c("err", "fpr", "fnr", "fdr", "fom")
    if (cmeasure %in% lowisbest) {
      if (nrow(finalvalues) == 1L) {
        methodnfac <- rownames(finalvalues)
      } else {
        methodnfac <- names(which(vals == min(vals, na.rm = TRUE)))
      }
    } else {
      if (nrow(finalvalues) == 1L) {
        methodnfac <- rownames(finalvalues)
      } else {
        methodnfac <- names(which(vals == max(vals, na.rm = TRUE)))
      }
    }
    nfac.opt0 <- as.numeric(gsub("[^0-9]", "", methodnfac))
    nfac.opt <- min(nfac.opt0)
    outstor <- vector("list", 4)
    mapstor <- vector("list", 3)
    if (parallel == TRUE) {
      if (is.null(cl)) {cl <- makeCluster(detectCores())}
      ce <- clusterEvalQ(cl, library(multiway))
      registerDoParallel(cl)
    }
    if (model == "parafac") {
      pfac <- parafac(X = X, nfac = nfac.opt, const = const, cl = cl, 
                      parallel = parallel, ...)
      if ((!(is.null(scale.remode))) && (!(is.null(scale.abmode)))) {
        pfac <- rescale(pfac, mode = scale.remode, newscale = newscales, 
                        absorb = scale.abmode)
      }
      if ((!(is.null(sign.remode))) && (!(is.null(sign.abmode)))) {
        pfac <- resign(pfac, mode = sign.remode, newsign = newsigns, 
                       absorb = sign.abmode)
      }
      mapstor[[1]] <- outstor[[1]] <- pfac$A
      mapstor[[2]] <- outstor[[2]] <- pfac$B   
      outstor[[3]] <- pfac$C
      if (lxdim == 4L) {
        mapstor[[3]] <- pfac$C
        outstor[[4]] <- pfac$D
      }
    } else if (model == "parafac2") {
      pfac <- parafac2(X = X, nfac = nfac.opt, const = const, cl = cl, 
                       parallel = parallel, ...)
      if ((!(is.null(scale.remode))) && (!(is.null(scale.abmode)))) {
        pfac <- rescale(pfac, mode = scale.remode, newscale = newscales, 
                        absorb = scale.abmode)
      }
      if ((!(is.null(sign.remode))) && (!(is.null(sign.abmode)))) {
        pfac <- resign(pfac, mode = sign.remode, newsign = newsigns, 
                       absorb = sign.abmode)
      }
      outstor[[1]] <- pfac$A
      mapstor[[2]] <- outstor[[2]] <- pfac$B   
      outstor[[3]] <- pfac$C
      if (lxdim == 4L) {
        mapstor[[3]] <- pfac$C
        outstor[[4]] <- pfac$D
      }
    } else {
      xcent <- scale(X, center = TRUE, scale = FALSE)
      pcacenter <- attr(xcent, "scaled:center")
      USV <- svd(xcent)
      weights <- USV$v[, 1:nfac.opt, drop = FALSE]
      leftsing <- USV$u[, 1:nfac.opt, drop = FALSE]
      scores <- sweep(leftsing, 2, USV$d[1:nfac.opt], "*")
      if (const == "varimax") {
        if (nfac.opt != 1L) {
          varires <- varimax(weights)
          rotmat <- varires$rotmat
          weights <- unclass(as.matrix(varires$loadings))
          scores <- scores %*% rotmat
        }
      }
      mapstor[[1]] <- outstor[[1]] <- weights
      outstor[[2]] <- scores
    }
    if (parallel == TRUE) {stopCluster(cl)}
    plotlabels <- c("A Weights", "B Weights", "C Weights")
    plotlabels2 <- c(plotlabels, "D Weights")
    palette_colors <- colorRampPalette(c("red", "white", "green"))(50)
    par(mfrow = c(1, 1))
    for (i in 1:3) {
       if (!(is.null(mapstor[[i]]))) {
         mat <- as.matrix(mapstor[[i]])
         mainlab <- plotlabels[i]
         rownames(mat) <- paste0("L", 1:nrow(mat))
         colnames(mat) <- paste0("C", 1:ncol(mat))
         maxabs <- max(abs(mat))
         if (ncol(mat) == 1) {
           zarg <- t(as.matrix(t(mat)[, nrow(mat):1]))
         } else {
           zarg <- as.matrix(t(mat)[, nrow(mat):1])
         }
         image(x = 1:ncol(mat), y = 1:nrow(mat), z = zarg, col = palette_colors, 
               xlab = "Components", ylab = "Levels", axes = FALSE, 
               zlim = c(-maxabs, maxabs), main = mainlab)
         axis(1, at = 1:ncol(mat), labels = colnames(mat))
         axis(2, at = 1:nrow(mat), labels = rev(rownames(mat)))
         box()
         if (!(supNum == TRUE)) {
           for (j in 1:nrow(mat)) {
              for (k in 1:ncol(mat)) {
                 text(x = k, y = (nrow(mat) - j + 1), cex = 0.8,
                      labels = round(mat[j, k], 2))
              }
           }
         }
       }
    }
    names(outstor) <- c("Aweights", "Bweights", "Cweights", "Dweights")
    return(outstor)
}

kcv.nn <-
  function(x, y, foldid = NULL, nn.grid, nfolds = NULL, weights = NULL,
           linout = FALSE, censored = FALSE, skip = FALSE, rang = 0.5, 
           parallel = FALSE) 
{
    kcvcheck(y = y, nfolds = nfolds, parallel = parallel, foldid = foldid)
    if (is.null(weights)) {
      frac <- table(y) / length(y)
      names(frac) <- seq_along(levels(as.factor(y))) - 1
      wtemp <- as.numeric(frac[y])
      weights <- 1 / (wtemp * (length(y) / sum(wtemp)))
    }
    x <- as.matrix(x)
    weights <- as.matrix(weights)                                               
    grid.row <- nrow(nn.grid)
    cv.nn <- matrix(rep(0, grid.row * nfolds), ncol = nfolds)
    if (parallel == TRUE) {
      cv.nn <- foreach (gg = 1:nfolds, .combine = cbind, 
                        .packages = 'nnet') %dorng% {
                        x.train <- as.matrix(x[which(foldid != gg), ])
                        y.train <- y[which(foldid != gg)]
                        x.test <- as.matrix(x[which(foldid == gg), ])
                        y.test <- as.numeric(y[which(foldid == gg)]) - 1
                        trweights <- as.matrix(weights[which(foldid != gg), ])
                        data.ytrain <- data.frame(y.train)
                        con.ytrain <- model.matrix(~y.train - 1, data.ytrain)
                        stortune <- matrix(rep(0, grid.row), ncol = 1)
                        for (yy in 1:grid.row) {
                           nn.fit <- nnet(x = x.train, y = con.ytrain, 
                                          trace = F, size = nn.grid[yy, 1], 
                                          decay = nn.grid[yy, 2], 
                                          linout = linout, weights = trweights,
                                          censored = censored, skip = skip, 
                                          rang = rang, MaxNWts = 10000)
                           nn.pred <- predict(nn.fit, newdata = x.test, 
                                              type = 'raw')
                           y.pred <- as.numeric((apply(nn.pred, 1, 
                                                 which.max))) - 1
                           stortune[yy, 1] <- 1 - mean(y.pred == y.test)
                        }
                        cv.nn[, gg] <- stortune
               }
    } else {
      for (gg in 1:nfolds) {
         x.train <- as.matrix(x[which(foldid != gg), ])
         y.train <- y[which(foldid != gg)]
         x.test <- as.matrix(x[which(foldid == gg), ])
         y.test <- as.numeric(y[which(foldid == gg)]) - 1
         trweights <- as.matrix(weights[which(foldid != gg), ])
         data.ytrain <- data.frame(y.train)
         con.ytrain <- model.matrix(~y.train - 1, data.ytrain)
         stortune <- matrix(rep(0, grid.row), ncol = 1)
         for (yy in 1:grid.row) {
            nn.fit <- nnet(x = x.train, y = con.ytrain, trace = F,
                           size = nn.grid[yy, 1], decay = nn.grid[yy, 2],
                           linout = linout, censored = censored, skip = skip, 
                           weights = trweights, rang = rang, MaxNWts = 10000)
            nn.pred <- predict(nn.fit, newdata = x.test, type = 'raw')
            y.pred <- as.numeric((apply(nn.pred, 1, which.max))) - 1
            stortune[yy, 1] <- 1 - mean(y.pred == y.test) 
         }
         cv.nn[, gg] <- stortune
      }
    }
    nn.mean <- apply(cv.nn, 1, mean)
    minid <- which.min(nn.mean)
    data.y <- data.frame(y)
    con.y <- model.matrix(~y - 1, data.y)
    nn.fit.best <- nnet(x = x, y = con.y, trace = F, size = nn.grid[minid, 1], 
                        decay = nn.grid[minid, 2], linout = linout, 
                        censored = censored, skip = skip, weights = weights, 
                        rang = rang, MaxNWts = 1e4)
    return(list(nn.grid.id = minid, nn.fit = nn.fit.best, 
                error = nn.mean[minid]))
}

cpm.all <- 
  function(x, y, ...) 
{   
    if (!(is.data.frame(x))) {stop("Input 'x' must be of class 'data.frame'. ")}
    if (!(is.numeric(y))) {stop("Input 'y' must be of class 'numeric'.")}
    if (any(is.na(x))) {stop("Input 'x' cannot contain missing values.")}
    if (any(is.na(y))) {stop("Input 'y' cannot contain missing values.")}
    if (nrow(x) != length(y)) {
      stop("Input 'x' must be same length as input 'y'.") 
    }
    nvar <- ncol(x)
    cmat <- vector('list', nvar)
    cpms <- NULL
    values <- apply(x, 2, function(a){cpm(a, y, ...)})
    for (i in 1:nvar) {
       cmat[[i]] <- values[[i]][[1]]
       cpms <- rbind(cpms, values[[i]][[2]]) 
    }
    names(cmat) <- colnames(x)
    rownames(cpms) <- colnames(x)
    output <- list(cm.list = cmat, cpms = cpms)
    return(output)
}

predict.tunecpfa <-
  function(object, newdata = NULL, newdata.z = NULL, method = NULL,
           type = c("response", "prob", "classify.weights"), 
           threshold = NULL, ...)                                               
{   
    if (!(inherits(object, "tunecpfa"))) {
      stop("Input 'object' must be of class 'tunecpfa'.")
    }
    model <- object$model
    xold.dim <- object$xdim
    cmode <- object$cmode
    oyold <- object$y
    zout <- object$z
    if (is.null(newdata)) {
      newdata <- object$x
      xdim <- object$xdim
      lxdim <- object$lxdim
      skippy <- TRUE
    } else {
      skippy <- FALSE
    }
    if (!(skippy)) {
      if (is.array(newdata) && (!is.matrix(newdata)) && 
          (model %in% c("parafac", "pca"))) {
        xdim <- dim(newdata)                                                            
        lxdim <- length(xdim)
        if (!((lxdim == 3L) || (lxdim == 4L))) {
          stop("Input 'newdata' must be a 3-way or 4-way array.")
        }
        if (any(is.nan(newdata)) || any(is.infinite(newdata))) {
          stop("Input 'newdata' cannot contain NaN or Inf values.")
        }
        if (any(is.na(newdata))) {
          stop("Input 'newdata' cannot contain missing values.")
        }
        if (model == "parafac") {
          if (cmode != length(xold.dim)) {
            modeval <- 1:lxdim
            mode.re <- c(modeval[-cmode], cmode)
            newdata <- aperm(newdata, mode.re)
            xdim <- dim(newdata)
          }
        } else {
          modeval <- 1:lxdim
          mode.re <- c(cmode, modeval[-cmode])
          newdata <- matrix(aperm(newdata, mode.re), nrow = xdim[cmode])
          xdim <- dim(newdata)
          lxdim <- length(xdim)
        }
      } else if (is.array(newdata) && (!is.matrix(newdata)) 
                 && (model == "parafac2")) {
        xdim <- dim(newdata)                                                            
        lxdim <- length(xdim)
        if (!((lxdim == 3L) || (lxdim == 4L))) {
          stop("Input 'newdata' must be a 3-way or 4-way array.")
        }
        if (any(is.nan(newdata)) || any(is.infinite(newdata))) {
          stop("Input 'newdata' cannot contain NaN or Inf values.")
        }
        if (any(is.na(newdata))) {
          stop("Input 'newdata' cannot contain missing values.")
        }
        if (lxdim == 3L) {
          storlist <- vector("list", xdim[3])
          for (k in 1:xdim[3]) {storlist[[k]] <- newdata[, , k]}
        } else {
          storlist <- vector("list", xdim[4])
          for (k in 1:xdim[4]) {storlist[[k]] <- newdata[, , , k]}
        }
        newdata <- storlist
        rm(storlist)
      } else if (is.list(newdata) && (model == "parafac2")) {
        xdim1 <- dim(newdata[[1]])
        lxdim <- length(xdim1) + 1L
        if (!((lxdim == 3L) || (lxdim == 4L))) {
          stop("Input 'newdata' must be a list of matrices or 3-way arrays.")
        }
        if (any(as.logical(lapply(newdata, 
                                  function(a){return(any(is.nan(a)))})))) {
          stop("Input 'newdata' cannot contain NaN values")
        }
        if (any(as.logical(lapply(newdata,
                                  function(a){return(any(is.infinite(a)))})))) {
          stop("Input 'newdata' cannot contain Inf values")
        }
        if (any(as.logical(lapply(newdata, 
                                  function(a){return(any(is.na(a)))})))) {
          stop("Input 'newdata' cannot contain missing values")
        }
        if (lxdim == 3L) {
          xdim <- rep(NA, 3)
          xdim[2] <- xdim1[2]
          xdim[3] <- length(newdata)
          if (any(unlist(lapply(newdata, ncol)) != xdim[2])) {
            stop("Input 'newdata' must be list of matrices with same number \n
                 of columns.")
          }
        } else {
          xdim <- rep(NA, 4)
          xdim[2] <- xdim1[2]
          xdim[3] <- xdim1[3]
          xdim[4] <- length(newdata)
          index2 <- seq(2, (3 * length(newdata) - 1), by = 3)
          index3 <- seq(3, (3 * length(newdata)), by = 3)
          if (any(unlist(lapply(newdata, dim))[index2] != xdim[2])) {
            stop("Input 'newdata' must be list of arrays with same \n
                 number of columns.")
          }
          if (any(unlist(lapply(newdata, dim))[index3] != xdim[3])) {
            stop("Input 'newdata' must be list of arrays with same \n
                 number of slabs.")
          }
        }
      } else if (is.list(newdata) && (model != "parafac2")) {
        stop("Input 'newdata' cannot be of class 'list' unless \n
             'model = parafac2'.")
      } else if (is.matrix(newdata) && (model != "pca")) {
        stop("Input 'newdata' cannot be of class 'matrix' if model is \n
             'parafac' or 'parafac2'.")
      } else if (is.matrix(newdata) && (model == "pca")) {  
        xdim <- origdim <- dim(newdata)                                                            
        lxdim <- length(xdim)
        if (!((lxdim == 2L))) {
          stop("If 'newdata' has class 'matrix' and model is 'pca', 'newdata' \n 
               must be a 2-way matrix.")
        }
        if (any(is.nan(newdata)) || any(is.infinite(newdata))) {
          stop("Input 'newdata' cannot contain NaN or Inf values.")
        }
        if (any(is.na(newdata))) {
          stop("Input 'newdata' cannot contain missing values.")
        }
        if (!(is.null(cmode))) {
          if (!(cmode %in% (1:lxdim))) {
            stop("Input 'cmode' must be 1 or 2 when model is 'pca' and when \n
                 'newdata' is of class 'matrix'.")
          }
          if (cmode == 1) {
            newdata <- newdata
          } else {
            modeval <- 1:lxdim
            mode.re <- c(modeval[-cmode], cmode)
            newdata <- aperm(newdata, mode.re)
            xdim <- dim(newdata)
          }
        } else {
          cmode <- 1
        }
      } else {
        stop("Input 'newdata' can be of class 'array' for any model, can be \n
             of class 'list' for 'parafac2', and can be of class 'matrix' for \n
             'pca'. Else, input 'newdata' cannot be of a different class.")
      }
    }
    if (model == "parafac") {
      if (xdim[1] != xold.dim[1]) {
        stop("Number of levels for A mode of input 'newdata' must match \n
             number of levels for A mode used in 'object'.")
      }
      if (xdim[2] != xold.dim[2]) {
        stop("Number of levels for B mode of input 'newdata' must match \n
             number of levels for B mode used in 'object'.")
      }
      if (lxdim == 4L) {
        if (xdim[3] != xold.dim[3]) {
          stop("Number of levels for C mode of input 'newdata' must match \n 
               number of levels for C mode used in 'object'.")
        }
      }
    } else if (model == "parafac2") {
      if (xdim[2] != xold.dim[2]) {
        stop("Number of levels for B mode of input 'newdata' must match \n 
             number of levels for B mode used in 'object'.")
      }
      if (lxdim == 4L) {
        if (xdim[3] != xold.dim[3]) {
          stop("Number of levels for C mode of input 'newdata' must match \n 
               number of levels for C mode used in 'object'.")
        }
      }
    } else {
      if (xdim[2] != xold.dim[2]) {
        stop("Number of variables of input 'newdata' must match number of \n 
             variables used in 'object'.")
      }
    }
    if ((!(is.null(newdata.z))) && ((is.null(zout)))) {
      stop("Input 'newdata.z' was provided, but input 'z' from the \n 
           'tunecpfa' object is NULL. When 'newdata.z' is provided, \n
           input 'z' from 'tunecpfa' cannot be NULL.")
    } else if ((is.null(newdata.z)) && (!(is.null(zout)))) {
      stop("Input 'newdata.z' was not provided, but input 'z' from the \n
           'tunecpfa' object is not NULL. When 'z' from 'tunecpfa' is not \n
           NULL, 'newdata.z' must be provided.")
    } else if ((is.null(newdata.z)) && (is.null(zout))) {
      newdata.z <- NULL
    } else {
      newzdim <- dim(newdata.z)                                                            
      nlzdim <- length(newzdim)
      if (!((nlzdim == 2L))) {stop("Input 'newdata.z' must have two modes.")}
      if (!(is.matrix(newdata.z))) {
        stop("Input 'newdata.z', when provided, must be of class 'matrix'.")
      }
      if (any(is.nan(newdata.z)) || any(is.infinite(newdata.z))) {
        stop("Input 'newdata.z' cannot contain NaN or Inf values.")
      }
      if (any(is.na(newdata.z))) {
        stop("Input 'newdata.z' cannot contain missing values.")
      }
      if (newzdim[2] != dim(zout)[2]) {
        stop("Input 'newdata.z', when provided, must have the same number of \n
             number of features as the number of features used in the \n
             original input 'z' from 'tunecpfa'.")
      }
    }
    nfac <- object$opt.param$nfac
    opt.param <- object$opt.param
    lnfac <- length(nfac)
    nfac.names <- paste("fac.", nfac, sep = "")
    if (is.null(method)) {
      method <- object$method
      lmethod <- length(method)
    } else {
      omethods <- c("PLR", "SVM", "RF", "NN", "RDA", "GBM")
      checkmethod <- sum(toupper(method) %in% omethods)
      if (checkmethod != length(method)) {
        stop("Input 'method' contains at least one value that is not valid.")
      }
      method <- which(omethods %in% toupper(method) == TRUE)
      lmethod <- length(method)
      if (sum(method %in% object$method) != lmethod) {
        stop("Input 'method' contains at least one method that was not tuned \n
             in input 'object'.")
      }
    }
    meth.names <- NULL
    if (1 %in% method) {meth.names <- c(meth.names, "PLR")}
    if (2 %in% method) {meth.names <- c(meth.names, "SVM")}
    if (3 %in% method) {meth.names <- c(meth.names, "RF")}
    if (4 %in% method) {meth.names <- c(meth.names, "NN")}
    if (5 %in% method) {
      meth.names <- c(meth.names, "RDA")
      train.weights <- object$train.weights
    }
    if (6 %in% method) {meth.names <- c(meth.names, "GBM")}
    meth.names <- tolower(meth.names)
    opt.model <- object$opt.model
    Aweights <- object$Aweights
    Bweights <- object$Bweights   
    Cweights <- object$Cweights
    Phi <- object$Phi
    scenters <- object$scenters
    sscales <- object$sscales
    const <- object$const
    classify.weights <- vector("list", lnfac)
    names(classify.weights) <- nfac.names
    if (length(type) != 1) {
      stop("Input 'type' must be a character of length equal to 1. Make sure \n
           to specify 'type'.")
    }
    types <- c("response", "prob", "classify.weights")
    if (!(tolower(type) %in% types)) {
      stop("Input 'type' must be 'response', 'prob', or 'classify.weights'.")
    }
    type <- tolower(type)
    family <- object$family
    if (family == "binomial") {
      if (!(is.null(threshold))) {
        if ((threshold < 0) || (threshold > 1) || (length(threshold) > 1)) {
          stop("Input 'threshold' must be a single real number from 0 to 1, \n
              inclusive, for binary classification.")
        }
      }
      if ((is.null(threshold)) && (type != "classify.weights")) {
        threshold <- 0.5
      }
    }
    if (family == "multinomial") {
      if (!(is.null(threshold))) {
        if (any(threshold < 0) || any(threshold > 1)) {
          stop("Input 'threshold' must contain real numbers from 0 to 1 for
             multiclass classification.")
        }
        if (sum(threshold) != 1) {
          stop("Input 'threshold' must sum to 1 for multiclass classification.")
        }
        warning("Argument 'threshold' is not currently implemented for 
                multiclass classification.")
      }
      if ((is.null(threshold)) && (type == "response")) {
        yt <- object$y
        fraction <- table(yt) / length(yt)
        threshold <- as.numeric(fraction)
      }
      if ((is.null(threshold)) && (type == "prob")) {
        threshold <- 0.5
      }
    }
    stor.name <- NULL
    for (i in 1:lnfac) {
       stor.name <- c(stor.name, paste0(nfac.names[i], meth.names)) 
    }
    if (model == "parafac") {
      storrows <- dim(newdata)[lxdim]
    } else if (model == "parafac2") {
      storrows <- length(newdata)
    } else {
      storrows <- xdim[1]
    }
    storfac <- matrix(NA, nrow = storrows, ncol = lmethod * lnfac)
    storprob <- vector("list", lmethod * lnfac)
    for (w in 1:lnfac) {
       colcount <- lmethod * (w - 1) + 1
       if (model == "parafac") {
         Afixed <- Aweights[[w]]
         Bfixed <- Bweights[[w]]
         if (lxdim == 3L) {
           ppfac <- parafac(X = newdata, nfac = nfac[w], nstart = 1, 
                            ctol = sqrt(.Machine$double.eps), verbose = FALSE, 
                            const = const, Afixed = Afixed, Bfixed = Bfixed)                
           C.pred0 <- ppfac$C
           if (!(is.null(newdata.z))) {
             if (nrow(newdata.z) != nrow(C.pred0)) {
               stop("Input 'newdata.z', when provided, must have number of \n
                    observations equal to the number of levels of the \n
                    classification mode of input 'newdata'.")
             } else {
               C.pred0 <- cbind(C.pred0, newdata.z)
             }
           }
           C.pred <- scale(C.pred0, center = scenters[[w]], 
                           scale = sscales[[w]])
           classify.weights[[w]] <- C.pred
         }
         if (lxdim == 4L) {
           Cfixed <- Cweights[[w]]
           ppfac <- parafac(X = newdata, nfac = nfac[w], nstart = 1, 
                            ctol = sqrt(.Machine$double.eps), verbose = FALSE, 
                            const = const, Afixed = Afixed, Bfixed = Bfixed,
                            Cfixed = Cfixed)                                
           C.pred0 <- ppfac$D
           if (!(is.null(newdata.z))) {
             if (nrow(newdata.z) != nrow(C.pred0)) {
               stop("Input 'newdata.z', when provided, must have number of \n
                    observations equal to the number of levels of the \n
                    classification mode of input 'newdata'.")
             } else {
               C.pred0 <- cbind(C.pred0, newdata.z)
             }
           }
           C.pred <- scale(C.pred0, center = scenters[[w]], 
                           scale = sscales[[w]])
           classify.weights[[w]] <- C.pred
         }
       } else if (model == "parafac2") {
         Phifixed <- Phi[[w]]
         phi.pfac2 <- eigen(Phifixed, symmetric = TRUE)
         if (nfac[w] == 1) {
           Gfixed <- t(phi.pfac2$vectors * sqrt(phi.pfac2$values))
         } else {
           Gfixed <- t(phi.pfac2$vectors %*% diag(sqrt(phi.pfac2$values)))
         }
         Bfixed <- Bweights[[w]]
         if (lxdim == 3L) {
           ppfac <- parafac2(X = newdata, nfac = nfac[w], nstart = 1, 
                             ctol = sqrt(.Machine$double.eps), verbose = FALSE, 
                             const = const, Gfixed = Gfixed, Bfixed = Bfixed)                
           C.pred0 <- ppfac$C
           if (!(is.null(newdata.z))) {
             if (nrow(newdata.z) != nrow(C.pred0)) {
               stop("Input 'newdata.z', when provided, must have number of \n
                    observations equal to the number of levels of the \n
                    classification mode of input 'newdata'.")
             } else {
               C.pred0 <- cbind(C.pred0, newdata.z)
             }
           }
           C.pred <- scale(C.pred0, center = scenters[[w]], 
                           scale = sscales[[w]])
           classify.weights[[w]] <- C.pred
         }
         if (lxdim == 4L) {
           Cfixed <- Cweights[[w]]
           ppfac <- parafac2(X = newdata, nfac = nfac[w], nstart = 1, 
                             ctol = sqrt(.Machine$double.eps), verbose = FALSE, 
                             const = const, Gfixed = Gfixed, Bfixed = Bfixed,
                             Cfixed = Cfixed)                                
           C.pred0 <- ppfac$D
           if (!(is.null(newdata.z))) {
             if (nrow(newdata.z) != nrow(C.pred0)) {
               stop("Input 'newdata.z', when provided, must have number of \n
                    observations equal to the number of levels of the \n
                    classification mode of input 'newdata'.")
             } else {
               C.pred0 <- cbind(C.pred0, newdata.z)
             }
           }
           C.pred <- scale(C.pred0, center = scenters[[w]], 
                           scale = sscales[[w]])
           classify.weights[[w]] <- C.pred
         }
       } else {
         pcacenter <- object$pcacenter
         Afixed <- Aweights[[w]]
         ndcent <- scale(newdata, center = pcacenter, scale = FALSE)
         C.pred0 <- ndcent %*% Afixed
         if (!(is.null(newdata.z))) {
           if (nrow(newdata.z) != nrow(C.pred0)) {
             stop("Input 'newdata.z', when provided, must have number of \n
                    observations equal to the number of levels of the \n
                    classification mode of input 'newdata'.")
           } else {
             C.pred0 <- cbind(C.pred0, newdata.z)
           }
         }
         C.pred <- scale(C.pred0, center = scenters[[w]], 
                         scale = sscales[[w]])
         classify.weights[[w]] <- C.pred
       }
       if (type != "classify.weights") {
         C.pred <- as.matrix(C.pred)
           if ('1' %in% method) {
             plr.fit <- opt.model[[w]][[1]]
             if (!(is.null(plr.fit$glmnet.fit))) {
               plr.fit.class <- plr.fit$glmnet.fit$classnames
               lambda.min <- plr.fit$lambda.min
             }
             if (is.null(plr.fit$glmnet.fit)) {
               plr.fit.class <- plr.fit$classnames
               lambda.min <- opt.param[which(
                                       opt.param$nfac == nfac[w]), ]$lambda
             }
             if ((nfac[w] == 1) || (nfac[w] == 1L)) {
               C.pred.plr <- cbind(C.pred, 0)
             } else {
               C.pred.plr <- C.pred
             }
             if (type == "response") {
               type.plr <- "response" 
               if (family == "binomial") {
                 vals <- as.numeric(predict(plr.fit, newx = C.pred.plr, 
                                            type = type.plr, s = lambda.min,
                                            levels = plr.fit.class))
                 storfac[, colcount] <- as.numeric(vals > threshold)
                 colcount <- colcount + 1
               }
               if (family == "multinomial") {
                 vals <- predict(plr.fit, newx = C.pred.plr, type = type.plr, 
                                 s = lambda.min, levels = plr.fit.class)
                 storfac[, colcount] <- as.numeric((apply(vals, 1, 
                                                          which.max))) - 1
                 colcount <- colcount + 1
               }
             }
             if (type == "prob") {
               type.plr <- "response"
               if (family == "binomial") {
                 storprob[[colcount]] <- as.numeric(predict(plr.fit, 
                                                    newx = C.pred.plr, 
                                                    type = type.plr, 
                                                    s = lambda.min,
                                                    levels = plr.fit.class))
                 colcount <- colcount + 1
               }
               if (family == "multinomial") {
                 plr.vals <- as.numeric(predict(plr.fit, 
                                                newx = C.pred.plr, 
                                                type = type.plr, 
                                                s = lambda.min,
                                                levels = plr.fit.class))
                 plr.dim <- dim(C.pred.plr)
                 lplr.class <- length(plr.fit.class)
                 storprob[[colcount]] <- matrix(plr.vals, nrow = plr.dim[1], 
                                                ncol = lplr.class)
                 colcount <- colcount + 1
               }
             }
           }
           if ('2' %in% method) {
             svm.fit <- opt.model[[w]][[2]]
             if (type == "response") {
               if (family == "binomial") {
                 svm.prob <- attr(predict(svm.fit, C.pred, type = type,
                                  probability = TRUE), "probabilities")
                 svm.prob <- svm.prob[, which(colnames(svm.prob) == "1")]
                 storfac[, colcount] <- as.numeric(svm.prob > threshold)
                 colcount <- colcount + 1
               }
               if (family == "multinomial") {
                 svm.prob <- attr(predict(svm.fit, C.pred, type = type,
                                  probability = TRUE), "probabilities")
                 sord <- cbind(1:ncol(svm.prob), 
                               as.numeric(colnames(svm.prob)) + 1)
                 svmord <- sord[order(sord[,2]), ]
                 svm.prob <- svm.prob[, svmord[, 1]]
                 storfac[, colcount] <- as.numeric((apply(svm.prob, 1, 
                                                          which.max))) - 1
                 colcount <- colcount + 1
               }
             }
             if (type == "prob") {
               type.svm <- "response"
               if (family == "binomial") {
                 svm.prob <- attr(predict(svm.fit, C.pred, type = type.svm,
                                  probability = TRUE), "probabilities")
                 svm.prob <- svm.prob[, which(colnames(svm.prob) == "1")]
                 storprob[[colcount]] <- as.numeric(svm.prob)
                 colcount <- colcount + 1
               }
               if (family == "multinomial") {
                 storprob[[colcount]] <- attr(predict(svm.fit, C.pred, 
                                              type = type.svm,
                                              probability = TRUE),
                                              "probabilities")
                 colcount <- colcount + 1
               }
             }
           }
           if ('3' %in% method) {
             rf.fit <- opt.model[[w]][[3]]
             if (type == "response") {
               if (family == "binomial") {
                 rf.prob <- predict(rf.fit, C.pred, type = "prob")
                 rf.prob <- rf.prob[, which(colnames(rf.prob) == "1")]
                 storfac[, colcount] <- as.numeric(rf.prob > threshold)
                 colcount <- colcount + 1
               }
               if (family == "multinomial") {
                 rf.prob <- predict(rf.fit, C.pred, type = "prob")
                 storfac[, colcount] <- as.numeric((apply(rf.prob, 1, 
                                                          which.max))) - 1
                 colcount <- colcount + 1
               }
             }
             if (type == "prob") {
               if (family == "binomial") {
                 rf.prob <- predict(rf.fit, C.pred, type = "prob")
                 rf.prob <- rf.prob[, which(colnames(rf.prob) =="1")]
                 storprob[[colcount]] <- as.numeric(rf.prob)
                 colcount <- colcount + 1
               }
               if (family == "multinomial") {
                 storprob[[colcount]]  <- predict(rf.fit, C.pred, type = "prob")
                 colcount <- colcount + 1
               }
             }
           }
           if ('4' %in% method) {
             nn.fit <- opt.model[[w]][[4]]
             if (type == "response") {
               if (family == "binomial") {
                 nn.prob <- predict(nn.fit, newdata = C.pred, type = "raw")
                 nn.prob <- nn.prob[, which(colnames(nn.prob) == "y1")]
                 storfac[, colcount] <- as.numeric(nn.prob > threshold)
                 colcount <- colcount + 1
               }
               if (family == "multinomial") {
                 nn.prob <- predict(nn.fit, newdata = C.pred, type = "raw")
                 storfac[, colcount] <- as.numeric((apply(nn.prob, 1, 
                                                          which.max))) - 1
                 colcount <- colcount + 1
               }
             }
             if (type == "prob") {
               if (family == "binomial") {
                 nn.prob <- predict(nn.fit, newdata = C.pred, type = "raw")
                 nn.prob <- nn.prob[, which(colnames(nn.prob) =="y1")]
                 storprob[[colcount]] <- as.numeric(nn.prob)
                 colcount <- colcount + 1
               }
               if (family == "multinomial") {
                 storprob[[colcount]]  <- predict(nn.fit, C.pred, type = "raw")
                 colcount <- colcount + 1
               }
             }
           }
           if ('5' %in% method) {
             rda.fit <- opt.model[[w]][[5]]
             if (type == "response") {
               if (family == "binomial") {
                 rda.prob <- predict(rda.fit, x = t(train.weights[[w]]), 
                                     y = as.numeric(oyold) - 1, 
                                     xnew = t(C.pred), type = "posterior")
                 colnames(rda.prob) <- c(0, 1)
                 rda.prob <- rda.prob[, which(colnames(rda.prob) == "1")]
                 storfac[, colcount] <- as.numeric(rda.prob > threshold)
                 colcount <- colcount + 1
               }
               if (family == "multinomial") {
                 rda.prob <- predict(rda.fit, x = t(train.weights[[w]]), 
                                     y = as.numeric(oyold) - 1, 
                                     xnew = t(C.pred), type = "posterior")
                 storfac[, colcount] <- as.numeric((apply(rda.prob, 1, 
                                                          which.max))) - 1
                 colcount <- colcount + 1
               }
             }
             if (type == "prob") {
               if (family == "binomial") {
                 rda.prob <- predict(rda.fit, x = t(train.weights[[w]]), 
                                     y = as.numeric(oyold) - 1, 
                                     xnew = t(C.pred), type = "posterior")
                 colnames(rda.prob) <- c(0, 1)
                 rda.prob <- rda.prob[, which(colnames(rda.prob) == "1")]
                 storprob[[colcount]] <- as.numeric(rda.prob)
                 colcount <- colcount + 1
               }
               if (family == "multinomial") {
                 storprob[[colcount]]  <- predict(rda.fit, 
                                                  x = t(train.weights[[w]]), 
                                                  y = as.numeric(oyold) - 1, 
                                                  xnew = t(C.pred), 
                                                  type = "posterior")
                 colcount <- colcount + 1
               }
             }
           }
           if ('6' %in% method) {
             gbm.fit <- opt.model[[w]][[6]]
             xgdata <- xgb.DMatrix(data = C.pred)
             num_classes <- length(unique(oyold))
             if (type == "response") {
               if (family == "binomial") {
                 gbm.pred <- predict(gbm.fit, xgdata)
                 storfac[, colcount] <- as.numeric(gbm.pred > threshold)       
               }
               if (family == "multinomial") {
                 gbm.pred <- matrix(predict(gbm.fit, xgdata), 
                                    ncol = num_classes)
                 storfac[, colcount] <- as.numeric((apply(gbm.pred, 1, 
                                                          which.max))) - 1
               }
             }
             if (type == "prob") {
               if (family == "binomial") {
                 storprob[[colcount]] <- predict(gbm.fit, xgdata)
               }
               if (family == "multinomial") {
                 storprob[[colcount]] <- matrix(predict(gbm.fit, xgdata), 
                                                ncol = num_classes)
               }
             }
           } 
       }
    }
    storfac <- as.data.frame(storfac)
    colnames(storfac) <- stor.name
    names(storprob) <- stor.name
    if (type == "classify.weights") {
      classify.weight.names <- paste(nfac, "-component(s)", sep ="")
      names(classify.weights) <- classify.weight.names
      return(classify.weights)
    } 
    if (type == "response") {return(storfac)} 
    if (type == "prob") {return(storprob)}
}

kcv.rda <-
  function(x, y, foldid = NULL, rda.grid, nfolds = NULL, prior = NULL,
           regularization = "S", genelist = FALSE, trace = FALSE, 
           parallel = FALSE) 
{
    kcvcheck(y = y, nfolds = nfolds, parallel = parallel, foldid = foldid)
    if (is.null(prior)) {
      frac <- table(y) / length(y)
      prior <- rep(1 / length(frac), length(frac))
    }
    grid.row <- nrow(rda.grid)
    cv.rda <- matrix(rep(0, grid.row * nfolds), ncol = nfolds)
    if (parallel == TRUE) {
      cv.rda <- foreach(gg = 1:nfolds, .combine = cbind, 
                        .packages = 'rda') %dorng% {
                        x.train <- as.matrix(x[which(foldid != gg), ])
                        y.train <- y[which(foldid != gg)]
                        x.test <- as.matrix(x[which(foldid == gg), ])
                        y.test <- y[which(foldid == gg)]
                        stortune <- matrix(rep(0, grid.row), ncol = 1)
                        for (yy in 1:grid.row) {
                           rda.fit <- rda(x = t(x.train), y = y.train, 
                                          prior = prior, 
                                          alpha = rda.grid[yy, 1],
                                          delta = rda.grid[yy, 2],
                                          regularization = regularization,
                                          genelist = genelist, trace = trace)
                           rda.pred <- predict(rda.fit, x = t(x.train), 
                                               y = y.train, xnew = t(x.test), 
                                               alpha = rda.grid[yy, 1], 
                                               delta = rda.grid[yy, 2], 
                                               type = "class") - 1
                           stortune[yy, 1] <- 1 - mean(rda.pred == y.test) 
                        }
                        cv.rda[, gg] <- stortune
                }
    } else {
      for (gg in 1:nfolds) {
         x.train <- as.matrix(x[which(foldid != gg), ])
         y.train <- y[which(foldid != gg)]
         x.test <- as.matrix(x[which(foldid == gg), ])
         y.test <- y[which(foldid == gg)]
         stortune <- matrix(rep(0, grid.row), ncol = 1)
         for (yy in 1:grid.row) {
            rda.fit <- rda(x = t(x.train), y = y.train, 
                           prior = prior, alpha = rda.grid[yy, 1], 
                           delta = rda.grid[yy, 2], 
                           regularization = regularization, genelist = genelist, 
                           trace = trace)
            rda.pred <- predict(rda.fit, x = t(x.train), y = y.train, 
                                xnew = t(x.test), alpha = rda.grid[yy, 1], 
                                delta = rda.grid[yy, 2], type = "class") - 1
            stortune[yy, 1] <- 1 - mean(rda.pred == y.test) 
         }
         cv.rda[, gg] <- stortune
      }
    }
    rda.mean <- apply(cv.rda, 1, mean)
    minid <- which.min(rda.mean)
    rda.fit.best <- rda(x = t(x), y = y, prior = prior, 
                        alpha = rda.grid[minid, 1], delta = rda.grid[minid, 2],
                        regularization = regularization, genelist = genelist, 
                        trace = trace)
    return(list(rda.grid.id = minid, rda.fit = rda.fit.best, 
                error = rda.mean[minid]))
}

numcheck <- 
  function(argum) 
{
    argnam <- deparse(substitute(argum))
    if (length(argum) != 1L) {
      stop(sprintf("Input '%s' must contain only a single value.", argnam), 
           call. = FALSE)
    }
    if (!(is.numeric(argum))) {
      stop(sprintf("Input '%s' must be of class 'numeric'.", argnam), 
           call. = FALSE)
    }
    if ((is.infinite(argum)) || (is.na(argum)) || (is.nan(argum))) { 
      stop(sprintf("Input '%s' must be a finite number and cannot be NA \n 
                   or NaN.", argnam), call. = FALSE)
    }
}

logicheck <- 
  function(argu) 
{
    argnam <- deparse(substitute(argu))
    if (length(argu) != 1L) {
      stop(sprintf("Input '%s' must contain only a single value.", argnam), 
           call. = FALSE)
    }
    if (!(is.logical(argu))) {
      stop(sprintf("Input '%s' must be of class 'logical'.", argnam), 
           call. = FALSE)
    }
}

distdraw <- 
  function(dname = "normal", n = 1e2, params = NULL, modes = "A") 
{
  if (is.null(n)) {n <- 1e2}
  if (length(n) != 1) {stop("Input 'n' must be a single value.")}
  if ((is.infinite(n)) || (is.na(n)) || (is.nan(n))) {
    stop("Input 'n' must be a finite number and cannot be NA or NaN.")
  }
  if ((!is.numeric(n)) || (n < 1) || (n != floor(n))) { 
    stop("Input 'n' must be an integer value of 1 or greater.") 
  }
  allowmodes <- c("A", "B", "C", "G", "E")
  if (length(modes) != 1) {
    stop("Input 'modes' must be specified as a single letter from: ", 
         paste(allowmodes, collapse = ", "))
  }
  modeselected <- toupper(modes)
  if (!(modeselected %in% allowmodes)) {
    stop("Input 'modes' must be one of the following: ", 
         paste(allowmodes, collapse = ", "))
  }
  modes <- modeselected; dname <- tolower(dname)
  normalparams <- list(mean = 0, sd = 1)
  uniformparams <- list(min = 0, max = 1)
  gammaparams <- list(shape = 1, scale = 1)
  betaparams <- list(shape1 = 1, shape2 = 1)
  binomialparams <- list(size = 1, prob = 0.5)
  poissonparams <- list(lambda = 1)
  exponentialparams <- list(rate = 1)
  geometricparams <- list(prob = 0.5)
  negbinomialparams <- list(size = 1, prob = 0.5)
  hypergeoparams <- list(m = 1, n = 1, k = 1)
  lognormalparams <- list(meanlog = 0, sdlog = 1)
  cauchyparams <- list(location = 0, scale = 1)
  distfuncs <- list(
     normal = function(n, params) do.call(rnorm, c(list(n = n), params)),
     uniform = function(n, params) do.call(runif, c(list(n = n), params)),
     gamma = function(n, params) do.call(rgamma, c(list(n = n), params)),
     beta = function(n, params) do.call(rbeta, c(list(n = n), params)),
     binomial = function(n, params) do.call(rbinom, c(list(n = n), params)),
     poisson = function(n, params) do.call(rpois, c(list(n = n), params)),
     exponential = function(n, params) do.call(rexp, c(list(n = n), params)),
     geometric = function(n, params) do.call(rgeom, c(list(n = n), params)),
     negbinomial = function(n, params) do.call(rnbinom, c(list(n = n), params)),
     hypergeo = function(n, params) do.call(rhyper, c(list(nn = n), params)),
     lognormal = function(n, params) do.call(rlnorm, c(list(n = n), params)),
     cauchy = function(n, params) do.call(rcauchy, c(list(n = n), params)))
  if (!(dname %in% names(distfuncs))) {
    stop(sprintf("For mode '%s', input 'dname' must be the name of a \n
                 valid distribution.", modes))
  }
  if (is.null(params)) {
    params <- switch(dname, normal = normalparams, uniform = uniformparams, 
                     gamma = gammaparams, beta = betaparams,
                     binomial = binomialparams, poisson = poissonparams, 
                     exponential = exponentialparams, 
                     geometric = geometricparams,
                     negbinomial = negbinomialparams, hypergeo = hypergeoparams, 
                     lognormal = lognormalparams, cauchy = cauchyparams)
  } else {
    if ((length(params) > 0) && (!(is.numeric(unlist(params))))) {
      stop(sprintf("For mode '%s', input 'params' must contain numeric \n
                    values.", modes))
    }
    if ((length(params) > 0) && (is.null(names(params)))) {
      stop(sprintf("For mode '%s', input 'params' must be a named list.", 
                   modes))
    }
  }
  allowedparams <- list(normal = c("mean", "sd"), uniform = c("min", "max"), 
                        gamma = c("shape", "scale"), 
                        beta = c("shape1", "shape2"), 
                        binomial = c("size", "prob"), poisson = c("lambda"), 
                        exponential = c("rate"), geometric = c("prob"), 
                        negbinomial = c("size", "prob"), 
                        hypergeo = c("m", "n", "k"), 
                        lognormal = c("meanlog", "sdlog"), 
                        cauchy = c("location", "scale"))
  if (!(all(tolower(names(params)) %in% allowedparams[[dname]]))) {
    invalidnames <- names(params)[!(tolower(names(params)) %in% 
                                      allowedparams[[dname]])]
    stop(sprintf("For mode '%s', invalid parameter name(s) for %s \n
                 distribution: %s", modes, dname, paste(invalidnames, 
                                                           collapse = ", ")))
  }
  names(params) <- tolower(names(params))
  defaultparams <- list(normal = normalparams, uniform = uniformparams, 
                        gamma = gammaparams, beta = betaparams, 
                        binomial = binomialparams, poisson = poissonparams, 
                        exponential = exponentialparams, 
                        geometric = geometricparams, 
                        negbinomial = negbinomialparams, 
                        hypergeo = hypergeoparams, lognormal = lognormalparams, 
                        cauchy = cauchyparams)
  for (param in allowedparams[[dname]]) {
    if ((!(param %in% names(params)))) {
      params[[param]] <- defaultparams[[dname]][[param]]
    }
  }
  switch(dname,
         normal = {
           if (params$sd <= 0) {
             stop(sprintf("For mode '%s', for normal distribution, \n
                          'sd' must be greater than 0.", modes))
           }
         },
         uniform = {
           if (params$min >= params$max) {
             stop(sprintf("For mode '%s', for uniform distribution, 'min' \n
                          must be less than 'max'.", modes))
           }
         },
         gamma = {
           if (params$shape <= 0) {
             stop(sprintf("For mode '%s', for gamma distribution, 'shape' \n 
                          must be greater than 0.", modes))
           }
           if (params$scale <= 0) {
             stop(sprintf("For mode '%s', for gamma distribution, 'scale' \n 
                          must be greater than 0.", modes))
           }
         },
         beta = {
           if (params$shape1 <= 0) {
             stop(sprintf("For mode '%s', for beta distribution, 'shape1' \n 
                          must be greater than 0.", modes))
           }
           if (params$shape2 <= 0) {
             stop(sprintf("For mode '%s', for beta distribution, 'shape2' \n 
                          must be greater than 0.", modes))
           }
         },
         binomial = {
           if (params$size < 0) {
             stop(sprintf("For mode '%s', for binomial distribution, 'size' \n 
                          must be zero or positive.", modes))
           }
           mnumb <- .Machine$double.eps^0.5
           if ((!(abs(params$size - round(params$size)) < mnumb))) {
             stop(sprintf("For mode '%s', for binomial distribution, 'size' \n 
                          must be an integer.", modes))
           }
           if ((params$prob < 0) || (params$prob > 1)) {
             stop(sprintf("For mode '%s', for binomial distribution, 'prob' \n 
                          must be between 0 and 1, inclusive.", modes))
           }
         },
         poisson = {
           if (params$lambda < 0) {
             stop(sprintf("For mode '%s', for poisson distribution, 'lambda' \n 
                          must be greater than or equal to 0.", modes))
           }
         },
         exponential = {
           if (params$rate <= 0) {
             stop(sprintf("For mode '%s', for exponential distribution, \n 
                          'rate' must be greater than 0.", modes))
           }
         },
         geometric = {
           if ((params$prob <= 0) || (params$prob > 1)) {
             stop(sprintf("For mode '%s', for geometric distribution, 'prob' \n 
                          must be greater than 0 and less than or equal to 1", 
                          modes))
           }
         },
         negbinomial = {
           if (params$size <= 0) {
             stop(sprintf("For mode '%s', for negative binomial distribution, \n
                          'size' must be a positive real number.", modes))
           }
           mnumb <- .Machine$double.eps^0.5
           if ((!(abs(params$size - round(params$size)) < mnumb))) {
             stop(sprintf("For mode '%s', for negative binomial distribution, \n 
                          'size' must be an integer.", modes))
           }
           if ((params$prob <= 0) || (params$prob > 1)) {
             stop(sprintf("For mode '%s', for negative binomial distribution, \n 
                          'prob' must be greater than 0 and less than or \n
                          equal to 1.", modes))
           }
         },
         hypergeo = {
           if (params$m < 0) {
             stop(sprintf("For mode '%s', for hypergeometric distribution, \n 
                          'm' must be greater than or equal to 0.", modes))
           }
           if (params$n < 0) {
             stop(sprintf("For mode '%s', for hypergeometric distribution, \n 
                          'n' must be greater than or equal to 0.", modes))
           }
           if (params$k < 0) {
             stop(sprintf("For mode '%s', for hypergeometric distribution, \n 
                          'k' must be greater than or equal to 0.", modes))
           }
           mnumb <- .Machine$double.eps^0.5
           if ((!(abs(params$m - round(params$m)) < mnumb))) {
             stop(sprintf("For mode '%s', for hypergeometric distribution, \n 
                          'm' must be an integer.", modes))
           }
           if ((!(abs(params$n - round(params$n)) < mnumb))) {
             stop(sprintf("For mode '%s', for hypergeometric distribution, \n 
                          'n' must be an integer.", modes))
           }
           if ((!(abs(params$k - round(params$k)) < mnumb))) {
             stop(sprintf("For mode '%s', for hypergeometric distribution, \n 
                          'k' must be an integer.", modes))
           }
           if (params$k > (params$m + params$n)) {
             stop(sprintf("For mode '%s', for hypergeometric distribution, \n 
                          'k' cannot be greater than the sum of 'm' and \n
                          'n'.", modes))
           }
         },
         lognormal = {
           if (params$sdlog <= 0) {
             stop(sprintf("For mode '%s', for lognormal distribution, \n
                          'sdlog' must be greater than 0.", modes))
           }
         },
         cauchy = {
           if (params$scale <= 0) {
             stop(sprintf("For mode '%s', for Cauchy distribution, 'scale' \n 
                          must be greater than 0.", modes))
           }
         })
  result <- distfuncs[[dname]](n, params)
  return(result)
}

kcv.gbm <-
  function(x, y, foldid = NULL, gbm.grid, nfolds = NULL, weights = NULL,          
           family = c("binomial", "multinomial"), min_child_weight = 1,
           colsample_bytree = 1, booster = "gbtree", parallel = FALSE) 
{
    kcvcheck(y = y, nfolds = nfolds, parallel = parallel, foldid = foldid)
    if (family == "binomial") {objective <- "binary:logistic"; threshold <- 0.5}
    if (family == "multinomial") {objective <- "multi:softprob"}
    y <- as.numeric(y) - 1
    num_classes <- length(unique(y))
    grid.row <- nrow(gbm.grid)
    cv.gbm <- matrix(rep(0, grid.row * nfolds), ncol = nfolds)
    if (parallel == TRUE) {
      cv.gbm <- foreach(gg = 1:nfolds, .combine = cbind, 
                        .packages = 'xgboost') %dorng% {
                        x.train <- as.matrix(x[which(foldid != gg), ])
                        y.train <- y[which(foldid != gg)]
                        trweights <- as.matrix(weights[which(foldid != gg)])
                        xgtrain <- xgb.DMatrix(data = x.train, label = y.train, 
                                               weight = trweights)
                        x.test <- as.matrix(x[which(foldid == gg), ])
                        y.test <- y[which(foldid == gg)]
                        xgtest <- xgb.DMatrix(data = x.test)
                        stortune <- matrix(rep(0, grid.row), ncol = 1)
                        for (yy in 1:grid.row) {
                           params <- list(booster = booster,
                                          objective = objective,
                                          eta = gbm.grid[yy, 1],
                                          max_depth = gbm.grid[yy, 2],
                                          min_child_weight = min_child_weight,
                                          subsample = gbm.grid[yy, 3],
                                          colsample_bytree = colsample_bytree)
                           if (family == "multinomial") {
                             params$num_class <- num_classes
                           }                                                    
                           gbm.fit <- xgboost::xgb.train(params = params, 
                                                      data = xgtrain,
                                                      nrounds = gbm.grid[yy, 4], 
                                                      verbose = 0)
                           if (family == "binomial") {
                             gbm.pred <- predict(gbm.fit, xgtest)
                             gbm.class <- as.numeric(gbm.pred > threshold)
                           } else {
                             gbm.pred <- matrix(predict(gbm.fit, xgtest), 
                                                ncol = num_classes)
                             gbm.class <- as.numeric((apply(gbm.pred, 1, 
                                                            which.max))) - 1
                           }
                           stortune[yy, 1] <- 1 - mean(gbm.class == y.test) 
                        }
                        cv.gbm[, gg] <- stortune
                }
    } else {
      for (gg in 1:nfolds) {
         x.train <- as.matrix(x[which(foldid != gg), ])
         y.train <- y[which(foldid != gg)]
         trweights <- as.matrix(weights[which(foldid != gg)])
         xgtrain <- xgb.DMatrix(data = x.train, label = y.train, 
                                weight = trweights)
         x.test <- as.matrix(x[which(foldid == gg), ])
         y.test <- y[which(foldid == gg)]
         xgtest <- xgb.DMatrix(data = x.test)
         stortune <- matrix(rep(0, grid.row), ncol = 1)
         for (yy in 1:grid.row) {
            params <- list(booster = booster, objective = objective,
                           eta = gbm.grid[yy, 1], max_depth = gbm.grid[yy, 2],
                           min_child_weight = min_child_weight,
                           subsample = gbm.grid[yy, 3],
                           colsample_bytree = colsample_bytree)
            if (family == "multinomial") {params$num_class <- num_classes}
            gbm.fit <- xgboost::xgb.train(params = params, data = xgtrain,
                                          nrounds = gbm.grid[yy, 4], 
                                          verbose = 0)
            if (family == "binomial") {
              gbm.pred <- predict(gbm.fit, xgtest)
              gbm.class <- as.numeric(gbm.pred > threshold)
            } else {
              gbm.pred <- matrix(predict(gbm.fit, xgtest), ncol = num_classes)
              gbm.class <- as.numeric((apply(gbm.pred, 1, which.max))) - 1
            }
            stortune[yy, 1] <- 1 - mean(gbm.class == y.test) 
         }
         cv.gbm[, gg] <- stortune
      }
    }
    gbm.mean <- apply(cv.gbm, 1, mean)
    minid <- which.min(gbm.mean)
    params <- list(booster = booster, objective = objective, 
                   eta = gbm.grid[minid, 1], max_depth = gbm.grid[minid, 2],
                   min_child_weight = min_child_weight,
                   subsample = gbm.grid[minid, 3], 
                   colsample_bytree = colsample_bytree)
    if (family == "multinomial") {params$num_class <- num_classes}
    xgdata <- xgb.DMatrix(data = x, label = y, weight = weights)
    gbm.fit.best <- xgboost::xgb.train(params = params, data = xgdata, 
                                       nrounds = gbm.grid[minid, 4], 
                                       verbose = 0)
    return(list(gbm.grid.id = minid, gbm.fit = gbm.fit.best, 
                error = gbm.mean[minid]))
}

---
title: "An Introduction to cpfa"
author: 
  - Matthew Asisgress
date: "June 2026"
output: rmarkdown::pdf_document
vignette: >
  %\VignetteIndexEntry{An Introduction to cpfa}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  cache     = FALSE,
  warning   = FALSE,
  message   = FALSE,
  seed      = 500
)
```

## Outline

> Overview

> Installation

> Example 1: Four-way Array with Multiclass Response

> Example 2: Three-way Array with Binary Response

> Example 3: Two-way Matrix with Multiclass Response

> Concluding Thoughts

> References

## Overview

Package **cpfa** implements a k-fold cross-validation procedure to
predict class labels using component weights from a single mode of a
Parallel Factor Analysis model-1 (Parafac; Harshman, 1970) or a 
Parallel Factor Analysis model-2 (Parafac2; Harshman, 1972), 
which is fit to a three-way or four-way data array. The package also 
supports principal component analysis (PCA) applied to a two-way data matrix. 
After fitting a Parafac or Parafac2 model with package **multiway** via an
alternating least squares algorithm (Helwig, 2025), or after fitting a PCA 
model using the singular value decomposition, estimated component
weights from one mode of the selected component model are passed to one or more
classification methods. For each method, a k-fold cross-validation is
conducted to tune classification parameters using estimated component weights, 
optimizing class label prediction. This process is repeated over multiple 
train-test splits in order to improve the generalizability of results. Multiple 
constraint options are available to impose on any mode of the Parafac or 
Parafac2 model during the estimation step (see Helwig, 2017). Multiple numbers
of components can be considered in the primary package function `cpfa`. This 
vignette describes how to use the **cpfa** package.

## Installation

**cpfa** can be installed directly from CRAN. Type the following
command in an R console: 
`install.packages("cpfa", repos = "https://cran.r-project.org/")`. The argument 
`repos` can be modified according to user preferences. For more options and 
details, see `help(install.packages)`. In this case, the package **cpfa** has 
been downloaded and installed to the default directories. Users can download the 
package source at <https://cran.r-project.org/package=cpfa> and use Unix 
commands for installation.

## Example 1: Four-way Array with Multiclass Response

We start by using the simulation function `simcpfa` and examining basic
operations and outputs related to this function.

First, we load the **cpfa** package:

```{r, message = FALSE}
library(cpfa)
```

We simulate a four-way array where the fourth mode (i.e., the classification 
mode) of the simulated array is related to a response vector, which is also 
simulated. To generate data, we specify the data-generating model as a 
Parafac2 model via the `model` argument and specify three components for this 
model with the `nfac` argument. We specify the number of dimensions for the 
simulated array using the `arraydim` argument. However, because a Parafac2 model 
is used, the function ignores the first element of `arraydim` and looks for 
input provided through the argument `pf2num` instead. Argument `pf2num` 
specifies the number of rows in each three-way array that exists within each 
level of the fourth mode of the four-way ragged array being simulated. As a 
demonstration, we set `pf2num <- rep(c(7, 8, 9), length.out = 100)`, which
specifies that the number of rows alternates from 7, to 8, to 9, and back to 7,
across all 100 levels of the fourth mode of the simulated array. Note that a 
useful feature of Parafac2 is that it can be fit to ragged arrays directly, 
while maintaining the intrinsic axis property of Parafac (see Harshman and 
Lundy, 1994).

For these simulated data, we specify that the response vector should have three
classes using `nclass`. Moreover, we set a target correlation matrix, 
`corrpred`, specifying correlations among the columns of the classification 
mode's weight matrix (i.e., the fourth mode, in this case). We also specify 
correlations, contained in `corresp`, between columns of the classification 
mode's weight matrix and the response vector. Input `modes` sets the number of 
modes in the array; and we use `meanpred` to specify the target means for the 
columns of the classification mode weight matrix. Finally, `onreps` specifies 
the number of classification mode weight matrices to generate while `nreps` 
specifies, for any one classification mode weight matrix, the number of response 
vectors to generate. Both of these arguments work when `smethod = logistic`, 
which implements an iterative Monte Carlo rejection sampling procedure based on 
the generalized linear model (see `help(simcpfa)` for additional details of the 
simulation procedure). Then, in R we have the following:

```{r, message = FALSE, warning = FALSE}
# set seed for reproducibility
set.seed(500)

# specify correlation
cp <- 0.1

# define target correlation matrix for columns of fourth mode weight matrix
corrpred <- matrix(c(1, cp, cp, cp, 1, cp, cp, cp, 1), nrow = 3, ncol = 3)

# define correlations between fourth mode weight matrix and response vector
corresp <- rep(.85, 3)

# specify number of rows in the three-way array for each level of fourth mode
pf2num <- rep(c(7, 8, 9), length.out = 100)

# simulate a four-way ragged array connected to a response
data <- simcpfa(arraydim = c(10, 11, 12, 100), model = "parafac2", nfac = 3, 
                nclass = 3, nreps = 10, onreps = 10, corresp = corresp,
                pf2num = pf2num, modes = 4, corrpred = corrpred, 
                meanpred = c(10, 20, 30), smethod = "logistic")

# define simulated array 'X' and response vector 'y' from the output
X <- data$X
y <- data$y
```

The above creates a four-way array `X` with Parafac2 structure that is connected
through its fourth mode to response vector `y`. We confirm the dimensions of `X` 
and `y`, confirm their classes, and inspect the possible values of `y`:

```{r}
# examine data object X
class(X)
length(X)
dim(X[[1]])
dim(X[[2]])

# examine data object y
class(y)
length(y)
table(y)
```

As shown, `X` is a list where each element is a three-way array. The dimensions 
of `X` match those specified in input arguments `arraydim` and `pf2num`. 
Likewise, `y` is a factor with length equal to the number of levels of the 
fourth mode of `X`. As desired, we can see that `y` contains three classes.

We confirm that the columns of the fourth mode's weights are linearly associated
with `y`:

```{r}
# examine correlations between columns of fourth mode weights 'Dmat' and 
# simulated response vector 'y'
cor(data$Dmat, (as.numeric(data$y) - 1))
```

As shown, the classification mode weight matrix `Dmat` contains columns that 
have a positive correlation with the response vector `y`. The target 
correlations (i.e., 0.85) were not achieved, especially given that 
`nreps = 10` and `onreps = 10` were small values. Nevertheless, achieved
positive correlations indicate that building a classifier between `X` 
and `y` through the fourth mode of a three-component Parafac2 model could prove 
useful.

We initialize values for tuning parameter $\alpha$ from penalized logistic
regression (PLR) implemented through package **glmnet** (Friedman, 
Hastie, and Tibshirani, 2010; Zou and Hastie, 2005). We specify the 
classification method as PLR through `method`, the model of interest as Parafac2 
through `model`, the number of folds in the k-fold cross-validation step as 
three through `nfolds`, and the number of random starts for fitting the Parafac2 
model as three through `nstart`. Further, we specify `nfac` to be two or three 
because we wish to explore classification performance for a two-component model 
and for a three-component model. The classification problem is multiclass, which 
is specified by setting `multinomial` for input `family`. In this demonstration, 
we allow for three train-test splits by setting `nrep <- 3` with a split ratio
of `ratio <- 0.9`. Finally, we set a Parafac2 model constraint: the fourth mode 
must have non-negative weights. We use `const` to set this constraint. In R:

```{r}
# set seed
set.seed(500)

# initialize alpha and store within a list called 'parameters'
alpha <- seq(0, 1, length.out = 11)
parameters <- list(alpha = alpha)

# initialize inputs
method <- "PLR"
model <- "parafac2"
nfolds <- 3
nstart <- 3
nfac <- c(2, 3)
family <- "multinomial"
nrep <- 3
ratio <- 0.9
const <- c("uncons", "uncons", "uncons", "nonneg")

# implement train-test splits with inner k-fold CV to optimize classification
output <- cpfa(x = X, y = y, model = model, nfac = nfac, 
               nrep = nrep, ratio = ratio, nfolds = nfolds, method = method, 
               family = family, parameters = parameters, plot.out = FALSE, 
               parallel = FALSE, const = const, nstart = nstart, 
               verbose = FALSE, align = TRUE)
```

The function can generate box plots of classification accuracy for 
each number of components and for each classification method, but we set 
`plot.out = FALSE` and do not produce them. We examine classification 
performance in the output object:

```{r}
# examine classification performance measures - median across train-test splits
output$descriptive$median[, 1:2]
```

As shown, classification accuracy (i.e., 'acc') is relatively fair (for more 
details on classification performance measures, see help file for package 
function `cpm` via `help(cpm)`). In this case, the data-generating model with 
three components worked best for classification purposes. We also examine, 
averaged across train-test splits, optimal tuning parameters. Note that 
**glmnet** optimized tuning parameter $\lambda$ internally.

```{r}
# examine optimal tuning parameters averaged across train-test splits
output$mean.opt.tune
```

We can see average values for $\alpha$ that worked best. In addition, the best 
average $\lambda$ values are also displayed. Note that other classifiers were 
not used in this demonstration, but their tuning parameters are indicated in the 
output with placeholders of NA.

Next, we could use the package function `plotcpfa` to fit the best (in terms of 
mean accuracy) Parafac2 model and to plot the results. The code looks like this:

```{r, eval = FALSE}
# set seed
set.seed(500)

# plot heat maps of component weights for optimal model
results <- plotcpfa(output, nstart = 3, ctol = 1e-1, verbose = FALSE)
```

Generated plots are heat maps displaying the magnitude of estimated component
weights for the second (B) and third (C) modes. Because the input array was 
simulated, these plots would not display meaningful results. As such, we omit 
the heat maps for this example. For such plots, while `cpfa` can 
serve as a guide to identify a meaningful number of components and a meaningful 
set of constraints for different modes, the function `plotcpfa` can be used to 
visualize component weights of the best model to understand how levels of each 
mode map onto components. To see heat maps, interested readers might explore the 
application of this package to several real datasets. See here for examples: 
<https://github.com/matthewasisgress/multiway-classification/>.

To obtain a measure of feature importance among features in the model, we 
calculate permutation feature importance (PFI; see Breiman, 2001). The function 
`pficpfa` calculates PFI for an object from function `cpfa`.

```{r}

# set seed
set.seed(500)

# calculate permutation feature importance for each feature
pfistats <- pficpfa(object = output, nshuffles = 5, type = "marginal")

# examine median pfi for classification accuracy and for nfac = 2
pfistats[which((pfistats$nfac == 2) & (pfistats$metric == "acc")), ]

```

As shown, we can observe the mean or median drop in classification accuracy, 
pooled across replications, after permuting observations for each feature.

Alternatively, we can set `type = conditional` to fit a conditioning model 
to predict each feature from the others; and the model's residuals are permuted 
and added back to the fitted values, preserving the feature's dependence on the 
other features (for more information, see Huang, 2025, and O'Gorman, 2005). We
can choose random forest as the conditioning model by setting 
`conditional.model = "rf"`. 

```{r}

# set seed
set.seed(500)

# calculate permutation feature importance for each feature
pfistats <- pficpfa(object = output, nshuffles = 5, type = "conditional",
                    conditional.model = "rf")

# examine median pfi for classification accuracy and for nfac = 2
pfistats[which((pfistats$nfac == 2) & (pfistats$metric == "acc")), ]


```

As shown, the mean and median importance calculations are lower. Conditional
permutation feature importance is useful when features are correlated.

## Example 2: Three-way Array with Binary Response

We now simulate a three-way array. For this array, the third mode is related 
linearly to a response vector of class labels, which is also simulated. To 
generate data using function `simcpfa`, we specify the data-generating model as 
a Parafac model via the `model` argument and specify two components for this 
model with the `nfac` argument. We specify the number of dimensions for the 
simulated array using the `arraydim` argument. 

For these simulated data, we specify that the response vector should have two
classes using `nclass`. Moreover, we set a target correlation matrix, 
`corrpred`, specifying correlations among the columns of the classification 
mode's weight matrix (i.e., in this case, the third mode). We also specify 
correlations, contained in `corresp`, between columns of the classification 
mode's weight matrix and the response vector. 

```{r, message = FALSE, warning = FALSE}
# set seed for reproducibility
set.seed(400)

# specify correlation
cp <- 0.1

# define target correlation matrix for columns of third mode weight matrix
corrpred <- matrix(c(1, cp, cp, 1), nrow = 2, ncol = 2)

# define correlations between third mode weight matrix and response vector
corresp <- rep(.9, 2)

# simulate a three-way array connected to a binary response
data <- simcpfa(arraydim = c(10, 11, 100), model = "parafac", nfac = 2, 
                nclass = 2, nreps = 10, onreps = 10, corresp = corresp,
                modes = 3, corrpred = corrpred, meanpred = c(10, 20), 
                smethod = "logistic")

# define simulated array 'X' and response vector 'y' from the output
X <- data$X
y <- data$y
```

The above creates a three-way array `X` with Parafac structure that is connected
through its third mode to response vector `y`. We confirm the dimensions of `X` 
and `y`, confirm their classes, and inspect the possible values of `y`:

```{r}
# examine data object X
class(X)
dim(X)

# examine data object y
class(y)
length(y)
table(y)
```

As shown, `X` is a three-way array. The dimensions of `X` match those specified 
in input argument `arraydim`. Likewise, `y` is a factor with length equal to the 
number of levels of the third mode of `X`. As desired, we can see that `y` 
contains two classes.

We confirm that the columns of the third mode's weights are linearly associated
with `y`:

```{r}
# examine correlations between columns of third mode weights 'Cmat' and 
# simulated response vector 'y'
cor(data$Cmat, (as.numeric(data$y) - 1))
```

As shown, the classification mode weight matrix `Cmat` contains columns that 
have a positive correlation with the response vector `y`. The target 
correlations (i.e., 0.9) were not achieved, especially given that 
`nreps = 10` and `onreps = 10` were small values. Nevertheless, the
positive correlations indicate that building a classifier between `X` 
and `y` through the third mode of a two-component Parafac model could prove 
useful.

We initialize values for tuning parameter $\alpha$ from PLR implemented through 
package **glmnet**. We also initialize values for the tuning parameters `ntree` 
(i.e., number of trees) and `nodesize` (i.e., node size) from random forest
(RF; Breiman, 2001) implemented through package **randomForest** 
(Liaw and Wiener, 2002). We specify the classification methods as PLR and RF 
through `method`, the model of interest as Parafac through `model`, the number 
of folds in the k-fold cross-validation step as three through `nfolds`, and the 
number of random starts for fitting the Parafac model as three through `nstart`. 
Further, we specify `nfac` to be two or three because we wish to explore 
classification performance for a two-component model and for a three-component 
model. The classification problem is binary, which is specified by setting 
`binomial` for input `family`. We allow for three train-test splits by setting 
`nrep <- 3` with a split ratio of `ratio <- 0.9`. Finally, for this 
demonstration, we set a Parafac model constraint: the second mode must have 
orthogonal weights. We use `const` to set this constraint. In R:

```{r}
# set seed
set.seed(300)

# initialize tuning parameters and store within a list called 'parameters'
alpha <- seq(0, 1, length.out = 3)
ntree <- c(200, 400)
nodesize <- c(2, 4)
parameters <- list(alpha = alpha, ntree = ntree, nodesize = nodesize)

# initialize inputs
method <- c("PLR", "RF")
model <- "parafac"
nfolds <- 3
nstart <- 3
nfac <- c(2, 3)
family <- "binomial"
nrep <- 3
ratio <- 0.9
const <- c("uncons", "orthog", "uncons")

# implement train-test splits with inner k-fold CV to optimize classification
output <- cpfa(x = X, y = y, model = "parafac", nfac = nfac, 
               nrep = nrep, ratio = ratio, nfolds = nfolds, method = method, 
               family = family, parameters = parameters, plot.out = FALSE, 
               parallel = FALSE, const = const, nstart = nstart, 
               verbose = FALSE)
```

We examine classification performance in the output object:

```{r}
# examine classification performance measures - mean across train-test splits
output$descriptive$mean[, 1:2]
```

As shown, classification accuracy is highest for the two-component RF 
classifier. In this case, the data-generating model with two components worked 
best for classification purposes (i.e., compared to the three-component model). 
We also examine, averaged across train-test splits, optimal tuning parameters.

```{r}
# examine optimal tuning parameters averaged across train-test splits
output$mean.opt.tune
```

We can see average tuning values that worked best. For example, PLR favored 
$\alpha = 0$ for the two-component model (i.e., preferred ridge regression).

We next could use the function `plotcpfa` to fit the best Parafac model and to 
plot the results. The code looks like this:

```{r, eval = FALSE}
# set seed
set.seed(400)

# plot heat maps of component weights for optimal model
results <- plotcpfa(output, nstart = 3, ctol = 1e-1, verbose = FALSE)
```

As in the previous example, the simulated array contains mode A and 
mode B weights whose levels do not have a substantive meaning. As such, we
omit the heat maps for this example. However, if these were real data, such heat 
maps could reveal relationships between model components and the levels of mode 
A or B. As previously described, interested readers might explore the 
application of this package to several real datasets. See here for more 
examples: <https://github.com/matthewasisgress/multiway-classification/>.

## Example 3: Two-way Matrix with Multiclass Response

We now simulate a two-way matrix. For this matrix, the second mode is related 
linearly to a response vector of class labels, which is also simulated. To 
generate data using function `simcpfa`, we specify the data-generating model as 
a PCA model via the `model` argument and specify three components for this 
model with the `nfac` argument. We specify the number of dimensions for the 
simulated matrix using the `arraydim` argument. For a matrix only, the 
classification mode is assumed to be the first mode while the mode containing
variables/predictors is assumed to be the second mode.

For these simulated data, we specify that the response vector should have three
classes using `nclass`. Moreover, we set a target correlation matrix, 
`corrpred`, specifying correlations among the columns of the classification 
mode's weight matrix (i.e., in this case, the first mode). We also specify 
correlations, contained in `corresp`, between columns of the classification 
mode's weight matrix and the response vector. For this example, we use the
second simulation method `eigende`, which simulates component weights and a 
latent response variable simultaneously from a joint multivariate normal 
distribution using an eigendecomposition, discretizing the response into class 
labels using quantile cuts defined by the cumulative sum of `props`. Without 
specifying `props`, this argument defaults to equal class proportions. We ensure 
that argument `modes` is set to 2.

```{r, message = FALSE, warning = FALSE}
# set seed for reproducibility
set.seed(400)

# specify correlation
cp <- 0.1

# define target correlation matrix for columns of first mode weight matrix
a <- matrix(cp, nrow = 3, ncol = 3); diag(a) <- 1; corrpred <- a

# define correlations between first mode weight matrix and response vector
corresp <- rep(.5, 3)

# simulate a two-way matrix connected to a multiclass response
data <- simcpfa(arraydim = c(200, 10), model = "pca", nfac = 3, 
                nclass = 3, corresp = corresp, modes = 2, corrpred = corrpred, 
                smethod = "eigende")

# define simulated matrix 'X' and response vector 'y' from the output
X <- data$X
y <- data$y
```

The above creates a two-way matrix `X` with PCA structure that is connected
through its second mode to response vector `y`. We confirm the dimensions of `X` 
and `y`, confirm their classes, and inspect the possible values of `y`:

```{r}
# examine data object X
class(X)
dim(X)

# examine data object y
class(y)
length(y)
table(y)
```

As shown, `X` is a two-way matrix. The dimensions of `X` match those specified 
in input argument `arraydim`. Likewise, `y` is a factor with length equal to the 
number of levels of the first mode of `X`. As desired, we can see that `y` 
contains three classes. We see that the output classes in `y` are balanced.

We confirm that the columns of the first mode's weights are linearly associated
with `y` (note: while `Bmat` is associated with the second mode in Parafac and 
Parafac2 models, it is associated with the _first_ mode in PCA for the `simcpfa` 
function):

```{r}
# examine correlations between columns of first mode weights 'Bmat' and 
# simulated response vector 'y'
cor(data$Bmat, (as.numeric(data$y) - 1))
```

As shown, the classification mode weight matrix `Bmat` contains columns that 
have a positive correlation with the response vector `y`. The target 
correlations (i.e., 0.5) were nearly achieved. The positive correlations 
indicate that building a classifier between `X` and `y` through the first mode 
of a three-component PCA model could prove useful. Again, for emphasis, 
while `Bmat` is associated with the second mode in Parafac and Parafac2 models, 
it is associated with the _first_ mode in PCA for this function.

As before, we initialize values for tuning parameter $\alpha$ from PLR 
implemented through package **glmnet**. We specify the model of interest as PCA 
through `model`.  We specify other arguments in a fashion similar to the 
previous example (i.e., Example 2). We also specify that we wish to apply a 
Varimax rotation to the loadings matrix for the PCA solution by setting 
`pcarot = "varimax"`. In R:

```{r}
# set seed
set.seed(300)

# initialize tuning parameters and store within a list called 'parameters'
alpha <- seq(0, 1, length.out = 5)
parameters <- list(alpha = alpha)

# initialize inputs
method <- c("PLR")
model <- "pca"
nfolds <- 3
nfac <- c(2, 3)
family <- "multinomial"
nrep <- 3
ratio <- 0.9

# implement train-test splits with inner k-fold CV to optimize classification
output <- cpfa(x = X, y = y, model = model, nfac = nfac, 
               nrep = nrep, ratio = ratio, nfolds = nfolds, method = method, 
               family = family, parameters = parameters, plot.out = FALSE, 
               parallel = FALSE, verbose = FALSE, pcarot = "varimax")
```

We examine classification performance in the output object:

```{r}
# examine classification performance measures - mean across train-test splits
output$descriptive$mean[, 1:2]
```

As shown, classification accuracy is highest for the three-component PLR
classifier. In this case, the data-generating model with three components worked 
best for classification purposes (i.e., compared to the two-component model). 
We also examine, averaged across train-test splits, optimal tuning parameters.

```{r}
# examine optimal tuning parameters averaged across train-test splits
output$mean.opt.tune
```

We can see average tuning values that worked best. We next can use the function 
`plotcpfa` to fit the best PCA model and to plot the results. The R code is
provided but not evaluated:

```{r, eval = FALSE}
# set seed
set.seed(400)

# plot heat maps of component weights for optimal model
results <- plotcpfa(output)
```

The simulated matrix contains mode A as the loadings and mode B as the scores.
As in the previous example, the levels do not have a substantive meaning. 
As such, we omit the heat maps for this example. However, if these were real 
data, such heat maps could reveal relationships between model components and 
the levels of mode A (i.e., for PCA, the loadings).

## Concluding Thoughts

Package **cpfa** implements a k-fold cross-validation procedure, connecting 
Parafac and Parafac2 models fit by **multiway** to classification methods 
implemented through six popular packages used for classification: **glmnet**; 
**e1071** (Meyer et al., 2024; Cortes and Vapnik, 1995); **randomForest** (Liaw 
and Wiener, 2002; Breiman, 2001); **nnet** (Ripley, 1994; Venables and Ripley, 
2002); **rda** (Guo, Hastie, and Tibshirani, 2007, 2023; Friedman, 1989), and 
**xgboost** (Chen et al., 2025; Friedman, 2001). Parallel computing is 
implemented through packages **parallel** (R Core Team, 2025); **doParallel**
(Microsoft Corporation and Weston, 2022); and **doRNG** (Gaujoux, 2025). The 
package also supports principal component analysis applied to a matrix. The 
examples above highlight the use of **cpfa** and three of its functions. For 
more information about the package, see https://CRAN.R-project.org/package=cpfa, 
or examine package help files with `help(simcpfa)`, `help(cpfa)`, or 
`help(plotcpfa)`.

## References

Breiman, L. (2001). Random forests. Machine Learning, 45(1), 5-32.

Chen, T., He, T., Benesty, M., Khotilovich, V., Tang, Y., Cho, H., Chen, K., 
Mitchell, R., Cano, I., Zhou, T., Li, M., Xie, J., Lin, M., Geng, Y., Li, Y., 
and Yuan, J. (2025). xgboost: Extreme gradient boosting. R Package Version 
1.7.9.1.

Corporation, M. and Weston S (2022). doParallel: foreach parallel adaptor for 
the 'parallel' package. R Package Version 1.0.17.

Cortes, C. and Vapnik, V. (1995). Support-vector networks. Machine Learning, 
20(3), 273-297.

Friedman, J. (2001). Greedy function approximation: a gradient boosting 
machine. Annals of Statistics, 29(5), 1189-1232.

Friedman, J. (1989). Regularized discriminant analysis. Journal of the 
American Statistical Association, 84(405), 165-175.

Friedman, J., Hastie, T., and Tibshirani, R. (2010). Regularization paths for 
generalized linear models via coordinate descent. Journal of Statistical 
Software, 33(1), 1-22.

Gaujoux, R. (2025). doRNG: Generic reproducible parallel backend for 'foreach' 
loops. R Package Version 1.8.6.2.

Guo, Y., Hastie, T., and Tibshirani, R. (2007). Regularized linear discriminant 
analysis and its application in microarrays. Biostatistics, 8(1), 86-100.

Guo, Y., Hastie, T., and Tibshirani, R. (2023). rda: Shrunken centroids 
regularized discriminant analysis. R Package Version 1.2-1.

Harshman, R. (1970). Foundations of the PARAFAC procedure: Models and 
conditions for an explanatory multimodal factor analysis. UCLA Working 
Papers in Phonetics, 16, 1-84.

Harshman, R. (1972). PARAFAC2: Mathematical and technical notes. UCLA Working 
Papers in Phonetics, 22, 30-44.

Harshman, R. and Lundy, M. (1994). PARAFAC: Parallel factor analysis. 
Computational Statistics and Data Analysis, 18, 39-72.

Helwig, N. (2017). Estimating latent trends in multivariate longitudinal data 
via Parafac2 with functional and structural constraints. Biometrical Journal, 
59(4), 783-803.

Helwig, N. (2025). multiway: Component models for multi-way data. R Package 
Version 1.0-7.

Hornik, K. (2005). A CLUE for CLUster ensembles. Journal of Statistical 
Software, 14, 1-25.

Hornik, K. (2026). clue: Cluster ensembles. R Package Version 0.3-68.

Huang, P. (2025). Residual permutation tests for feature importance in machine 
learning. British Journal of Mathematical and Statistical Psychology.

Liaw, A. and Wiener, M. (2002). Classification and regression by randomForest. 
R News 2(3), 18-22.

O'Gorman, T. (2005). The performance of randomization tests that use 
permutations of independent variables. Communications in Statistics - Simulation 
and Computation, 34(4), 895-908.

Meyer, D., Dimitriadou, E., Hornik, K., Weingessel, A., and Leisch, F. (2024). 
e1071: Misc functions of the Department of Statistics, Probability Theory 
Group (Formerly: E1071), TU Wien. R Package Version 1.7-16.

Microsoft Corporation and Weston, S. (2022). doParallel: foreach parallel 
adaptor for the 'parallel' package. R Package Version 1.0.17.

R Core Team (2025). R: A Language and Environment for Statistical Computing. R 
Foundation for Statistical Computing, Vienna, Austria.

Ripley, B. (1994). Neural networks and related methods for classification. 
Journal of the Royal Statistical Society: Series B (Methodological), 56(3), 
409-437.

Venables, W. and Ripley, B. (2002). Modern applied statistics with S. Fourth 
Edition. Springer, New York. ISBN 0-387-95457-0.

Zou, H. and Hastie, T. (2005). Regularization and variable selection via the 
elastic net. Journal of the Royal Statistical Society: Series B (Statistical 
Methodology), 67(2), 301-320.

\name{predict.tunecpfa}
\alias{predict.tunecpfa}
\title{
Predict Method for Tuning for Classification with Parallel Factor Analysis
}
\description{
Obtains predicted class labels from a 'tunecpfa' model object generated by 
function \code{tunecpfa}.
}
\usage{
\method{predict}{tunecpfa}(object, newdata = NULL, newdata.z = NULL, 
        method = NULL, type = c("response", "prob", "classify.weights"), 
        threshold = NULL, ...)
}
\arguments{
\item{object}{
  A fit object of class 'tunecpfa' produced by function \code{tunecpfa}.
}
\item{newdata}{
  An optional two-way matrix, three-way array, or four-way data array used to 
  predict Parafac, Parafac2, or PCA component weights using estimated Parafac, 
  Parafac2, or PCA model component weights from the input object. For Parafac2, 
  can be a list of length \code{K} where the \code{k}-th element is a matrix or 
  three-way array associated with the \code{k}-th observation. Matrix, array, or 
  list must contain only real numbers. Dimensions must match dimensions of 
  original data for all modes except the classification mode. If omitted, 
  the original data are used.
}
\item{newdata.z}{
  An optional two-way matrix containing additional features used to predict
  class labels. If omitted, and original \code{z} was NULL, defaults to NULL.
  Otherwise, if provided, this argument must have number of features equal to 
  the number of columns of the original \code{z}. As such, the original
  \code{z} must not have been NULL.
}
\item{method}{
  Character vector indicating classification methods to use. Possible methods 
  include penalized logistic regression (PLR); support vector machine (SVM); 
  random forest (RF); feed-forward neural network (NN); regularized 
  discriminant analysis (RDA); and gradient boosting machine (GBM). If none 
  selected, default is to use methods used in original \code{tunecpfa} run.
}
\item{type}{
  Character vector indicating type of prediction to return. Possible values 
  include: (1) \code{"response"}, returning predicted class labels; (2) 
  \code{"prob"}, returning predicted class probabilities; or (3) 
  \code{"classify.weights"}, returning predicted component weights used for 
  classification in the specified component models. Must be specified.
}
\item{threshold}{
  For binary classification, value indicating prediction threshold over which 
  observations are classified as the positive class. If not provided, 
  calculates threshold using class proportions in original data. For 
  multiclass classification, \code{threshold} is not currently implemented.
}
\item{...}{
  Additional predict arguments. Currently ignored.
}
}

\details{
Predicts class labels for a binary or a multiclass outcome. Specifically, 
predicts component weights for one mode of a Parallel Factor Analysis-1 
(Parafac) model, one mode of a Parallel Factor Analysis-2 (Parafac2) model, or
scores from a PCA model, using new data and previously estimated mode weights 
from original data. Passes predicted component weights (or scores for PCA) to 
one or several classification methods as new data for predicting class labels.

Tuning parameters optimized by k-fold cross-validation are used for each 
classification method (see help for \code{tunecpfa}). If not supplied in 
argument \code{threshold}, prediction threshold for all classification methods 
is calculated using proportions of class labels for original data in the 
binary case (and the positive class proportion is set as the threshold). For 
multiclass case, class with highest probability is chosen.
}
\value{
Returns one of the following, depending on the choice for argument \code{type}:

\item{type = "response"}{A data frame containing predicted class labels for each 
component model and classification method selected (see argument \code{type}). 
Number of columns is equal to number of methods times number of 
component models. Number of rows is equal to number of predicted observations.
}
\item{type = "prob"}{A list containing predicted probabilities for each 
component model and classification method selected (see argument \code{type}). 
The number of list elements is equal to the number of methods times the number 
of component models.
}
\item{type = "classify.weights"}{List containing predicted component weights 
for each component model. Length is equal to number of component models that 
were fit.
}
}
\note{
Applications of this function to real datasets can be explored at the following
repository: \url{https://github.com/matthewasisgress/multiway-classification/}.
}
\author{
Matthew Asisgress <mattgress@protonmail.ch>
}
\references{
See help file for function \code{tunecpfa} for a list of references.
}
\examples{
########## Parafac example with 3-way array and binary response ##########
\dontrun{
# set seed and simulate a three-way array related to a binary response
set.seed(5)

# define list of arguments specifying distributions for A and G weights
techlist <- list(distA = list(dname = "poisson", 
                              lambda = 3),                 # for A weights
                 distG = list(dname = "gamma", shape = 2, 
                              scale = 4))                  # for G weights

# define target correlation matrix for columns of C mode weights matrix
cormat <- matrix(c(1, .6, .6, .6, 1, .6, .6, .6, 1), nrow = 3, ncol = 3)

# simulate a three-way array connected to a response
data <- simcpfa(arraydim = c(11, 12, 100), model = "parafac", nfac = 3, 
                nclass = 2, nreps = 1e2, onreps = 10, corresp = rep(.6, 3), 
                meanpred = rep(2, 3), modes = 3, corrpred = cormat,
                technical = techlist, smethod = "eigende")

# initialize
alpha <- seq(0, 1, length = 2)
gamma <- c(0, 0.01)
cost <- c(1, 2)
method <- c("PLR", "SVM")
family <- "binomial"
parameters <- list(alpha = alpha, gamma = gamma, cost = cost)
model <- "parafac"
nfolds <- 3
nstart <- 3

# constrain first mode weights to be orthogonal
const <- c("orthog", "uncons", "uncons")

# fit Parafac models and use third mode to tune classification methods
tune.object <- tunecpfa(x = data$X[, , 1:80], y = data$y[1:80], 
                        model = model, nfac = 3, nfolds = nfolds, 
                        method = method, family = family, 
                        parameters = parameters, parallel = FALSE, 
                        const = const, nstart = nstart)
                    
# predict class labels
predict.labels <- predict(object = tune.object, newdata = data$X[, , 81:100], 
                          type = "response")

# print predicted labels
predict.labels
}
}

\name{plotcpfa}
\alias{plotcpfa}
\title{
Plot Optimal Model from Classification with Parallel Factor Analysis
}
\description{
Plots optimal model based on results from a 'wrapcpfa' object generated by 
function \code{cpfa}. 
}
\usage{
plotcpfa(object, cmeasure = "acc", meanvalue = TRUE, supNum = FALSE, 
         cmode = NULL, parallel = FALSE, cl = NULL, scale.remode = NULL, 
         newscales = 1, scale.abmode = NULL, sign.remode = NULL, newsigns = 1, 
         sign.abmode = NULL, ...)
}
\arguments{
\item{object}{
  An object of class 'wrapcpfa' from function \code{cpfa}.
}
\item{cmeasure}{
  Classification performance measure used to select the optimal number of 
  components. Options include \code{c("err", "acc", "tpr", "fpr", "tnr", "fnr", 
  "ppv", "npv", "fdr", "fom", "fs")}. If \code{cmeasure} is in \code{c("err", 
  "fpr", "fnr", "fdr", "fom")}, the number of components that minimized 
  \code{cmeasure} is selected among all classification methods. Otherwise, the 
  number that maximized \code{cmeasure} is selected.
}
\item{meanvalue}{
  Logical indicating whether to find the optimal number of components based on 
  the mean performance across replications from the results generated by 
  \code{cpfa}. If \code{meanvalue = FALSE}, the median is used. 
}
\item{supNum}{
  Logical indicating whether to suppress text displaying component weight values 
  within plot cells. If TRUE, values are not displayed.
}
\item{cmode}{
  Integer value of 1, 2, or 3 (or 4 if \code{x} is a four-way array) specifying 
  the mode whose component weights were predictors for classification when
  generating the 'wrapcpfa' object using function \code{cpfa}. If the original 
  input \code{model} from function \code{cpfa} was \code{pca}, \code{cmode} must 
  be 1 or 2 when the original input \code{x} was a two-way matrix. If the 
  original input \code{x} was a three-way or four-way array, \code{cmode} values 
  greater than 2 are ignored with a warning.
}
\item{parallel}{
  Logical indicating whether parallel computing should be used. If TRUE, 
  parallel computing is used.
}
\item{cl}{
  Cluster for parallel computing, which is used when \code{parallel = TRUE}. 
  Note that if \code{parallel = TRUE} and \code{cl = NULL}, then the cluster 
  is defined as \code{makeCluster(detectCores())}.
}
\item{scale.remode}{
  Character that indicates a mode to rescale. Must be one of \code{c("A", "B", 
  "C", "D")}. Sent directly to argument \code{mode} in function \code{rescale} 
  from package \bold{multiway}. See help file for \code{rescale} for additional 
  details. Ignored when function \code{cpfa} argument \code{model = 'pca'}. 
  If supplied, argument \code{scale.abmode} must also be supplied.
}
\item{newscales}{
  The root mean-square for columns of the mode indicated by \code{scale.remode}. 
  See help file for \code{rescale} for additional details. Ignored when function 
  \code{cpfa} argument \code{model = 'pca'}.
}
\item{scale.abmode}{
  Character that indicates the mode that absorbs the inverse of rescalings 
  applied to the mode indicated by \code{scale.remode}. Must be one of 
  \code{c("A", "B", "C", "D")}. Sent directly to argument \code{absorb} in 
  function \code{rescale} from package \bold{multiway}. See help file for 
  \code{rescale} for additional details. Ignored when function \code{cpfa} 
  argument \code{model = 'pca'}. If supplied, argument \code{scale.remode} must 
  also be supplied.
}
\item{sign.remode}{
  Character that indicates a mode to resign. Must be one of \code{c("A", "B", 
  "C", "D")}. Sent directly to argument \code{mode} in function \code{resign} 
  from package \bold{multiway}. See help file for \code{resign} for additional 
  details. Ignored when function \code{cpfa} argument \code{model = 'pca'}. 
  If supplied, argument \code{sign.abmode} must also be supplied.
}
\item{newsigns}{
  Scalar or vector indicating resignings for columns of the mode indicated by 
  \code{sign.remode}. See help file for \code{resign} for additional details. 
  Ignored when function \code{cpfa} argument \code{model = 'pca'}.
}
\item{sign.abmode}{
  Character that indicates the mode that absorbs the negation of the resignings 
  applied to the mode indicated by \code{sign.remode}. Must be one of 
  \code{c("A", "B", "C", "D")}. Sent directly to argument \code{absorb} in 
  function \code{resign} from package \bold{multiway}. See help file for 
  \code{resign} for additional details. Ignored when function \code{cpfa} 
  argument \code{model = 'pca'}. If supplied, argument \code{sign.remode} must 
  also be supplied.
}
\item{...}{
  Additional arguments to be passed to function \code{parafac} for fitting a 
  Parafac model or function \code{parafac2} for fitting a Parafac2 model. See 
  help file for function \code{parafac} or for function \code{parafac2} for 
  additional details.
}
}
\details{
Selects the number of components that optimized a performance measure across 
all classification methods used by \code{cpfa}. With this optimal number of 
components, fits the component model that was used by \code{cpfa} to 
create the input 'wrapcpfa' object. Uses same constraints used in \code{cpfa}. 
Plots component weights for this optimal model using heatmaps. Darker red 
indicates component weights that are more negative while darker green indicates 
component weights that are more positive. For three-way Parafac, plots A and B 
weights. For four-way Parafac, plots A, B, and C weights. For three-way 
Parafac2, plots B weights. For four-way Parafac2, plots B and C weights. For
PCA, plots loadings (i.e., A weights).
}
\value{
Returns one or more heatmap plots of component weights for the optimal component
model. Returns list of estimated component weights from the optimal model.
\item{Aweights}{
  Estimated A mode weights for optimal Parafac or Parafac2 model. For PCA, 
  contains the component loadings.
}
\item{Bweights}{
  Estimated B mode weights for optimal Parafac or Parafac2 model. For PCA, 
  contains the component scores.
}
\item{Cweights}{
  Estimated C mode weights for optimal Parafac or Parafac2 model. For PCA, 
  returns NULL.
}
\item{Dweights}{
  Estimated D mode weights for optimal Parafac or Parafac2 model. For PCA, 
  returns NULL.
}
}
\note{
Applications of this function to real datasets can be explored at the following
repository: \url{https://github.com/matthewasisgress/multiway-classification/}.
}
\author{
Matthew Asisgress <mattgress@protonmail.ch>
}
\references{
See help file for function \code{cpfa} for a list of references.
}
\examples{
########## Parafac2 example with 4-way array and multiclass response ##########
\dontrun{
# set seed and simulate a four-way ragged array related to a multiclass response
set.seed(5)

# define list of arguments specifying distributions for A and G weights
techlist <- list(distA = list(dname = "poisson", 
                              lambda = 3),                 # for A weights
                 distG = list(dname = "gamma", shape = 2, 
                              scale = 4))                  # for G weights

# define target correlation matrix for columns of D mode weights matrix
cormat <- matrix(c(1, .6, .6, .6, 1, .6, .6, .6, 1), nrow = 3, ncol = 3)

# simulate a four-way ragged array connected to a response
data <- simcpfa(arraydim = c(10, 11, 12, 100), model = "parafac2", nfac = 3, 
                nclass = 3, nreps = 1e2, onreps = 10, corresp = rep(.6, 3), 
                meanpred = rep(2, 3), modes = 4, corrpred = cormat,
                technical = techlist, smethod = "eigende")

# initialize
alpha <- seq(0, 1, length = 2)
gamma <- c(0, 1)
cost <- c(0.1, 5)
rda.alpha <- seq(0.1, 0.9, length = 2)
delta <- c(0.1, 2)
method <- c("PLR", "SVM", "RDA")
family <- "multinomial"
parameters <- list(alpha = alpha, gamma = gamma, cost = cost, 
                   rda.alpha = rda.alpha, delta = delta)
model <- "parafac2"
nfolds <- 3
nstart <- 3

# constrain first mode weights to be orthogonal, fourth mode to be nonnegative
const <- c("orthog", "uncons", "uncons", "nonneg")

# fit Parafac2 model and use fourth mode weights to tune classification
# methods, to predict class labels, and to return classification 
# performance measures pooled across multiple train-test splits
output <- cpfa(x = data$X, y = data$y, model = model, nfac = 3, 
               nrep = 2, ratio = 0.8, nfolds = nfolds, method = method, 
               family = family, parameters = parameters, 
               type.out = "descriptives", seeds = NULL, plot.out = TRUE, 
               parallel = FALSE, const = const, nstart = nstart, ctol = 1e-2)

# plot heatmap of component weights for optimal model
plotcpfa(output, nstart = nstart, ctol = 1e-3)
}
}

\name{cpfa-internals}

\title{Internal Functions for "cpfa"}

% List of Internal Functions
\alias{kcv.plr}
\alias{kcv.svm}
\alias{kcv.rf}
\alias{kcv.nn}
\alias{kcv.rda}
\alias{kcv.gbm}
\alias{distdraw}
\alias{kcvcheck}
\alias{logicheck}
\alias{numcheck}

\description{
  Internal functions for the "cpfa" package.
}
\details{
  These functions are not intended to be called by the user.
}
\keyword{internal}

\name{print.tunecpfa}
\alias{print.tunecpfa}
\title{
Print Method for Tuning for Classification with Parallel Factor Analysis
}
\description{
Prints summary of a 'tunecpfa' model object generated by function 
\code{tunecpfa}. 
}
\usage{
\method{print}{tunecpfa}(x, ...)
}
\arguments{
\item{x}{
  A fit object of class 'tunecpfa' from function \code{tunecpfa}.
}
\item{...}{
  Additional print arguments.
}
}
\details{
Prints names of the models and methods used to create the input 'tunecpfa' 
model object. Prints misclassification error rates and estimation times in 
seconds.
}
\value{
Returns a summary of the 'tunecpfa' model object.
}
\author{
Matthew Asisgress <mattgress@protonmail.ch>
}
\references{
See help file for function \code{tunecpfa} for a list of references.
}
\examples{
########## Parafac example with 3-way array and binary response ##########
\dontrun{
# set seed and simulate a three-way array connected to a binary response
set.seed(5)

# define list of arguments specifying distributions for A and G weights
techlist <- list(distA = list(dname = "poisson", 
                              lambda = 3),                 # for A weights
                 distG = list(dname = "gamma", shape = 2, 
                              scale = 4))                  # for G weights

# define target correlation matrix for columns of C mode weights matrix
cormat <- matrix(c(1, .6, .6, .6, 1, .6, .6, .6, 1), nrow = 3, ncol = 3)

# simulate a three-way array connected to a response
data <- simcpfa(arraydim = c(11, 12, 100), model = "parafac", nfac = 3, 
                nclass = 2, nreps = 1e2, onreps = 10, corresp = rep(.6, 3), 
                meanpred = rep(2, 3), modes = 3, corrpred = cormat,
                technical = techlist, smethod = "eigende")

# initialize
alpha <- seq(0, 1, length = 2)
gamma <- c(0, 0.01)
cost <- c(1, 2)
method <- c("PLR", "SVM")
family <- "binomial"
parameters <- list(alpha = alpha, gamma = gamma, cost = cost)
model <- "parafac"
nfolds <- 3
nstart <- 3

# constrain first mode weights to be orthogonal
const <- c("orthog", "uncons", "uncons")

# fit Parafac models and use third mode to tune classification methods
tune.object <- tunecpfa(x = data$X, y = data$y, model = model, 
                        nfac = 3, nfolds = nfolds, method = method, 
                        family = family, parameters = parameters, 
                        parallel = FALSE, const = const, nstart = nstart)
                         
# print summary of output
print(tune.object)
}
}

\name{tunecpfa}
\alias{tunecpfa}
\title{
Tuning for Classification with Parallel Factor Analysis
}
\description{
Fits Richard A. Harshman's Parallel Factor Analysis-1 (Parafac) model or 
Parallel Factor Analysis-2 (Parafac2) model to a three-way or four-way data 
array. Also fits a principal component analysis model (PCA) to a two-way matrix.
Allows for different constraint options on multiple tensor modes. For PCA, 
allows for either an unrotated or varimax rotated solution. Uses component 
weights from a single mode of the model as predictors to tune parameters for 
one or more classification methods via a k-fold cross-validation procedure. 
Allows for additional features to be included. Supports binary and multiclass 
classification.
}
\usage{
tunecpfa(x, y, z = NULL, model = c("parafac", "parafac2", "pca"), nfac = 1, 
         nfolds = 10, method = c("PLR", "SVM", "RF", "NN", "RDA", "GBM"), 
         family = c("binomial", "multinomial"), parameters = list(), 
         foldid = NULL, prior = NULL, cmode = NULL, parallel = FALSE, 
         cl = NULL, verbose = TRUE, compscale = TRUE, 
         pcarot = c("unrotated", "varimax"), ...)
}
\arguments{
\item{x}{
  A three-way or four-way data array. For Parafac2, can be a list where each 
  element is a matrix or three-way array. Array or list must contain only real 
  numbers. See note below. For PCA, can be a two-way matrix, a three-way array,
  or a four-way array. If a three-way or four-way array for PCA, array is 
  unfolded across all modes except the classification mode.
} 
\item{y}{
  A vector containing at least two unique class labels. Should be a factor that 
  contains two or more levels. For binary case, ensure the order of factor 
  levels (left to right) is such that negative class is first and positive 
  class is second.
}
\item{z}{
  A matrix containing additional features for classification. Must have number
  of rows equal to the number of class labels (i.e., equal to the length of 
  \code{y}). 
}
\item{model}{
  Character designating the component model to use, including: 
  \code{model = "parafac"} to fit the Parafac model, \code{model = "parafac2"} 
  to fit the Parafac2 model, or \code{model = "pca"} to fit the PCA model. One
  must be provided.
}
\item{nfac}{
  Vector containing integers that specify the number of components for each 
  component model to fit. Default is \code{nfac = 1}.
}
\item{nfolds}{
  Numeric value specifying the number of folds for k-fold cross-validation. 
  Must be 2 or greater. Default is \code{nfolds = 10}.
}
\item{method}{
  Character vector indicating classification methods to use. Possible methods 
  include penalized logistic regression (PLR); support vector machine (SVM); 
  random forest (RF); feed-forward neural network (NN); regularized 
  discriminant analysis (RDA); and gradient boosting machine (GBM). If none 
  selected, default is to use all methods.
}
\item{family}{
  Character value specifying binary classification (\code{family = "binomial"}) 
  or multiclass classification (\code{family = "multinomial"}). If not 
  provided, number of levels of input \code{y} is used, where two levels is 
  binary, and where three or more levels is multiclass.
}
\item{parameters}{
  List containing arguments related to classification methods. When specified, 
  must contain one or more of the following:
  \describe{
  \item{alpha}{
  Values for penalized logistic regression alpha parameter; default is 
  \code{alpha = seq(0, 1, length = 6)}. Must be numeric and contain only real 
  numbers between 0 and 1, inclusive.
}
  \item{lambda}{
  Optional user-supplied lambda sequence for \code{cv.glmnet} for penalized 
  logistic regression. Default is NULL.
}
  \item{cost}{
  Values for support vector machine cost parameter; default is 
  \code{cost = c(1, 2, 4, 8, 16, 32, 64)}. Must be numeric and contain only 
  real numbers greater than 0.
}
  \item{gamma}{
  Values for support vector machine gamma parameter; default is 
  \code{gamma = c(0, 0.01, 0.1, 1, 10, 100, 1000)}. Must be numeric and greater 
  than or equal to 0.
}
  \item{ntree}{
  Values for random forest number of trees parameter; default is 
  \code{ntree = c(100, 200, 400, 600, 800, 1600, 3200)}. Must be numeric and 
  contain only integers greater than or equal to 1.
}
  \item{nodesize}{
  Values for random forest node size parameter; default is 
  \code{nodesize = c(1, 2, 4, 8, 16, 32, 64)}. Must be numeric and contain 
  only integers greater than or equal to 1.
}
  \item{size}{
  Values for neural network size parameter; default is 
  \code{size = c(1, 2, 4, 8, 16, 32, 64)}. Must be numeric and contain only 
  integers greater than or equal to 0.
}
  \item{decay}{
  Values for neural network decay parameter; default is 
  \code{decay = c(0.001, 0.01, 0.1, 1, 2, 4, 8, 16)}. Must be numeric and 
  contain only real numbers.
}
  \item{rda.alpha}{
  Values for regularized discriminant analysis alpha parameter; default is 
  \code{rda.alpha = seq(0, 0.999, length = 6)}. Must be numeric and contain 
  only real numbers between 0 (inclusive) and 1 (exclusive).
}
  \item{delta}{
  Values for regularized discriminant analysis delta parameter; default is 
  \code{delta = c(0, 0.1, 1, 2, 3, 4)}. Must be numeric and contain only real 
  numbers greater than or equal to 0.
}
\item{eta}{
  Values for gradient boosting machine eta parameter; default is 
  \code{eta = c(0.1, 0.3, 0.5, 0.7, 0.9)}. Must be numeric and contain only 
  real numbers greater than 0 and less than 1.
}
\item{max.depth}{
  Values for gradient boosting machine max.depth parameter; default is 
  \code{max.depth = c(1, 2, 3, 4)}. Must be numeric and contain only integers 
  greater than or equal to 1.
}
\item{subsample}{
  Values for gradient boosting machine subsample parameter; default is 
  \code{subsample = c(0.6, 0.7, 0.8, 0.9)}. Must be numeric and contain only 
  real numbers greater than 0 and less than or equal to 1.
}
\item{nrounds}{
  Values for gradient boosting machine nrounds parameter; default is 
  \code{nrounds = c(100, 200, 300, 500)}. Must be numeric and contain only 
  integers greater than or equal to 1.
}
}
}
\item{foldid}{
  Vector containing fold IDs for k-fold cross-validation. Must be of class 
  integer. Should contain integers from 1 through the number of folds. If not 
  provided, fold IDs are generated randomly for observations using integers of 
  1 through the number of folds \code{nfolds}.
}
\item{prior}{
  Prior probabilities of class membership. If specified, the probabilities 
  should be in the order of the factor levels of input \code{y}. If unspecified, 
  the observed class proportions for input \code{y} are used. Based on 
  \code{prior}, inverse probability weights are calculated to account for class 
  imbalance. Note that RF and RDA ignore \code{prior} and use uniform priors 
  to handle imbalance.
}
\item{cmode}{
  Integer value of 1, 2, or 3 (or 4 if \code{x} is a four-way array) specifying 
  the mode whose component weights will be predictors for classification. 
  Defaults to the last mode of the input array (i.e., defaults to 3 for 
  a three-way array, and to 4 for a four-way array). 
  If \code{model = "parafac2"}, last mode will be used. If \code{model = "pca"},
  cmode is set to the first mode. 
}
\item{parallel}{
  Logical indicating whether to use parallel computing. If TRUE, the package 
  \bold{parallel} is used for parallel computing. For all classification 
  methods except penalized logistic regression, the \bold{doParallel} package 
  is used as a wrapper. Defaults to FALSE, which implements sequential 
  computing.
}
\item{cl}{
  Cluster for parallel computing, which is used when \code{parallel = TRUE}. 
  Note that if \code{parallel = TRUE} and \code{cl = NULL}, then the cluster 
  is defined as \code{makeCluster(detectCores())}.
}
\item{verbose}{
  If TRUE, progress is printed.
}
\item{compscale}{
  Logical indicating whether to scale each column of the estimated 
  classification component weights matrix (i.e., the features/predictors). If
  \code{TRUE}, each column is scaled to have mean zero and unit variance. If 
  \code{FALSE}, no scaling is performed.
}
\item{pcarot}{
  Character indicating whether to apply a varimax rotation or leave PCA loadings
  unrotated when \code{model} is set to \code{pca}. Ignored when \code{model} is
  not \code{pca}. Defaults to \code{"unrotated"} if not specified.
}
\item{...}{
  Additional arguments to be passed to function \code{parafac} for fitting a 
  Parafac model or function \code{parafac2} for fitting a Parafac2 model. 
  Example: can impose different constraints on different modes of the input 
  array using the argument \code{const}. See help file for function 
  \code{parafac} or for function \code{parafac2} for additional details.
}
}
\details{
After fitting a Parafac or Parafac2 model with the training set using package 
\bold{multiway} (see \code{parafac} or \code{parafac2} in \bold{multiway} for 
details), or after fitting a PCA model using the singular value decomposition, 
the estimated classification mode weight matrix is passed to one or more 
classification methods. The methods include: penalized logistic regression 
(PLR); support vector machine (SVM); random forest (RF); feed-forward neural 
network (NN); regularized discriminant analysis (RDA); and gradient boosting 
machine (GBM).

Package \bold{glmnet} fits models for PLR. PLR tunes penalty parameter lambda 
while the elastic net parameter alpha is set by the user (see the help file for 
function \code{cv.glmnet} in package \bold{glmnet}). For SVM, package 
\bold{e1071} is used with a radial basis kernel. Penalty parameter cost and 
radial basis parameter gamma are used (see \code{svm} in package \bold{e1071}). 
For RF, package \bold{randomForest} is used and implements Breiman's random 
forest algorithm. The number of predictors sampled at each node split is set 
at the default of sqrt(R), where R is the number of Parafac or Parafac2 
components. Two tuning parameters allowed are ntree, the number of trees to 
be grown, and nodesize, the minimum size of terminal nodes 
(see \code{randomForest} in package \bold{randomForest}). For NN, package 
\bold{nnet} fits a single-hidden-layer, feed-forward neural network model. 
Penalty parameters size (i.e., number of hidden layer units) and decay 
(i.e., weight decay) are used (see \bold{nnet}). For RDA, package \bold{rda} 
fits a shrunken centroids regularized discriminant analysis model. Tuning 
parameters include rda.alpha, the shrinkage penalty for the within-class 
covariance matrix, and delta, the shrinkage penalty of class centroids towards 
the overall dataset centroid. For GBM, package \bold{xgboost} fits a gradient 
boosting machine model. Four tuning parameters are allowed: (1) eta, the 
learning rate; (2) max.depth, the maximum tree depth; (3) subsample, the 
fraction of samples per tree; and (4) nrounds, the number of boosting trees 
to build.

For all six methods, k-fold cross-validation is implemented to tune 
classification parameters where the number of folds is set by argument 
\code{nfolds}.
}
\value{
Returns an object of class \code{tunecpfa} with the following elements:
  
\item{opt.model}{
  List containing optimal model for tuned classification methods for each 
  component model that was fit.
}
\item{opt.param}{
  Data frame containing optimal parameters for tuned classification methods.
}
\item{kcv.error}{
  Data frame containing KCV misclassification error for optimal parameters for 
  tuned classification methods.
}
\item{est.time}{
  Data frame containing times for fitting the component model and for 
  tuning classification methods.
}
\item{model}{
  Character designating the component model that was used, including:
  \code{model = "parafac"} for the Parafac model, \code{model = "parafac2"} 
  for the Parafac2 model, or \code{model = "pca"} for the PCA model.
}
\item{method}{
  Numeric indicating classification methods used. Value of '1' indicates 
  'PLR'; value of '2' indicates 'SVM'; value of '3' indicates 'RF'; value of 
  '4' indicates 'NN'; value of '5' indicates 'RDA'; and value of '6' indicates 
  'GBM'.
}
\item{x}{
  Two-way matrix, or three-way or four-way data array or list used in argument 
  \code{x}. If \code{x} was a three-way or four-way array, and if \code{model}
  was \code{pca}, returns the flattened two-way matrix.
}
\item{y}{
  Factor containing class labels used. Note that output \code{y} is recoded 
  such that the input labels of \code{y} are converted to numeric integers 
  from 0 through the number of levels, which are then applied as labels for 
  output \code{y}. 
}
\item{z}{
  Matrix containing additional features for classification.
}
\item{Aweights}{
  List containing estimated A weights for each component model that was fit. For
  PCA, contains the loadings.
}
\item{Bweights}{
  List containing estimated B weights for each component model that was fit. 
  Null if \code{model} was \code{pca}.
}
\item{Cweights}{
  List containing estimated C weights for each Parafac or Parafac2 model that 
  was fit. Null if input argument \code{x} was a three-way array or if 
  \code{model} was \code{pca}.
}
\item{Phi}{
  If \code{model = "parafac2"}, a list containing estimated \code{Phi} from 
  the Parafac2 model. \code{Phi} is the common cross product matrix shared by 
  all levels of the last mode (see help file for function \code{parafac2} in 
  package \bold{multiway} for additional details). NULL if 
  \code{model = "parafac"} or if \code{model = "pca"}.
}
\item{const}{
  Constraints used in fitting the Parafac, Parafac2, or PCA model. When 
  \code{model} was \code{pca}, contains the value used in input \code{pcarot}
  to indicate whether a rotation was applied to the solution.
}
\item{cmode}{
  Integer value of 1, 2, or 3 (or 4 if \code{x} is a four-way array) specifying 
  mode whose component weights were predictors for classification.
}
\item{family}{
  Character value specifying whether classification was binary 
  (\code{family = "binomial"}) or multiclass (\code{family = "multinomial"}).
}
\item{xdim}{
  Numeric value specifying number of levels for each mode of input \code{x}. 
  If \code{model = "parafac2"}, the number of levels for the first mode is 
  designated as \code{NA} because the number of levels can differ across levels 
  of the last mode. If \code{model = "pca"} and if input \code{x} was a 3-way or 
  4-way array, \code{xdim} contains the number of levels of the matrix that is 
  the unfolded version of the input array.
}
\item{lxdim}{
  Integer specifying the number of modes of the output \code{x}. Identical to 
  the number of modes of input \code{x}, except when input \code{x} was a 
  3-way or 4-way array and when \code{model} was \code{pca}. In this case,
  \code{lxdim} is 2.
}
\item{train.weights}{
  List containing classification component weights for each fit Parafac or 
  Parafac2 model, for possibly different numbers of components. The weights 
  used to train classifiers.
}
\item{priorweights}{
  List containing three elements based on input \code{prior}: (1) \code{weight}, 
  inverse probability weights per observation, used to balance classes for PLR, 
  NN, and GBM; (2) \code{frac}, inverse probability weights per class, used to 
  balance classes for SVM; and (3) \code{pricorrect}, uniform priors used to 
  balance classes for RF and RDA. 
}
\item{scenters}{
  List containing center of the scale for each Parafac or Parafac2 model that 
  was fit. Note that, for each component, estimated classification weights are 
  mean-centered before being passed to classification methods. Returns 
  \code{FALSE} if argument \code{compscale = FALSE}.
}
\item{sscales}{
  List containing standard devition of the scale for each Parafac or Parafac2 
  model that was fit. Note that, for each component, estimated classification 
  weights are scaled to have a variance of 1 before being passed to 
  classification methods. Returns \code{FALSE} if argument 
  \code{compscale = FALSE}.
}
\item{pcacenter}{
  Numeric vector containing centers for each feature used in PCA. NULL if 
  \code{model} is not \code{pca}.
}
}
\note{
For fitting the Parafac model, if argument \code{cmode} is not NULL, input 
array \code{x} is reshaped with function \code{aperm} such that the 
\code{cmode} dimension of \code{x} is ordered last. Estimated mode A and B 
(and mode C for a four-way array) weights that are outputted as \code{Aweights} 
and \code{Bweights} (and \code{Cweights}) reflect this permutation. For example, 
if \code{x} is a four-way array and \code{cmode = 2}, the original input 
modes 1, 2, 3, and 4 will correspond to output modes 1, 3, 4, 2. Here, 
output A = input 1; B = 3, and C = 4 (i.e., the second mode specified by 
\code{cmode} has been moved to the D mode/last mode). For 
\code{model = "parafac2"}, classification mode is assumed to be the last mode 
(i.e., mode C for three-way array and mode D for four-way array). For PCA, if 
argument \code{cmode} is not NULL, and if \code{x} is a 3-way or 4-way array, 
the array is reshaped with \code{aperm} such that the \code{cmode} dimension
of \code{x} is ordered first. Then, the array is unfolded into a two-way matrix.
If \code{x} is already input as a two-way matrix, the matrix is reshaped if 
\code{cmode} is 2, such that the matrix is transposed. Note that for PCA, 
\code{Aweights} contains the PCA model loadings.

In addition, note that the following combination of arguments will give an 
error: \code{nfac = 1, family = "multinomial", method = "PLR"}. The issue 
arises from providing \code{glmnet::cv.glmnet} input \code{x} with a matrix 
that has a single column. The issue is resolved for \code{family = "binomial"} 
because a column of 0s is appended to the single column, but this solution 
does not appear to work for the multiclass case. As such, this combination of 
arguments is not currently allowed. This issue will be resolved in a future 
update.

Applications of this function to real datasets can be explored at the following
repository: \url{https://github.com/matthewasisgress/multiway-classification/}.
}
\author{
Matthew A. Asisgress <mattgress@protonmail.ch>
}
\references{
Breiman, L. (2001). Random forests. Machine Learning, 45(1), 5-32.

Chen, T., He, T., Benesty, M., Khotilovich, V., Tang, Y., Cho, H., Chen, K., 
Mitchell, R., Cano, I., Zhou, T., Li, M., Xie, J., Lin, M., Geng, Y., Li, Y., 
Yuan, J. (2025). xgboost: Extreme gradient boosting. R Package Version 1.7.9.1.

Cortes, C. and Vapnik, V. (1995). Support-vector networks. Machine Learning, 
20(3), 273-297.

Friedman, J. H. (2001). Greedy function approximation: a gradient boosting 
machine. Annals of Statistics, 29(5), 1189-1232.

Friedman, J. H. (1989). Regularized discriminant analysis. Journal of the 
American Statistical Association, 84(405), 165-175.

Friedman, J., Hastie, T., and Tibshirani, R. (2010). Regularization paths for 
generalized linear models via coordinate descent. Journal of Statistical 
Software, 33(1), 1-22.

Gaujoux, R. (2025). doRNG: Generic reproducible parallel backend for 'foreach' 
loops. R Package Version 1.8.6.2.

Guo, Y., Hastie, T., and Tibshirani, R. (2007). Regularized linear discriminant 
analysis and its application in microarrays. Biostatistics, 8(1), 86-100.

Guo, Y., Hastie, T., and Tibshirani, R. (2023). rda: Shrunken centroids 
regularized discriminant analysis. R Package Version 1.2-1.

Harshman, R. (1970). Foundations of the PARAFAC procedure: Models and conditions 
for an "explanatory" multimodal factor analysis. UCLA Working Papers in 
Phonetics, 16, 1-84.

Harshman, R. (1972). PARAFAC2: Mathematical and technical notes. UCLA Working 
Papers in Phonetics, 22, 30-44.

Harshman, R. and Lundy, M. (1994). PARAFAC: Parallel factor analysis. 
Computational Statistics and Data Analysis, 18, 39-72.

Helwig, N. (2017). Estimating latent trends in multivariate longitudinal data 
via Parafac2 with functional and structural constraints. Biometrical Journal, 
59(4), 783-803.

Helwig, N. (2025). multiway: Component models for multi-way data. R Package 
Version 1.0-7.

Liaw, A. and Wiener, M. (2002). Classification and regression by randomForest. 
R News 2(3), 18--22.

Meyer, D., Dimitriadou, E., Hornik, K., Weingessel, A., and Leisch, F. (2024). 
e1071: Misc functions of the Department of Statistics, Probability Theory Group 
(Formerly: E1071), TU Wien. R Package Version 1.7-16.

Ripley, B. (1994). Neural networks and related methods for classification. 
Journal of the Royal Statistical Society: Series B (Methodological), 56(3), 
409-437.

Venables, W. and Ripley, B. (2002). Modern applied statistics with S. Fourth 
Edition. Springer, New York. ISBN 0-387-95457-0.

Zou, H. and Hastie, T. (2005). Regularization and variable selection via the 
elastic net. Journal of the Royal Statistical Society: Series B (Statistical 
Methodology), 67(2), 301-320.
}

\examples{
########## Parafac example with 3-way array and binary response ##########
\dontrun{
# set seed and simulate a three-way array connected to a binary response
set.seed(5)

# define list of arguments specifying distributions for A and G weights
techlist <- list(distA = list(dname = "poisson", 
                              lambda = 3),                 # for A weights
                 distG = list(dname = "gamma", shape = 2, 
                              scale = 4))                  # for G weights

# define target correlation matrix for columns of C mode weights matrix
cormat <- matrix(c(1, .6, .6, .6, 1, .6, .6, .6, 1), nrow = 3, ncol = 3)

# simulate a three-way array connected to a response
data <- simcpfa(arraydim = c(11, 12, 100), model = "parafac", nfac = 3, 
                nclass = 2, nreps = 1e2, onreps = 10, corresp = rep(.6, 3), 
                meanpred = rep(2, 3), modes = 3, corrpred = cormat,
                technical = techlist, smethod = "eigende")
                
# initialize
alpha <- seq(0, 1, length = 2)
gamma <- c(0, 0.01)
cost <- c(1, 2)
ntree <- c(100, 200)
nodesize <- c(1, 2)
size <- c(1, 2)
decay <- c(0, 1)
rda.alpha <- c(0.1, 0.6)
delta <- c(0.1, 2)
eta <- c(0.3, 0.7)
max.depth <- c(1, 2)
subsample <- c(0.75)
nrounds <- c(100)
method <- c("PLR", "SVM", "RF", "NN", "RDA", "GBM")
family <- "binomial"
parameters <- list(alpha = alpha, gamma = gamma, cost = cost, ntree = ntree,
                   nodesize = nodesize, size = size, decay = decay, 
                   rda.alpha = rda.alpha, delta = delta, eta = eta,
                   max.depth = max.depth, subsample = subsample,
                   nrounds = nrounds)
model <- "parafac"
nfolds <- 3
nstart <- 3

# constrain first mode weights to be orthogonal
const <- c("orthog", "uncons", "uncons")

# fit Parafac models and use third mode to tune classification methods
tune.object <- tunecpfa(x = data$X, y = data$y, z = data$Cmat, model = model, 
                        nfac = 3, nfolds = nfolds, method = method, 
                        family = family, parameters = parameters, 
                        parallel = FALSE, const = const, nstart = nstart)

# print tuning object
tune.object
}
}

\name{cpm}
\alias{cpm}
\title{
Classification Performance Measures
}
\description{
Calculates multiple performance measures for binary or multiclass 
classification. Uses known class labels and evaluates against predicted labels.
}
\usage{
cpm(x, y, level = NULL, fbeta = NULL, prior = NULL)
}
\arguments{
\item{x}{
  Known class labels of class numeric, factor, or integer. If factor, converted 
  to class integer in the order of factor levels with integers beginning at 
  0 (i.e., for binary classification, factor levels become 0 and 1; for 
  multiclass, levels become 0, 1, 2, etc.). 
}
\item{y}{
  Predicted class labels of class numeric, factor, or integer. If factor, 
  converted to class integer in the order of factor levels with integers 
  beginning at 0 (i.e., for binary classification, factor levels become 0 
  and 1; for multiclass, levels become 0, 1, 2, etc.).
}
\item{level}{
  Optional argument specifying possible class labels. For cases where 
  \code{x} or \code{y} do not contain all possible classes. Can be of class 
  numeric, integer, or character. Must contain two elements for binary 
  classification, and contain three or more elements for multiclass 
  classification. If integer, integers should be ordered (e.g., binary with 
  \code{c(0, 1)}; or three-class with \code{c(0, 1, 2)}). Note: if both 
  \code{x} and \code{y} jointly contain only a single value (e.g., 1), must 
  specify argument \code{level} in order to identify classification as binary 
  or multiclass. 
}
\item{fbeta}{
  Optional numeric argument specifying beta value for F-score. Defaults to 
  \code{fbeta = 1}, providing an F1-score (i.e., the balanced harmonic mean 
  between precision and recall). Can be any real number.
}
\item{prior}{
  Optional numeric argument specifying weights for classes. Currently only 
  implemented with multiclass problems. Defaults to \code{prior = c(rep(1/llev, 
  llev))}, where \code{llev} is the number of classes, providing equal 
  importance across classes.
  }
}
\details{
Selecting one class as a negative class and one class as a positive class, 
binary classification generates four possible outcomes: (1) negative cases 
classified as positives, called false positives (FP); (2) negative cases 
classified as negatives, called true negatives (TN); (3) positive cases 
classified as negatives, called false negatives (FN); and (4) positive cases 
classified as positives, called true positives (TP). 

Multiple evaluation measures are calculated using these four outcomes. Measures 
include: overall error (ERR), also called fraction incorrect;  overall accuracy 
(ACC), also called fraction correct; true positive rate (TPR), also called 
recall, hit rate, or sensitivity; false negative rate (FNR), also called miss 
rate; false positive rate (FPR), also called fall-out; true negative rate 
(TNR), also called specificity or selectivity; positive predictive value (PPV), 
also called precision; false discovery rate (FDR); negative predictive value 
(NPV); false omission rate (FOR); and F-score (FS).

In multiclass classification, the four outcomes are possible for each individual 
class in macro-averaging, and performance measures are averaged over classes. 
Macro-averaging gives equal importance to all classes. For multiclass 
classification, calculated measures are currently only macro-averaged. See the 
listed reference in this help file for additional details on micro-averaging.

For binary classification, this function assumes a negative class and a 
positive class (i.e., it contains a reference group) and is ordered. Multiclass 
classification is currently assumed to be unordered. 

Computational details:

ERR = (FP + FN) / (TP + TN + FP + FN).

ACC = (TP + TN) / (TP + TN + FP + FN), and ACC = 1 - ERR.

TPR = TP / (TP + FN).

FNR = FN / (FN + TP), and FNR = 1 - TPR.

FPR = FP / (FP + TN).

TNR = TN / (TN + FP), and TNR = 1 - FPR.

PPV = TP / (TP + FP).

FDR = FP / (FP + TP), and FDR = 1 - PPV.

NPV = TN / (TN + FN).

FOR = FN / (FN + TN), and FOR = 1 - NPV.

FS = (1 + beta^2) * ((PPV * TPR) / (((beta^2)*PPV) + TPR)).

All performance measures calculated are between 0 and 1, inclusive. For 
multiclass classification, macro-averaged values are provided for each 
performance measure. Note that 'beta' in FS represents the relative weight 
such that recall (TPR) is beta times more important than precision (PPV). See 
reference for more details.
}
\value{
Returns list where first element is a full confusion matrix \code{cm} and where 
the second element is a data frame containing performance measures. For 
multiclass classification, macro-averaged values are provided (i.e., each 
measure is calculated for each class, then averaged over all classes; the 
average is weighted by argument \code{prior} if provided). The second list 
element contains the following performance measures:

\item{cm}{
  A confusion matrix with counts for each of the possible outcomes.
}
\item{err}{
  Overall error (ERR). Also called fraction incorrect.
}
\item{acc}{
  Overall accuracy (ACC). Also called fraction correct.
}
\item{tpr}{
  True positive rate (TPR). Also called recall, hit rate, or sensitivity.
}
\item{fpr}{
  False positive rate (FPR). Also called fall-out.
}
\item{tnr}{
  True negative rate (TNR). Also called specificity or selectivity.
}
\item{fnr}{
  False negative rate (FNR). Also called miss rate.
}
\item{ppv}{
  Positive predictive value (PPV). Also called precision.
}
\item{npv}{
  Negative predictive value (NPV).
}
\item{fdr}{
  False discovery rate (FDR).
}
\item{fom}{
  False omission rate (FOR).
}
\item{fs}{
  F-score. Mean between TPR (recall) and PPV (precision) varying by importance 
given to recall over precision (see Details section and argument \code{fbeta}). 
}

}
\references{
Sokolova, M. and Lapalme, G. (2009). A systematic analysis of performance 
measures for classification tasks. Information Processing and Management, 
45(4), 427-437.
}
\author{
Matthew Asisgress <mattgress@protonmail.ch>
}
\examples{
########## Parafac example with 3-way array and binary response ##########
\dontrun{
# set seed and simulate a three-way array related to a binary response
set.seed(5)

# define target correlation matrix for columns of C mode weights matrix
cormat <- matrix(c(1, .6, .6, .6, 1, .6, .6, .6, 1), nrow = 3, ncol = 3)

# define list of arguments specifying distributions for A and G weights
techlist <- list(distA = list(dname = "poisson", 
                              lambda = 3),                 # for A weights
                 distG = list(dname = "gamma", shape = 2, 
                              scale = 4))                  # for G weights

# simulate a three-way array connected to a response
data <- simcpfa(arraydim = c(11, 12, 100), model = "parafac", nfac = 3, 
                nclass = 2, nreps = 1e2, onreps = 10, corresp = rep(.6, 3), 
                meanpred = rep(2, 3), modes = 3, corrpred = cormat,
                technical = techlist, smethod = "eigende")

# initialize
alpha <- seq(0, 1, length = 2)
gamma <- c(0, 0.01)
cost <- c(1, 2)
method <- c("PLR", "SVM")
family <- "binomial"
parameters <- list(alpha = alpha, gamma = gamma, cost = cost)
model <- "parafac"
nfolds <- 3
nstart <- 3

# constrain first mode weights to be orthogonal
const <- c("orthog", "uncons", "uncons")

# fit Parafac models and use third mode to tune classification methods
tune.object <- tunecpfa(x = data$X[, , 1:80], y = data$y[1:80], 
                        model = model, nfac = 3, nfolds = nfolds, 
                        method = method, family = family, 
                        parameters = parameters, parallel = FALSE, 
                        const = const, nstart = nstart)
                    
# predict class labels
predict.labels <- predict(object = tune.object, newdata = data$X[, , 81:100], 
                          type = "response")
                        
# calculate performance measures for predicted class labels
y.pred <- predict.labels[, 1]
yproc <- as.numeric(data$y[81:100]) - 1
evalmeasure <- cpm(x = yproc, y = y.pred)

# print performance measures
evalmeasure
}
}

\name{cpfa}
\alias{cpfa}
\title{
Classification with Parallel Factor Analysis
}
\description{
Fits Richard A. Harshman's Parallel Factor Analysis-1 (Parafac) model or 
Parallel Factor Analysis-2 (Parafac2) model to a three-way or four-way data 
array. Also fits a principal component analysis model (PCA) to a two-way matrix.
Allows for different constraint options on multiple tensor modes. For PCA, 
allows for either an unrotated or varimax rotated solution. Uses component 
weights from a single mode of the selected component model as predictors to tune 
parameters for one or more classification methods via a k-fold cross-validation 
procedure. Allows for additional features to be included. Predicts class labels 
and calculates multiple performance measures for binary or multiclass 
classification across multiple replications with different train-test splits. 
Provides descriptive statistics to pool output across replications.
}
\usage{
cpfa(x, y, z = NULL, model = c("parafac", "parafac2", "pca"), nfac = 1, 
     nrep = 5, ratio = 0.8, nfolds = 10, 
     method = c("PLR", "SVM", "RF", "NN", "RDA", "GBM"), 
     family = c("binomial", "multinomial"), parameters = list(), 
     type.out = c("measures", "descriptives"), foldid = NULL, prior = NULL, 
     cmode = NULL, seeds = NULL, plot.out = FALSE, plot.measures = NULL, 
     parallel = FALSE, cl = NULL, verbose = TRUE, compscale = TRUE, 
     pcarot = c("unrotated", "varimax"), ...)
}
\arguments{
\item{x}{
  A three-way or four-way data array. For Parafac2, can be a list where each 
  element is a matrix or three-way array. Array or list must contain only real 
  numbers. See note below. For PCA, can be a two-way matrix, a three-way array,
  or a four-way array. If a three-way or four-way array for PCA, array is 
  unfolded across all modes except the classification mode. Note that if 
  three-way or four-way array for PCA, classification mode must be the last 
  mode.
} 
\item{y}{
  A vector containing at least two unique class labels. Should be a factor that 
  contains two or more levels. For binary case, ensure the order of factor 
  levels (left to right) is such that negative class is first and positive 
  class is second. Levels should be sequential integers starting from 0, 1, ...,
  etc.
}
\item{z}{
  A matrix containing additional features for classification. Must have number
  of rows equal to the number of class labels (i.e., equal to the length of 
  \code{y}). 
}
\item{model}{
  Character designating the component model to use, including: 
  \code{model = "parafac"} to fit the Parafac model, \code{model = "parafac2"} 
  to fit the Parafac2 model, or \code{model = "pca"} to fit the PCA model.
}
\item{nfac}{
  Vector containing integers that specify the number of components for each 
  component model to fit. Default is \code{nfac = 1}.
}
\item{nrep}{
  Number of replications to repeat the procedure. Default is \code{nrep = 5}.
}
\item{ratio}{
  Split ratio for dividing data into train and test sets. Default is 
  \code{ratio = 0.8}.
}
\item{nfolds}{
  Numeric value specifying number of folds for k-fold cross-validation. Must 
  be 2 or greater. Default is \code{nfolds = 10}.
}
\item{method}{
  Character vector indicating classification methods to use. Possible methods 
  include penalized logistic regression (PLR); support vector machine (SVM); 
  random forest (RF); feed-forward neural network (NN); regularized 
  discriminant analysis (RDA); and gradient boosting machine (GBM). If none 
  are selected, default is to use all methods with \code{method = c("PLR", 
  "SVM", "RF", "NN", "RDA", "GBM")}.
}
\item{family}{
  Character value specifying binary classification (\code{family = "binomial"}) 
  or multiclass classification (\code{family = "multinomial"}). If not 
  provided, number of levels of input \code{y} is used, where two levels is 
  binary, and where three or more levels is multiclass.
}
\item{parameters}{
  List containing arguments related to classification methods. When specified, 
  must contain one or more of the following:
  \describe{
\item{alpha}{
  Values for penalized logistic regression alpha parameter; default is 
  \code{alpha = seq(0, 1, length = 6)}. Must be numeric and contain only real 
  numbers between 0 and 1, inclusive.
}
\item{lambda}{
  Optional user-supplied lambda sequence for \code{cv.glmnet} for penalized 
  logistic regression. Default is NULL.
}
\item{cost}{
  Values for support vector machine cost parameter; default is 
  \code{cost = c(1, 2, 4, 8, 16, 32, 64)}. Must be numeric and contain only 
  real numbers greater than 0.
}
\item{gamma}{
  Values for support vector machine gamma parameter; default is 
  \code{gamma = c(0, 0.01, 0.1, 1, 10, 100, 1000)}. Must be numeric and greater 
  than or equal to 0.
}
\item{ntree}{
  Values for random forest number of trees parameter; default is 
  \code{ntree = c(100, 200, 400, 600, 800, 1600, 3200)}. Must be numeric and 
  contain only integers greater than or equal to 1.
}
\item{nodesize}{
  Values for random forest node size parameter; default is 
  \code{nodesize = c(1, 2, 4, 8, 16, 32, 64)}. Must be numeric and contain 
  only integers greater than or equal to 1.
}
\item{size}{
  Values for neural network size parameter; default is \code{size = c(1, 2, 4, 
  8, 16, 32, 64)}. Must be numeric and contain only integers greater than or 
  equal to 0.
}
\item{decay}{
  Values for neural network decay parameter; default is \code{decay = c(0.001, 
  0.01, 0.1, 1, 2, 4, 8, 16)}. Must be numeric and contain only real numbers.
}
\item{rda.alpha}{
  Values for regularized discriminant analysis alpha parameter; default is 
  \code{rda.alpha = seq(0, 0.999, length = 6)}. Must be numeric and contain 
  only real numbers between 0 (inclusive) and 1 (exclusive).
}
\item{delta}{
  Values for regularized discriminant analysis delta parameter; default is 
  \code{delta = c(0, 0.1, 1, 2, 3, 4)}. Must be numeric and contain only real 
  numbers greater than or equal to 0.
}
\item{eta}{
  Values for gradient boosting machine eta parameter; default is 
  \code{eta = c(0.1, 0.3, 0.5, 0.7, 0.9)}. Must be numeric and contain only 
  real numbers greater than 0 and less than 1.
}
\item{max.depth}{
  Values for gradient boosting machine max.depth parameter; default is 
  \code{max.depth = c(1, 2, 3, 4)}. Must be numeric and contain only integers 
  greater than or equal to 1.
}
\item{subsample}{
  Values for gradient boosting machine subsample parameter; default is 
  \code{subsample = c(0.6, 0.7, 0.8, 0.9)}. Must be numeric and contain only 
  real numbers greater than 0 and less than or equal to 1.
}
\item{nrounds}{
  Values for gradient boosting machine nrounds parameter; default is 
  \code{nrounds = c(100, 200, 300, 500)}. Must be numeric and contain only 
  integers greater than or equal to 1.
}
}
}
\item{type.out}{
  Type of output desired: \code{type.out = "measures"} returns an array 
  containing classification performance measures for all replications while 
  \code{type.out = "descriptives"} returns the list of descriptive statistics 
  calculated across all replications for each performance measure. Both 
  options also provide the estimated training weights and classification 
  weights. Defaults to \code{type.out = "descriptives"}.
}
\item{foldid}{
  List containing, for each replication, an integer vector. Should have length 
  equal to 'nrep'. Each list element contains fold IDs for k-fold 
  cross-validation. If not provided, fold IDs are generated randomly for the 
  number of folds \code{nfolds}.
}
\item{prior}{
  Prior probabilities of class membership. If specified, the probabilities 
  should be in the order of the factor levels of input \code{y}. If unspecified, 
  the observed class proportions for input \code{y} are used. Based on 
  \code{prior}, inverse probability weights are calculated to account for class 
  imbalance. Note that RF and RDA ignore \code{prior} and use uniform priors 
  to handle imbalance.
}
\item{cmode}{
  Integer value of 1, 2, or 3 (or 4 if \code{x} is a four-way array) specifying 
  the mode whose component weights will be predictors for classification. 
  Defaults to the last mode of the input array (i.e., defaults to 3 for 
  a three-way array, and to 4 for a four-way array). 
  If \code{model = "parafac2"}, the last mode will be used. 
  If \code{model = "pca"}, and if input \code{x} is a matrix, cmode can be 1 or
  2; if not provided, defaults to 1. However, if \code{model = "pca"}, and if 
  input \code{x} is a 3-way or 4-way array, \code{cmode} must be the last mode 
  when supplied.
}
\item{seeds}{
  Random seeds to be associated with each replication. Default is 
  \code{seeds = 1:nrep}.
}
\item{plot.out}{
  Logical indicating whether to output one or more box plots of classification 
  performance measures that are plotted across classification methods and 
  number of components.
}
\item{plot.measures}{
  Character vector containing values that specify for plotting one or more of 
  11 possible classification performance measures. Only relevant when 
  \code{plot.out = TRUE}. Should contain one or more of the following 
  labels: \code{c("err", "acc", "tpr", "fpr", "tnr", "fnr", "ppv", "npv", 
  "fdr", "fom", "fs")}. A box plot will be created for each measure that is 
  specified, summarizing output across replications. Note that additional 
  information about each label is available in the Details section of the help 
  file for function \code{cpm}. If NULL, defaults to classification accuracy.
}
\item{parallel}{
  Logical indicating if parallel computing should be implemented. If TRUE, the 
  package \bold{parallel} is used for parallel computing. For all classification 
  methods except penalized logistic regression, the \bold{doParallel} package 
  is used as a wrapper. Defaults to FALSE, which implements sequential 
  computing.
}
\item{cl}{
  Cluster for parallel computing, which is used when \code{parallel = TRUE}. 
  Note that if \code{parallel = TRUE} and \code{cl = NULL}, then the cluster 
  is defined as \code{makeCluster(detectCores())}.
}
\item{verbose}{
  If TRUE, progress is printed.
}
\item{compscale}{
  Logical indicating whether to scale each column of the estimated 
  classification component weights matrix (i.e., the features/predictors). If
  \code{TRUE}, each column is scaled to have mean zero and unit variance. If 
  \code{FALSE}, no scaling is performed.
}
\item{pcarot}{
  Character indicating whether to apply a varimax rotation or leave PCA loadings
  unrotated when \code{model} is set to \code{pca}. Ignored when \code{model} is
  not \code{pca}. Defaults to \code{"unrotated"} if not specified.
}
\item{...}{
  Additional arguments to be passed to function \code{parafac} for fitting a 
  Parafac model or function \code{parafac2} for fitting a Parafac2 model. 
  Example: can impose different constraints on different modes of the input 
  array using the argument \code{const}. See help file for function 
  \code{parafac} or for function \code{parafac2} for additional details.
}
}
\details{
Data are split into a training set and a testing set. After fitting a Parafac or 
Parafac2 model with the training set using package \bold{multiway} (see 
\code{parafac} or \code{parafac2} in \bold{multiway} for details), or after
fitting a PCA model using the singular value decomposition, the 
estimated classification mode weight matrix is passed to one or more 
classification methods. The methods include: penalized logistic regression 
(PLR); support vector machine (SVM); random forest (RF); feed-forward neural 
network (NN); regularized discriminant analysis (RDA); and gradient boosting 
machine (GBM).

Package \bold{glmnet} fits models for PLR. PLR tunes penalty parameter lambda 
while the elastic net parameter alpha is set by the user (see the help file 
for function \code{cv.glmnet} in package \bold{glmnet}). For SVM, package 
\bold{e1071} is used with a radial basis kernel. Penalty parameter cost and 
radial basis parameter gamma are used (see \code{svm} in package \bold{e1071}). 
For RF, package \bold{randomForest} is used and implements Breiman's random 
forest algorithm. The number of predictors sampled at each node split is set 
at the default of sqrt(R), where R is the number of Parafac or Parafac2 
components. Two tuning parameters allowed are ntree, the number of trees to be 
grown, and nodesize, the minimum size of terminal nodes (see 
\code{randomForest} in package \bold{randomForest}). For NN, package 
\bold{nnet} fits a single-hidden-layer, feed-forward neural network model. 
Penalty parameters size (i.e., number of hidden layer units) and decay (i.e., 
weight decay) are used (see \bold{nnet}). For RDA, package \bold{rda} fits a 
shrunken centroids regularized discriminant analysis model. Tuning parameters 
include rda.alpha, the shrinkage penalty for the within-class covariance matrix, 
and delta, the shrinkage penalty of class centroids towards the overall dataset 
centroid. For GBM, package \bold{xgboost} fits a gradient boosting machine 
model. Four tuning parameters are allowed: (1) eta, the learning rate; (2) 
max.depth, the maximum tree depth; (3) subsample, the fraction of samples per 
tree; and (4) nrounds, the number of boosting trees to build.

For all six methods, k-fold cross-validation is implemented to tune 
classification parameters where the number of folds is set by argument 
\code{nfolds}. Separately, the trained Parafac, Parafac2, or PCA model is used
to predict the classification mode's component weights using the testing set 
data. The predicted component weights and the optimized classification method 
are then used to predict class labels. Finally, classification performance 
measures are calculated. The process is repeated over a number of replications 
with different random splits of the input array and of the class labels at each 
replication.
}
\value{
  Returns an object of class \code{wrapcpfa} that either \code{(1)} contains a 
  three-way array with classification performance measures for each model and 
  for each replication, or \code{(2)} contains a list with matrices with 
  descriptive statistics for performance measures calculated across all 
  replications. Specify \code{type.out = "measures"} to output the array of 
  performance measures. Specify \code{type.out = "descriptives"} to output 
  descriptive statistics across replications. In addition, for either option, 
  the returned list object includes the following:
  \item{predweights}{
    List of predicted classification weights for each Parafac, Parafac2, or PCA
    model and for each replication.
  }
  \item{train.weights}{
    List of lists of training weights for each Parafac, Parafac2, or PCA model 
    and for each replication.
  }
  \item{opt.tune}{
    List of optimal tuning parameters for classification methods for each 
    Parafac or Parafac2 model and for each replication.
  }
  \item{mean.opt.tune}{
    Mean across all replications of optimal tuning parameters for 
    classification methods for each Parafac or Parafac2 model. 
  }
  \item{X}{
    Two-way matrix, or three-way or four-way data array or list used in argument 
    \code{x}. If \code{x} was a three-way or four-way array, and if \code{model}
    was \code{pca}, returns the flattened two-way matrix.
  }
  \item{y}{
    Vector of class labels used in input argument \code{y}.
  }
  \item{z}{
    Matrix of additional features used in input argument \code{z}.
  }
  \item{nfac}{
    Number of components used to fit each Parafac, Parafac2, or PCA model.
  }
  \item{model}{
    Character designating the component model that was used, including:
    \code{model = "parafac"} for the Parafac model, \code{model = "parafac2"} 
    for the Parafac2 model, or \code{model = "pca"} for the PCA model.
  }
  \item{method}{
    Classification methods used.
  }
  \item{const}{
    Constraints used in fitting the Parafac, Parafac2, or PCA model. When 
    \code{model} was \code{pca}, contains the value used in input \code{pcarot}
    to indicate whether a rotation was applied to the solution.
  }
  \item{cmode}{
    Integer value used to specify the mode whose component weights were 
    predictors for classification. 
  }
  \item{family}{
    Character value used to specify binary classification 
    (\code{family = "binomial"}) or multiclass classification 
    (\code{family = "multinomial"}).
  }
  \item{lxdim}{
    Integer specifying the number of modes of the output \code{x}. Identical to 
    the number of modes of input \code{x}, except when input \code{x} was a 
    3-way or 4-way array and when \code{model} was \code{pca}. In this case,
    \code{lxdim} is 2.
  }
  \item{trainIDs}{
    List where each element contains the vector of integer IDs that specify the 
    rows/observations of the classification mode assigned to the train set for a
    given replication.
  }
  \item{testIDs}{
    List where each element contains the vector of integer IDs that specify the 
    rows/observations of the classification mode assigned to the test set for a
    given replication.
  }
  \item{flattened}{
    Logical indicating whether input \code{x} was flattened into a two-way 
    matrix. Only TRUE when \code{model} was \code{pca} and input \code{x} was
    a 3-way or 4-way array.
  }
}
\note{
For Parafac and Parafac2, if argument \code{cmode} is not null, input array 
\code{x} is reshaped with function \code{aperm} such that the \code{cmode} 
dimension of \code{x} is ordered last. Estimated mode A and B (and mode C for a 
four-way array) weights that are outputted as \code{Aweights} and 
\code{Bweights} (and \code{Cweights}) reflect this permutation. For example, if 
\code{x} is a four-way array and \code{cmode = 2}, the original input modes 1, 
2, 3, and 4 will correspond to output modes 1, 3, 4, 2. Here, output A = input 
1; B = 3, and C = 4 (i.e., the second mode specified by \code{cmode} has been 
moved to the D mode/last mode). For \code{model = "parafac2"}, classification 
mode is assumed to be the last mode (i.e., mode C for three-way array and mode D 
for four-way array).  For PCA, if argument \code{cmode} is not NULL, and if 
\code{x} is a 3-way or 4-way array, the array is reshaped with \code{aperm} such 
that the \code{cmode} dimension of \code{x} is ordered first. Then, the array is 
unfolded into a two-way matrix. If \code{x} is already input as a two-way 
matrix, the matrix is reshaped if \code{cmode} is 2, such that the matrix is 
transposed. Note that for PCA, \code{Aweights} contains the PCA model loadings. 

In addition, note that the following combination of arguments will give an 
error: \code{nfac = 1, family = "multinomial", method = "PLR"}. The issue 
arises from providing \code{glmnet::cv.glmnet} input \code{x} an input matrix 
that has a single column. The issue is resolved for \code{family = "binomial"} 
because a column of 0s is appended to the single column, but this solution 
does not appear to work for the multiclass case. As such, this combination of 
arguments is not currently allowed. Future updates are planned to resolve this 
issue.

Applications of this function to real datasets can be explored at the following
repository: \url{https://github.com/matthewasisgress/multiway-classification/}.
}
\author{
Matthew A. Asisgress <mattgress@protonmail.ch>
}
\references{
Breiman, L. (2001). Random forests. Machine Learning, 45(1), 5-32.

Chen, T., He, T., Benesty, M., Khotilovich, V., Tang, Y., Cho, H., Chen, K., 
Mitchell, R., Cano, I., Zhou, T., Li, M., Xie, J., Lin, M., Geng, Y., Li, Y., 
Yuan, J. (2025). xgboost: Extreme gradient boosting. R Package Version 1.7.9.1.

Cortes, C. and Vapnik, V. (1995). Support-vector networks. Machine Learning, 
20(3), 273-297.

Friedman, J. H. (2001). Greedy function approximation: a gradient boosting 
machine. Annals of Statistics, 29(5), 1189-1232.

Friedman, J. H. (1989). Regularized discriminant analysis. Journal of the 
American Statistical Association, 84(405), 165-175.

Friedman, J., Hastie, T., and Tibshirani, R. (2010). Regularization paths for 
generalized linear models via coordinate descent. Journal of Statistical 
Software, 33(1), 1-22.

Gaujoux, R. (2025). doRNG: Generic reproducible parallel backend for 'foreach' 
loops. R Package Version 1.8.6.2.

Guo, Y., Hastie, T., and Tibshirani, R. (2007). Regularized linear discriminant 
analysis and its application in microarrays. Biostatistics, 8(1), 86-100.

Guo, Y., Hastie, T., and Tibshirani, R. (2023). rda: Shrunken centroids 
regularized discriminant analysis. R Package Version 1.2-1.

Harshman, R. (1970). Foundations of the PARAFAC procedure: Models and 
conditions for an "explanatory" multimodal factor analysis. UCLA Working 
Papers in Phonetics, 16, 1-84.

Harshman, R. (1972). PARAFAC2: Mathematical and technical notes. UCLA Working 
Papers in Phonetics, 22, 30-44.

Harshman, R. and Lundy, M. (1994). PARAFAC: Parallel factor analysis. 
Computational Statistics and Data Analysis, 18, 39-72.

Helwig, N. (2017). Estimating latent trends in multivariate longitudinal data 
via Parafac2 with functional and structural constraints. Biometrical Journal, 
59(4), 783-803.

Helwig, N. (2025). multiway: Component models for multi-way data. R Package 
Version 1.0-7.

Liaw, A. and Wiener, M. (2002). Classification and regression by randomForest. 
R News 2(3), 18--22.

Meyer, D., Dimitriadou, E., Hornik, K., Weingessel, A., and Leisch, F. (2024). 
e1071: Misc functions of the Department of Statistics, Probability Theory 
Group (Formerly: E1071), TU Wien. R Package Version 1.7-16.

Ripley, B. (1994). Neural networks and related methods for classification. 
Journal of the Royal Statistical Society: Series B (Methodological), 56(3), 
409-437.

Venables, W. and Ripley, B. (2002). Modern applied statistics with S. Fourth 
Edition. Springer, New York. ISBN 0-387-95457-0.

Zou, H. and Hastie, T. (2005). Regularization and variable selection via the 
elastic net. Journal of the Royal Statistical Society: Series B (Statistical 
Methodology), 67(2), 301-320.
}
\examples{
########## Parafac2 example with 4-way array and multiclass response ##########
\dontrun{
# set seed
set.seed(5)

# define list of arguments specifying distributions for A and G weights
techlist <- list(distA = list(dname = "poisson", 
                              lambda = 3),                 # for A weights
                 distG = list(dname = "gamma", shape = 2, 
                              scale = 4))                  # for G weights

# define target correlation matrix for columns of D mode weights matrix
cormat <- matrix(c(1, .6, .6, .6, 1, .6, .6, .6, 1), nrow = 3, ncol = 3)

# simulate a four-way ragged array connected to a response
data <- simcpfa(arraydim = c(10, 11, 12, 100), model = "parafac2", nfac = 3, 
                nclass = 3, nreps = 1e2, onreps = 10, corresp = rep(.6, 3), 
                meanpred = rep(2, 3), modes = 4, corrpred = cormat,
                technical = techlist, smethod = "eigende")

# initialize
alpha <- seq(0, 1, length = 20)
gamma <- c(0, 1)
cost <- c(0.1, 5)
ntree <- c(200, 300)
nodesize <- c(1, 2)
size <- c(1, 2)
decay <- c(0, 1)
rda.alpha <- seq(0.1, 0.9, length = 2)
delta <- c(0.1, 2)
eta <- c(0.3, 0.7)
max.depth <- c(1, 2)
subsample <- c(0.75)
nrounds <- c(100)
method <- c("PLR", "SVM", "RF", "NN", "RDA", "GBM")
family <- "multinomial"
parameters <- list(alpha = alpha, gamma = gamma, cost = cost, ntree = ntree,
                   nodesize = nodesize, size = size, decay = decay, 
                   rda.alpha = rda.alpha, delta = delta, eta = eta,
                   max.depth = max.depth, subsample = subsample,
                   nrounds = nrounds)
model <- "parafac2"
nfolds <- 10
nstart <- 10

# constrain first mode weights to be orthogonal, fourth mode to be nonnegative
const <- c("orthog", "uncons", "uncons", "nonneg")

# fit Parafac2 model and use fourth mode weights to tune classification
# methods, to predict class labels, and to return classification 
# performance measures pooled across multiple train-test splits
output <- cpfa(x = data$X, y = data$y, model = model, nfac = 3, 
               nrep = 5, ratio = 0.9, nfolds = nfolds, method = method, 
               family = family, parameters = parameters, 
               type.out = "descriptives", seeds = NULL, plot.out = TRUE, 
               parallel = FALSE, const = const, nstart = nstart)

# print performance measure means across train-test splits
output$descriptive$mean
}
}

\name{simcpfa}
\alias{simcpfa}
\title{
Simulate Data for Classification with Parallel Factor Analysis
}
\description{
Simulates a two-way matrix, three-way array, or four-way array; and
simulates a set of class labels that are related to the simulated matrix or 
array through one mode of that matrix or array. Data matrix or array is 
simulated using one of the following component models without constraints: 
Parafac, Parafac2, or PCA. Weights for mode weight matrices can be drawn from 12 
common probability distributions. Alternatively, custom weights can be provided 
for any mode.
}
\usage{
simcpfa(arraydim = NULL, model = "parafac", nfac = 2, nclass = 2, 
        smethod = "logistic", nreps = 100, onreps = 10, props = NULL,
        corresp = NULL, meanpred = NULL, modes = 3, corrpred = NULL, 
        pf2num = NULL, Amat = NULL, Bmat = NULL, Cmat = NULL, Dmat = NULL, 
        Gmat = NULL, Emat = NULL, technical = list())
}
\arguments{
\item{arraydim}{
  Numeric vector containing the number of dimensions for each mode of the 
  simulated data matrix or array. Must contain integers greater than or equal 
  to 2. Defaults to \code{c(10, 100)} for \code{modes = 2}; 
  to \code{c(10, 10, 100)} for \code{modes = 3}; and to 
  \code{c(10, 10, 10, 100)} for \code{modes = 4}.
}
\item{model}{
  Character specifying the model to use for simulating the data array. Must be 
  'parafac', 'parafac2', or 'pca'.
}
\item{nfac}{
  Number of components in the component model. Must be an integer greater than 
  or equal to 1. 
}
\item{nclass}{
  Number of classes in simulated class labels. Must be an integer greater than 
  or equal to 2.
}
\item{smethod}{
  Simulation method, either "logistic" or "eigende". The former implements an 
  iterative Monte Carlo rejection sampling method based on the generalized
  linear model (slower). The latter uses a multivariate normal
  distribution and constructs a joint covariance matrix, employing a 
  eigendecomposition and assuming class labels arise from discretizing 
  continuous latent variables (faster).
}
\item{nreps}{
  Number of replications for simulating class labels for a given set of 
  classification mode component weights. 
}
\item{onreps}{
  Number of replications for simulating a set of classification mode component 
  weights. 
}
\item{props}{
  Target proportions for simulated class labels in output 'y'. Defaults to 
  equal proportions across classes.
}
\item{corresp}{
  Numeric vector of target correlations between simulated class labels and 
  columns of the classification mode component weight matrix. Must have length 
  equal to 'nfac'. Defaults to 0.5 for all components.
}
\item{meanpred}{
  Numeric vector of means used to generate the classification mode component 
  weights. Must be real numbers. Operates as the mean vector parameterizing a 
  multivariate normal distribution from which classification mode component 
  weights are generated. Length must be equal to input \code{nfac}. Defaults to
  a vector of zeros.
}
\item{modes}{
  Single integer of 2, 3, or 4, indicating whether to simulate a two-way matrix, 
  three-way array, or four-way array, respectively.
}
\item{corrpred}{
  A positive definite correlation matrix containing the target correlations for 
  the classification mode component weights. Must have number of rows and 
  columns equal to input 'nfac'. Operates as the covariance matrix 
  parameterizing a multivariate normal distribution from which classification 
  mode component weights are generated. Defaults to a correlation matrix with 1
  on the diagonal and 0.2 on the off-diagonals.
}
\item{pf2num}{
  When \code{model = 'parafac2'}, number of rows for each simulated matrix in 
  the list of matrices \code{Amat}. Replaces the first element of input 
  \code{arraydim} because, for the Parafac2 model, the number of rows in each 
  simulated matrix can vary. If not specified when \code{model = 'parafac2'}, 
  defaults to \code{rep(c((nfac + 1), (nfac + 2), (nfac + 3)), 
  length.out = arraydim[modes])}.
}
\item{Amat}{
  When \code{model = 'parafac'}, a matrix of A mode weights with number of rows 
  equal to the first element of input 'arraydim' and with number of columns 
  equal to input 'nfac'. When \code{model = 'parafac2'}, a list with length 
  equal to the last element of input 'arraydim', where each list element 
  contains a matrix with number of rows of at least 2 and with number 
  of columns equal to input 'nfac'. When provided, replaces a 
  simulated \code{Amat}. When \code{model = 'pca'}, a matrix of loadings with
  number of rows equal to the second element of input 'arraydim' and with number
  of columns equal to input 'nfac'.
}
\item{Bmat}{
  A matrix of B mode weights with number of rows equal to the second element of 
  input 'arraydim' and with number of columns equal to the input 'nfac'. When 
  provided, replaces a simulated \code{Bmat}. When \code{model = 'pca'}, a 
  matrix of scores with number of rows equal to the first element of input 
  'arraydim' and with number of columns equal to input 'nfac'. If provided when 
  \code{modes = 2}, \code{onreps} is reduced to one when \code{smethod} is 
  \code{logistic}. 
}
\item{Cmat}{
  A matrix of C mode weights with number of rows equal to the third element of 
  input 'arraydim' and with number of columns equal to the input 'nfac'. When 
  provided, replaces a simulated \code{Cmat} when \code{modes = 4}. When
  \code{modes = 3}, replaces the simulated classification mode weight matrix. If
  provided when \code{modes = 3}, \code{onreps} is reduced to one when 
  \code{smethod} is \code{logistic}. When \code{modes} is 2, this argument is 
  ignored.
}
\item{Dmat}{
  A matrix of D mode weights with number of rows equal to the fourth element of 
  input 'arraydim' and with number of columns equal to the input 'nfac'. When
  \code{modes = 4}, replaces the simulated classification mode weight matrix.
  When \code{modes} is 2 or 3, this argument is ignored. If provided when 
  \code{modes = 4}, \code{onreps} is reduced to one when \code{smethod} is 
  \code{logistic}. 
}
\item{Gmat}{
  When \code{model = 'parafac2'}, a matrix of G mode weights with number of rows 
  equal to input 'nfac' and with number of columns equal to input 'nfac'. When 
  provided, replaces a simulated \code{Gmat}.
}
\item{Emat}{
  When \code{model = 'parafac'}, a 3-way or 4-way array containing noise to be 
  added to the corresponding elements in the simulated data array. Error array 
  dimensions must be equal to the values contained in \code{arraydim}. When
  \code{model = 'parafac2'}, a list containing either matrices 
  (i.e., when \code{modes = 3}) or three-way arrays (i.e., when 
  \code{modes = 4}) whose elements contain noise to be added to corresponding 
  elements in the simulated data array. When provided, replaces a simulated
  \code{Emat}. When \code{model = 'pca'}, a matrix whose elements contain noise
  to be added to corresponding elements in the simulated data matrix. When
  provided, replaces a simulated \code{Emat}.
}
\item{technical}{
  List containing arguments related to distributions from which to simulate 
  data. When specified, must contain one or more of the following:
  \describe{
\item{distA}{
  List containing arguments specifying the distribution from which deviates 
  are drawn for A mode weights contained in \code{Amat}. Defaults to standard 
  normal distribution when not specified. See Details section for additional 
  information on acceptable arguments.
}
\item{distB}{
  List containing arguments specifying the distribution from which deviates 
  are drawn for B mode weights contained in \code{Bmat}. Defaults to standard 
  normal distribution when not specified. See Details section for additional 
  information on acceptable arguments. Ignored if \code{model = 'pca'}.
}
\item{distC}{
  For when \code{modes = '4'}, list containing arguments specifying the 
  distribution from which deviates are drawn for C mode weights contained in 
  \code{Cmat}. Defaults to standard normal distribution when not specified. 
  See Details section for additional information on acceptable arguments. 
  Ignored when \code{modes = 3}.
}
\item{distG}{
  For when \code{model = 'parafac2'}, list containing arguments specifying the 
  distribution from which deviates are drawn for G weights contained 
  in \code{Gmat}. Defaults to standard normal distribution when not specified. 
  See Details section for additional information on acceptable arguments.
}
\item{distE}{
  List containing arguments specifying the distribution from which deviates 
  are drawn for error contained in \code{Emat}. Defaults to standard 
  normal distribution when not specified. See Details section for additional 
  information on acceptable arguments.
}
}
}
}
\details{
  By selecting \code{smethod = "logistic"}, the data array simulation consists 
  of two steps. First, a Monte Carlo simulation is conducted to simulate class 
  labels using a binomial logistic (i.e., in the binary case) or multinomial 
  logistic (i.e., in the multiclass case) regression model. Specifically, 
  columns of the classification mode weights matrix (e.g., \code{Cmat} when 
  \code{modes = 3}) are generated from a multivariate normal distribution with 
  mean vector \code{meanpred} and with covariance matrix \code{corrpred}. Values 
  are then drawn randomly from a uniform or a normal distribution and serve as 
  beta coefficients. A linear combination of these beta coefficients and the 
  generated classification weights produces a linear systematic part, which is 
  passed through the logistic function (i.e., the sigmoid) in the binary case or 
  through the softmax function in the multiclass case. Resulting probabilities 
  are used to assign class labels. The simulation repeats classification weights 
  generation \code{onreps} times and repeats class label generation, within 
  each \code{onreps} iteration, a total of \code{nreps} times. The generated 
  class labels that correlate best with the generated classification weights 
  (i.e., with correlations closest to \code{corresp}) are retained as the final 
  class labels with corresponding final classification weights. An adaptive 
  sampling technique is used during the simulation such that optimal beta 
  coefficients from previous iterations are used to parameterize a normal 
  distribution, from which new coefficients are drawn in subsequent iterations. 
  Note that, if any simulation replicate produces a set of class labels where 
  all labels are the same (i.e., have no variance), that replicate is discarded.
  Note also that \code{onreps} is ignored when the classification mode weight 
  matrix (i.e., \code{Bmat} when \code{modes = 2}, \code{Cmat} when 
  \code{modes = 3}, or \code{Dmat} when \code{modes = 4}) is provided; in this 
  case, class labels are simulated with respect to the provided classification 
  mode weight matrix.
  
  Second, depending on the chosen model (i.e., Parafac, Parafac2, or PCA) 
  specified via \code{model}, and depending on the number of modes specified 
  via \code{modes}, component matrices are randomly generated for each mode 
  of the data matrix or array. A data matrix or array is then constructed using 
  a Parafac, Parafac2, or PCA structure from these weight matrices, including 
  the generated classification mode weight matrix (i.e., \code{Bmat}, 
  \code{Cmat}, or \code{Dmat}) from the first step. Alternatively, weight 
  matrices can be provided to override random generation for any weight matrix 
  with the exception of the classification mode. When provided, weight matrices 
  are used to form the final data matrix or array. Finally, random noise is 
  added to each value in the matrix or array. The resulting output is a 
  synthetic data matrix or array paired, through one mode of that matrix or 
  array, with a simulated binary or multiclass response.
  
  Alternatively, by selecting \code{smethod = "eigende"}, the function 
  simulates component weights and a latent response variable simultaneously 
  from a joint multivariate normal distribution using an eigendecomposition. 
  The covariance structure is defined by \code{corrpred} and by a corrected 
  version of \code{corresp} that accounts for the attenuation in correlation 
  caused by discretizing the latent response. This continuous latent response 
  vector is then discretized into class labels using quantile cuts defined by 
  the cumulative sum of \code{props}. This method offers an efficient, 
  non-iterative alternative that satisfies the target covariance structure 
  without rejection sampling.
  
  The \code{technical} argument controls the probability distributions used to 
  simulate weights for different modes. Currently, \code{technical} is highly 
  structured. In particular, \code{technical} must be provided as a named list 
  whose elements must be one of 'distA', 'distB', 'distC', 'distG', or 'distE', 
  with the last letter of each name designating a mode or, in the case of 
  'distE', designating error. Each element provided must itself be a list where 
  the first inner list element is named 'dname', specifying the distribution to 
  be used to generate weights for a given mode or for error. There are 12 
  'dname' options: 'normal', 'uniform', 'gamma', 'beta', 'binomial', 'poisson', 
  'exponential', 'geometric', 'negbinomial', 'hypergeo', 'lognormal', and 
  'cauchy'. Additional arguments can be added to each inner list to parameterize 
  the probability distribution being used. These arguments can be one of the 
  following, for each distribution allowed: 
  
  For \code{dname = 'normal'}, allowed arguments are \code{mean} or 
  \code{sd} (i.e., function \code{rnorm} is called).
  
  For \code{dname = 'uniform'}, allowed arguments are \code{min} or 
  \code{max} (i.e., function \code{runif} is called).

  For \code{dname = 'gamma'}, allowed arguments are \code{shape} or 
  \code{scale} (i.e., function \code{rgamma} is called).
  
  For \code{dname = 'beta'}, allowed arguments are \code{shape1} or 
  \code{shape2} (i.e., function \code{rbeta} is called).

  For \code{dname = 'binomial'}, allowed arguments are \code{size} or 
  \code{prob} (i.e., function \code{rbinom} is called).

  For \code{dname = 'poisson'}, allowed argument is \code{lambda} (i.e., 
  function \code{rpois} is called).

  For \code{dname = 'exponential'}, allowed argument is \code{rate} (i.e., 
  function \code{rexp} is called).
  
  For \code{dname = 'geometric'}, allowed argument is \code{prob} (i.e., 
  function \code{rgeom} is called).
  
  For \code{dname = 'negbinomial'}, allowed arguments are \code{size} or 
  \code{prob} (i.e., function \code{rnbinom} is called).

  For \code{dname = 'hypergeo'}, allowed arguments are \code{m}, \code{n}, or 
  \code{k} (i.e., function \code{rhyper} is called).

  For \code{dname = 'lognormal'}, allowed arguments are \code{meanlog} or 
  \code{sdlog} (i.e., function \code{rlnorm} is called).

  For \code{dname = 'cauchy'}, allowed arguments are \code{location} or 
  \code{scale} (i.e., function \code{rcauchy} is called).

  Note that if a weight matrix and technical information are both provided 
  for a given mode (or for error), the weight matrix is used while technical 
  information is ignored. See Examples below for an example of how to set up 
  \code{technical}.
}
\value{
  \item{X}{
    Simulated data matrix or array with dimensions specified by \code{arraydim} 
    and, when \code{model = 'parafac2'}, also by \code{pf2num}. When 
    \code{model = 'parafac'}, \code{X} is an object of class 'array'. When 
    \code{model = 'parafac2'}, \code{X} is an object of class 'list'. When 
    \code{model = 'pca'}, \code{X} is an object of class 'matrix'.
  }
  \item{y}{
    Simulated class labels provided as an object of class 'factor'. When 
    \code{model = 'parafac'} or \code{model = 'parafac2'}, the number 
    of labels is equal to the last element of \code{arraydim}. When 
    \code{model = 'pca'}, the number of labels is equal to the first element
    of \code{arraydim}.
  }
  \item{model}{
    Character value indicating the component model that was used to simulate the 
    data matrix or array.
  }
  \item{Amat}{
    Simulated A mode weights. When \code{model = 'parafac'}, output is a matrix
    with number of rows equal to the first element of \code{arraydim} and with 
    number of columns equal to the number of components \code{nfac}. When 
    \code{model = 'parafac2'}, output is a list of matrices with number of rows
    for each matrix equal to those specified by \code{pf2num} and with number of
    columns equal to \code{nfac}. When \code{model = 'pca'}, output is a matrix
    with number of rows equal to the second element of \code{arraydim}. If 
    \code{Amat} was supplied, returns original \code{Amat} instead of a 
    simulated \code{Amat}.
  }
  \item{Bmat}{
    Simulated B mode weights provided as a matrix with number of rows equal to 
    the second element of \code{arraydim} and with number of columns equal to 
    the number of components \code{nfac}. When \code{model = 'pca'}, output is a 
    matrix with number of rows equal to the first element of \code{arraydim}. If 
    \code{Bmat} was supplied, returns original \code{Bmat} instead of a 
    simulated \code{Bmat}.
  }
   \item{Cmat}{
    Simulated C mode weights provided as a matrix with number of rows equal to 
    the third element of \code{arraydim} and with number of columns equal to 
    the number of components \code{nfac}. If \code{Cmat} was supplied when
    \code{modes = 4}, returns original \code{Cmat} instead of a simulated 
    \code{Cmat}. Not provided when \code{modes = 2}.
  }
   \item{Dmat}{
    Simulated D mode weights provided when \code{modes = 4}. Output is a matrix 
    with number of rows equal to the fourth element of \code{arraydim} and with 
    number of columns equal to the number of components \code{nfac}. Not 
    provided when \code{modes = 2} or when \code{modes = 3}.
  }
  \item{Gmat}{
    Simulated G weights provided when \code{model = 'parafac2'}. Provided as 
    a matrix with number of rows and columns equal to \code{nfac}. If 
    \code{Gmat} was supplied, returns original \code{Gmat} instead of a 
    simulated \code{Gmat}.
  }
  \item{Emat}{
    Error matrix, array, or list containing noise added to corresponding 
    elements of simulated data matrix or array. Output has dimensions specified 
    by \code{arraydim} and, when \code{model = 'parafac2'}, also by 
    \code{pf2num}. When \code{model = 'parafac'}, \code{Emat} is an object of 
    class 'array'. When \code{model = 'parafac2'}, \code{Emat} is an object of 
    class 'list'. When \code{model = 'pca'}, \code{Emat} is an object of 
    class 'matrix'. 
  }
}
\author{
Matthew Asisgress <mattgress@protonmail.ch>
}
\references{
See help file for function \code{cpfa} for a list of references.
}
\examples{
########## Parafac2 example with 4-way array and multiclass response ##########
\dontrun{
# set seed for reproducibility
set.seed(5)

# define list of arguments specifying distributions for A and G weights
techlist <- list(distA = list(dname = "poisson", 
                              lambda = 3),                 # for A weights
                 distG = list(dname = "gamma", shape = 2, 
                              scale = 4))                  # for G weights

# define target correlation matrix for columns of D mode weights matrix
cormat <- matrix(c(1, .6, .6, .6, 1, .6, .6, .6, 1), nrow = 3, ncol = 3)

# simulate a four-way ragged array connected to a response
data <- simcpfa(arraydim = c(10, 11, 12, 100), model = "parafac2", nfac = 3, 
                nclass = 3, nreps = 1e2, onreps = 10, corresp = rep(.6, 3), 
                meanpred = rep(2, 3), modes = 4, corrpred = cormat,
                technical = techlist, smethod = "eigende")
                
# examine correlations among columns of classification mode matrix Dmat
cor(data$Dmat)

# examine correlations between columns of classification mode matrix Dmat and
# simulated class labels
yproc <- as.numeric(data$y) - 1
cor(data$Dmat, yproc)
}
}

\name{cpm.all}
\alias{cpm.all}
\title{
Wrapper for Calculating Classification Performance Measures
}
\description{
Applies function \code{cpm} to multiple sets of class labels. Each set of class 
labels is evaluated against the same set of predicted labels. Works with output 
from function \code{predict.tunecpfa} and calculates classification performance 
measures for multiple classifiers or numbers of components.
}
\usage{
cpm.all(x, y, ...)
}
\arguments{
\item{x}{
  A data frame where each column contains a set of class labels of class 
  numeric, factor, or integer. If a set is of class factor, that set is 
  converted to class integer in the order of factor levels with integers 
  beginning at 0 (i.e., for binary classification, factor levels become 0 and 
  1; for multiclass, levels become 0, 1, 2, etc.). 
}
\item{y}{
  Class labels of class numeric.
}
\item{...}{
  Additional arguments passed to function \code{cpm} for calculating 
  classification performance measures.
}
}
\details{
Wrapper function that applies function \code{cpm} to multiple sets of class 
labels and one other set of labels. See help file for function \code{cpm} for 
additional details.
}
\value{
Returns a list with the following two elements: 
\item{cm.list}{
  A list of confusion matrices, denoted \code{cm}, where each confusion matrix 
  is associated with one comparison.
}
\item{cpms}{
  A data frame containing classification performance measures where each row 
  contains measures for one comparison.
}
}
\references{
Sokolova, M. and Lapalme, G. (2009). A systematic analysis of performance 
measures for classification tasks. Information Processing and Management, 
45(4), 427-437.
}
\author{
Matthew Asisgress <mattgress@protonmail.ch>
}
\examples{
########## Parafac example with 3-way array and binary response ##########
\dontrun{
# set seed and simulate a three-way array related to a binary response
set.seed(5)

# define list of arguments specifying distributions for A and G weights
techlist <- list(distA = list(dname = "poisson", 
                              lambda = 3),                 # for A weights
                 distG = list(dname = "gamma", shape = 2, 
                              scale = 4))                  # for G weights

# define target correlation matrix for columns of C mode weights matrix
cormat <- matrix(c(1, .6, .6, .6, 1, .6, .6, .6, 1), nrow = 3, ncol = 3)

# simulate a three-way array connected to a response
data <- simcpfa(arraydim = c(11, 12, 100), model = "parafac", nfac = 3, 
                nclass = 2, nreps = 1e2, onreps = 10, corresp = rep(.6, 3), 
                meanpred = rep(2, 3), modes = 3, corrpred = cormat,
                technical = techlist, smethod = "eigende")

# initialize
alpha <- seq(0, 1, length = 2)
gamma <- c(0, 0.01)
cost <- c(1, 2)
method <- c("PLR", "SVM")
family <- "binomial"
parameters <- list(alpha = alpha, gamma = gamma, cost = cost)
model <- "parafac"
nfolds <- 3
nstart <- 3

# constrain first mode weights to be orthogonal
const <- c("orthog", "uncons", "uncons")

# fit Parafac models and use third mode to tune classification methods
tune.object <- tunecpfa(x = data$X[, , 1:80], y = data$y[1:80], 
                        model = model, nfac = 3, nfolds = nfolds, 
                        method = method, family = family, 
                        parameters = parameters, parallel = FALSE, 
                        const = const, nstart = nstart)
                    
# predict class labels
predict.labels <- predict(object = tune.object, newdata = data$X[, , 81:100], 
                          type = "response")
                        
# calculate performance measures for predicted class labels
yproc <- as.numeric(data$y[81:100]) - 1
evalmeasure <- cpm.all(x = predict.labels, y = yproc)

# print performance measures
evalmeasure
}
}
